#include <benchmark/benchmark.h>
#include "fhe_context.h"
using namespace fhe_deck;


std::vector<long>
test_calculator_boolean(FHEContext& ctx, uint8_t op = 0, uint16_t x = 0, uint16_t y = 0)
{
    Ciphertext ct_op0 = ctx.encrypt_public((op >> 0) & 1);
    Ciphertext ct_op1 = ctx.encrypt_public((op >> 1) & 1);
    Ciphertext ct_op2 = ctx.encrypt_public((op >> 2) & 1);
    Ciphertext ct_op3 = ctx.encrypt_public((op >> 3) & 1);
    Ciphertext ct_op4 = ctx.encrypt_public((op >> 4) & 1);
    Ciphertext ct_op5 = ctx.encrypt_public((op >> 5) & 1);
    Ciphertext ct_op6 = ctx.encrypt_public((op >> 6) & 1);
    Ciphertext ct_op7 = ctx.encrypt_public((op >> 7) & 1);
    Ciphertext ct_x0 = ctx.encrypt_public((x >> 0) & 1);
    Ciphertext ct_x1 = ctx.encrypt_public((x >> 1) & 1);
    Ciphertext ct_x2 = ctx.encrypt_public((x >> 2) & 1);
    Ciphertext ct_x3 = ctx.encrypt_public((x >> 3) & 1);
    Ciphertext ct_x4 = ctx.encrypt_public((x >> 4) & 1);
    Ciphertext ct_x5 = ctx.encrypt_public((x >> 5) & 1);
    Ciphertext ct_x6 = ctx.encrypt_public((x >> 6) & 1);
    Ciphertext ct_x7 = ctx.encrypt_public((x >> 7) & 1);
    Ciphertext ct_x8 = ctx.encrypt_public((x >> 8) & 1);
    Ciphertext ct_x9 = ctx.encrypt_public((x >> 9) & 1);
    Ciphertext ct_x10 = ctx.encrypt_public((x >> 10) & 1);
    Ciphertext ct_x11 = ctx.encrypt_public((x >> 11) & 1);
    Ciphertext ct_x12 = ctx.encrypt_public((x >> 12) & 1);
    Ciphertext ct_x13 = ctx.encrypt_public((x >> 13) & 1);
    Ciphertext ct_x14 = ctx.encrypt_public((x >> 14) & 1);
    Ciphertext ct_x15 = ctx.encrypt_public((x >> 15) & 1);
    Ciphertext ct_y0 = ctx.encrypt_public((y >> 0) & 1);
    Ciphertext ct_y1 = ctx.encrypt_public((y >> 1) & 1);
    Ciphertext ct_y2 = ctx.encrypt_public((y >> 2) & 1);
    Ciphertext ct_y3 = ctx.encrypt_public((y >> 3) & 1);
    Ciphertext ct_y4 = ctx.encrypt_public((y >> 4) & 1);
    Ciphertext ct_y5 = ctx.encrypt_public((y >> 5) & 1);
    Ciphertext ct_y6 = ctx.encrypt_public((y >> 6) & 1);
    Ciphertext ct_y7 = ctx.encrypt_public((y >> 7) & 1);
    Ciphertext ct_y8 = ctx.encrypt_public((y >> 8) & 1);
    Ciphertext ct_y9 = ctx.encrypt_public((y >> 9) & 1);
    Ciphertext ct_y10 = ctx.encrypt_public((y >> 10) & 1);
    Ciphertext ct_y11 = ctx.encrypt_public((y >> 11) & 1);
    Ciphertext ct_y12 = ctx.encrypt_public((y >> 12) & 1);
    Ciphertext ct_y13 = ctx.encrypt_public((y >> 13) & 1);
    Ciphertext ct_y14 = ctx.encrypt_public((y >> 14) & 1);
    Ciphertext ct_y15 = ctx.encrypt_public((y >> 15) & 1);

    auto fand2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 0;
            case 1:  return 0;
            case 2:  return 0;
            case 3:  return 1;
            default: assert(0);
        }
    };
    RotationPoly and2 = ctx.genrate_lut(fand2);

    auto fnand2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 1;
            case 1:  return 1;
            case 2:  return 1;
            case 3:  return 0;
            default: assert(0);
        }
    };
    RotationPoly nand2 = ctx.genrate_lut(fnand2);

    auto for2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 0;
            case 1:  return 1;
            case 2:  return 1;
            case 3:  return 1;
            default: assert(0);
        }
    };
    RotationPoly or2 = ctx.genrate_lut(for2);

    auto fnor2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 1;
            case 1:  return 0;
            case 2:  return 0;
            case 3:  return 0;
            default: assert(0);
        }
    };
    RotationPoly nor2 = ctx.genrate_lut(fnor2);

    auto fxor2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 0;
            case 1:  return 1;
            case 2:  return 1;
            case 3:  return 0;
            default: assert(0);
        }
    };
    RotationPoly xor2 = ctx.genrate_lut(fxor2);

    auto fxnor2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 1;
            case 1:  return 0;
            case 2:  return 0;
            case 3:  return 1;
            default: assert(0);
        }
    };
    RotationPoly xnor2 = ctx.genrate_lut(fxnor2);

    std::cerr << "\rLUT0   ";
    Ciphertext gin0 = 2 * ct_y3 + ct_x1;
    Ciphertext gout0 = ctx.eval_lut(&gin0, nand2);
    std::cerr << "\rLUT1   ";
    Ciphertext gin1 = 2 * ct_y3 + ct_x6;
    Ciphertext gout1 = ctx.eval_lut(&gin1, and2);
    std::cerr << "\rLUT2   ";
    Ciphertext gin2 = 2 * ct_y10 + ct_x4;
    Ciphertext gout2 = ctx.eval_lut(&gin2, nand2);
    std::cerr << "\rLUT3   ";
    Ciphertext gin3 = 2 * ct_y0 + ct_x2;
    Ciphertext gout3 = ctx.eval_lut(&gin3, and2);
    std::cerr << "\rLUT4   ";
    Ciphertext gin4 = 2 * ct_y0 + ct_x5;
    Ciphertext gout4 = ctx.eval_lut(&gin4, nand2);
    std::cerr << "\rLUT5   ";
    Ciphertext gin5 = 2 * ct_y0 + ct_x10;
    Ciphertext gout5 = ctx.eval_lut(&gin5, nand2);
    std::cerr << "\rLUT6   ";
    Ciphertext gin6 = 2 * (1 - ct_op2) + ct_op1;
    Ciphertext gout6 = ctx.eval_lut(&gin6, and2);
    std::cerr << "\rLUT7   ";
    Ciphertext gin7 = 2 * ct_y2 + ct_x6;
    Ciphertext gout7 = ctx.eval_lut(&gin7, and2);
    std::cerr << "\rINV8   ";
    Ciphertext gout8 = 1 - ct_x14;

    std::cerr << "\rLUT9   ";
    Ciphertext gin9 = 2 * ct_y3 + ct_x3;
    Ciphertext gout9 = ctx.eval_lut(&gin9, and2);
    std::cerr << "\rLUT10   ";
    Ciphertext gin10 = 2 * ct_y3 + ct_x9;
    Ciphertext gout10 = ctx.eval_lut(&gin10, and2);
    std::cerr << "\rLUT11   ";
    Ciphertext gin11 = 2 * ct_y6 + ct_x1;
    Ciphertext gout11 = ctx.eval_lut(&gin11, nand2);
    std::cerr << "\rLUT12   ";
    Ciphertext gin12 = 2 * ct_y13 + ct_x0;
    Ciphertext gout12 = ctx.eval_lut(&gin12, and2);
    std::cerr << "\rINV13   ";
    Ciphertext gout13 = 1 - ct_x4;

    std::cerr << "\rLUT14   ";
    Ciphertext gin14 = 2 * ct_y11 + ct_x0;
    Ciphertext gout14 = ctx.eval_lut(&gin14, and2);
    std::cerr << "\rLUT15   ";
    Ciphertext gin15 = 2 * ct_y0 + ct_x15;
    Ciphertext gout15 = ctx.eval_lut(&gin15, and2);
    std::cerr << "\rLUT16   ";
    Ciphertext gin16 = 2 * ct_y13 + ct_x1;
    Ciphertext gout16 = ctx.eval_lut(&gin16, and2);
    std::cerr << "\rLUT17   ";
    Ciphertext gin17 = 2 * ct_y5 + ct_x4;
    Ciphertext gout17 = ctx.eval_lut(&gin17, and2);
    std::cerr << "\rLUT18   ";
    Ciphertext gin18 = 2 * ct_y6 + ct_x6;
    Ciphertext gout18 = ctx.eval_lut(&gin18, and2);
    std::cerr << "\rLUT19   ";
    Ciphertext gin19 = 2 * ct_y0 + ct_x4;
    Ciphertext gout19 = ctx.eval_lut(&gin19, nand2);
    std::cerr << "\rLUT20   ";
    Ciphertext gin20 = 2 * ct_y1 + ct_x13;
    Ciphertext gout20 = ctx.eval_lut(&gin20, and2);
    std::cerr << "\rINV21   ";
    Ciphertext gout21 = 1 - ct_x13;

    std::cerr << "\rLUT22   ";
    Ciphertext gin22 = 2 * ct_y9 + ct_x6;
    Ciphertext gout22 = ctx.eval_lut(&gin22, and2);
    std::cerr << "\rLUT23   ";
    Ciphertext gin23 = 2 * ct_y9 + ct_x3;
    Ciphertext gout23 = ctx.eval_lut(&gin23, and2);
    std::cerr << "\rLUT24   ";
    Ciphertext gin24 = 2 * ct_y4 + ct_x6;
    Ciphertext gout24 = ctx.eval_lut(&gin24, and2);
    std::cerr << "\rLUT25   ";
    Ciphertext gin25 = 2 * ct_y5 + ct_x8;
    Ciphertext gout25 = ctx.eval_lut(&gin25, and2);
    std::cerr << "\rLUT26   ";
    Ciphertext gin26 = 2 * ct_y5 + ct_x9;
    Ciphertext gout26 = ctx.eval_lut(&gin26, and2);
    std::cerr << "\rLUT27   ";
    Ciphertext gin27 = 2 * ct_y7 + ct_x3;
    Ciphertext gout27 = ctx.eval_lut(&gin27, and2);
    std::cerr << "\rLUT28   ";
    Ciphertext gin28 = 2 * ct_y3 + ct_x7;
    Ciphertext gout28 = ctx.eval_lut(&gin28, and2);
    std::cerr << "\rLUT29   ";
    Ciphertext gin29 = 2 * ct_y9 + ct_x5;
    Ciphertext gout29 = ctx.eval_lut(&gin29, and2);
    std::cerr << "\rLUT30   ";
    Ciphertext gin30 = 2 * ct_y0 + ct_x8;
    Ciphertext gout30 = ctx.eval_lut(&gin30, nand2);
    std::cerr << "\rLUT31   ";
    Ciphertext gin31 = 2 * ct_y2 + ct_x7;
    Ciphertext gout31 = ctx.eval_lut(&gin31, and2);
    std::cerr << "\rLUT32   ";
    Ciphertext gin32 = 2 * ct_y7 + ct_x6;
    Ciphertext gout32 = ctx.eval_lut(&gin32, and2);
    std::cerr << "\rLUT33   ";
    Ciphertext gin33 = 2 * ct_y0 + ct_x7;
    Ciphertext gout33 = ctx.eval_lut(&gin33, nand2);
    std::cerr << "\rLUT34   ";
    Ciphertext gin34 = 2 * ct_y5 + ct_x1;
    Ciphertext gout34 = ctx.eval_lut(&gin34, and2);
    std::cerr << "\rLUT35   ";
    Ciphertext gin35 = 2 * ct_y2 + ct_x11;
    Ciphertext gout35 = ctx.eval_lut(&gin35, and2);
    std::cerr << "\rLUT36   ";
    Ciphertext gin36 = 2 * ct_y6 + ct_x9;
    Ciphertext gout36 = ctx.eval_lut(&gin36, and2);
    std::cerr << "\rLUT37   ";
    Ciphertext gin37 = 2 * ct_y0 + ct_x1;
    Ciphertext gout37 = ctx.eval_lut(&gin37, and2);
    std::cerr << "\rLUT38   ";
    Ciphertext gin38 = 2 * ct_y1 + ct_x4;
    Ciphertext gout38 = ctx.eval_lut(&gin38, and2);
    std::cerr << "\rLUT39   ";
    Ciphertext gin39 = 2 * ct_y1 + ct_x5;
    Ciphertext gout39 = ctx.eval_lut(&gin39, and2);
    std::cerr << "\rLUT40   ";
    Ciphertext gin40 = 2 * ct_y1 + ct_x3;
    Ciphertext gout40 = ctx.eval_lut(&gin40, and2);
    std::cerr << "\rLUT41   ";
    Ciphertext gin41 = 2 * ct_y3 + ct_x5;
    Ciphertext gout41 = ctx.eval_lut(&gin41, and2);
    std::cerr << "\rLUT42   ";
    Ciphertext gin42 = 2 * ct_y2 + ct_x10;
    Ciphertext gout42 = ctx.eval_lut(&gin42, and2);
    std::cerr << "\rLUT43   ";
    Ciphertext gin43 = 2 * ct_y0 + ct_x9;
    Ciphertext gout43 = ctx.eval_lut(&gin43, nand2);
    std::cerr << "\rLUT44   ";
    Ciphertext gin44 = 2 * ct_y1 + ct_y0;
    Ciphertext gout44 = ctx.eval_lut(&gin44, nor2);
    std::cerr << "\rLUT45   ";
    Ciphertext gin45 = 2 * ct_y6 + ct_x3;
    Ciphertext gout45 = ctx.eval_lut(&gin45, and2);
    std::cerr << "\rLUT46   ";
    Ciphertext gin46 = 2 * ct_y10 + ct_x5;
    Ciphertext gout46 = ctx.eval_lut(&gin46, and2);
    std::cerr << "\rLUT47   ";
    Ciphertext gin47 = 2 * ct_y0 + ct_x14;
    Ciphertext gout47 = ctx.eval_lut(&gin47, and2);
    std::cerr << "\rLUT48   ";
    Ciphertext gin48 = 2 * ct_y11 + ct_x1;
    Ciphertext gout48 = ctx.eval_lut(&gin48, and2);
    std::cerr << "\rLUT49   ";
    Ciphertext gin49 = 2 * ct_y6 + ct_x4;
    Ciphertext gout49 = ctx.eval_lut(&gin49, and2);
    std::cerr << "\rLUT50   ";
    Ciphertext gin50 = 2 * ct_y3 + ct_x10;
    Ciphertext gout50 = ctx.eval_lut(&gin50, and2);
    std::cerr << "\rLUT51   ";
    Ciphertext gin51 = 2 * ct_y12 + ct_x3;
    Ciphertext gout51 = ctx.eval_lut(&gin51, and2);
    std::cerr << "\rINV52   ";
    Ciphertext gout52 = 1 - ct_y2;

    std::cerr << "\rLUT53   ";
    Ciphertext gin53 = 2 * ct_y7 + ct_x0;
    Ciphertext gout53 = ctx.eval_lut(&gin53, and2);
    std::cerr << "\rLUT54   ";
    Ciphertext gin54 = 2 * ct_y12 + ct_x0;
    Ciphertext gout54 = ctx.eval_lut(&gin54, and2);
    std::cerr << "\rLUT55   ";
    Ciphertext gin55 = 2 * ct_y1 + ct_x9;
    Ciphertext gout55 = ctx.eval_lut(&gin55, and2);
    std::cerr << "\rLUT56   ";
    Ciphertext gin56 = 2 * ct_y5 + ct_x5;
    Ciphertext gout56 = ctx.eval_lut(&gin56, and2);
    std::cerr << "\rLUT57   ";
    Ciphertext gin57 = 2 * ct_y5 + ct_x6;
    Ciphertext gout57 = ctx.eval_lut(&gin57, and2);
    std::cerr << "\rLUT58   ";
    Ciphertext gin58 = 2 * ct_y7 + ct_x4;
    Ciphertext gout58 = ctx.eval_lut(&gin58, and2);
    std::cerr << "\rLUT59   ";
    Ciphertext gin59 = 2 * ct_op6 + ct_op7;
    Ciphertext gout59 = ctx.eval_lut(&gin59, nor2);
    std::cerr << "\rLUT60   ";
    Ciphertext gin60 = 2 * ct_y4 + ct_x4;
    Ciphertext gout60 = ctx.eval_lut(&gin60, and2);
    std::cerr << "\rLUT61   ";
    Ciphertext gin61 = 2 * ct_y6 + ct_x7;
    Ciphertext gout61 = ctx.eval_lut(&gin61, and2);
    std::cerr << "\rINV62   ";
    Ciphertext gout62 = 1 - ct_y1;

    std::cerr << "\rLUT63   ";
    Ciphertext gin63 = 2 * ct_y0 + ct_x11;
    Ciphertext gout63 = ctx.eval_lut(&gin63, nand2);
    std::cerr << "\rLUT64   ";
    Ciphertext gin64 = 2 * ct_y5 + ct_x10;
    Ciphertext gout64 = ctx.eval_lut(&gin64, and2);
    std::cerr << "\rLUT65   ";
    Ciphertext gin65 = 2 * ct_y15 + ct_x15;
    Ciphertext gout65 = ctx.eval_lut(&gin65, xor2);
    std::cerr << "\rLUT66   ";
    Ciphertext gin66 = 2 * (1 - ct_op4) + ct_op5;
    Ciphertext gout66 = ctx.eval_lut(&gin66, and2);
    std::cerr << "\rLUT67   ";
    Ciphertext gin67 = 2 * ct_y9 + ct_x2;
    Ciphertext gout67 = ctx.eval_lut(&gin67, and2);
    std::cerr << "\rLUT68   ";
    Ciphertext gin68 = 2 * ct_y6 + ct_x0;
    Ciphertext gout68 = ctx.eval_lut(&gin68, and2);
    std::cerr << "\rINV69   ";
    Ciphertext gout69 = 1 - ct_x5;

    std::cerr << "\rLUT70   ";
    Ciphertext gin70 = 2 * ct_y8 + ct_x7;
    Ciphertext gout70 = ctx.eval_lut(&gin70, and2);
    std::cerr << "\rLUT71   ";
    Ciphertext gin71 = 2 * ct_y10 + ct_x2;
    Ciphertext gout71 = ctx.eval_lut(&gin71, and2);
    std::cerr << "\rLUT72   ";
    Ciphertext gin72 = 2 * ct_op2 + ct_op3;
    Ciphertext gout72 = ctx.eval_lut(&gin72, and2);
    std::cerr << "\rINV73   ";
    Ciphertext gout73 = 1 - ct_y8;

    std::cerr << "\rLUT74   ";
    Ciphertext gin74 = 2 * ct_y1 + ct_x12;
    Ciphertext gout74 = ctx.eval_lut(&gin74, and2);
    std::cerr << "\rINV75   ";
    Ciphertext gout75 = 1 - ct_x2;

    std::cerr << "\rLUT76   ";
    Ciphertext gin76 = 2 * ct_y1 + ct_x2;
    Ciphertext gout76 = ctx.eval_lut(&gin76, and2);
    std::cerr << "\rLUT77   ";
    Ciphertext gin77 = 2 * ct_y1 + ct_x6;
    Ciphertext gout77 = ctx.eval_lut(&gin77, and2);
    std::cerr << "\rLUT78   ";
    Ciphertext gin78 = 2 * ct_y3 + ct_x0;
    Ciphertext gout78 = ctx.eval_lut(&gin78, nand2);
    std::cerr << "\rINV79   ";
    Ciphertext gout79 = 1 - ct_x1;

    std::cerr << "\rLUT80   ";
    Ciphertext gin80 = 2 * ct_y2 + ct_x8;
    Ciphertext gout80 = ctx.eval_lut(&gin80, and2);
    std::cerr << "\rLUT81   ";
    Ciphertext gin81 = 2 * ct_y9 + ct_x0;
    Ciphertext gout81 = ctx.eval_lut(&gin81, and2);
    std::cerr << "\rLUT82   ";
    Ciphertext gin82 = 2 * ct_y6 + ct_x5;
    Ciphertext gout82 = ctx.eval_lut(&gin82, and2);
    std::cerr << "\rLUT83   ";
    Ciphertext gin83 = 2 * ct_y5 + ct_x3;
    Ciphertext gout83 = ctx.eval_lut(&gin83, and2);
    std::cerr << "\rLUT84   ";
    Ciphertext gin84 = 2 * ct_y0 + ct_x0;
    Ciphertext gout84 = ctx.eval_lut(&gin84, xnor2);
    std::cerr << "\rLUT85   ";
    Ciphertext gin85 = 2 * ct_y8 + ct_x2;
    Ciphertext gout85 = ctx.eval_lut(&gin85, and2);
    std::cerr << "\rLUT86   ";
    Ciphertext gin86 = 2 * ct_y8 + ct_x3;
    Ciphertext gout86 = ctx.eval_lut(&gin86, and2);
    std::cerr << "\rLUT87   ";
    Ciphertext gin87 = 2 * ct_y14 + ct_x1;
    Ciphertext gout87 = ctx.eval_lut(&gin87, and2);
    std::cerr << "\rINV88   ";
    Ciphertext gout88 = 1 - ct_x10;

    std::cerr << "\rINV89   ";
    Ciphertext gout89 = 1 - ct_y7;

    std::cerr << "\rLUT90   ";
    Ciphertext gin90 = 2 * ct_y1 + ct_x0;
    Ciphertext gout90 = ctx.eval_lut(&gin90, and2);
    std::cerr << "\rLUT91   ";
    Ciphertext gin91 = 2 * ct_y9 + ct_x4;
    Ciphertext gout91 = ctx.eval_lut(&gin91, and2);
    std::cerr << "\rLUT92   ";
    Ciphertext gin92 = 2 * ct_y5 + ct_x0;
    Ciphertext gout92 = ctx.eval_lut(&gin92, and2);
    std::cerr << "\rLUT93   ";
    Ciphertext gin93 = 2 * ct_y2 + ct_x1;
    Ciphertext gout93 = ctx.eval_lut(&gin93, and2);
    std::cerr << "\rLUT94   ";
    Ciphertext gin94 = 2 * ct_y2 + ct_x4;
    Ciphertext gout94 = ctx.eval_lut(&gin94, and2);
    std::cerr << "\rINV95   ";
    Ciphertext gout95 = 1 - ct_x7;

    std::cerr << "\rLUT96   ";
    Ciphertext gin96 = 2 * ct_y7 + ct_x5;
    Ciphertext gout96 = ctx.eval_lut(&gin96, and2);
    std::cerr << "\rINV97   ";
    Ciphertext gout97 = 1 - ct_y10;

    std::cerr << "\rLUT98   ";
    Ciphertext gin98 = 2 * ct_y12 + ct_x2;
    Ciphertext gout98 = ctx.eval_lut(&gin98, nand2);
    std::cerr << "\rINV99   ";
    Ciphertext gout99 = 1 - ct_y9;

    std::cerr << "\rLUT100   ";
    Ciphertext gin100 = 2 * ct_y0 + ct_x6;
    Ciphertext gout100 = ctx.eval_lut(&gin100, nand2);
    std::cerr << "\rLUT101   ";
    Ciphertext gin101 = 2 * ct_y8 + ct_x1;
    Ciphertext gout101 = ctx.eval_lut(&gin101, and2);
    std::cerr << "\rLUT102   ";
    Ciphertext gin102 = 2 * ct_y10 + ct_x1;
    Ciphertext gout102 = ctx.eval_lut(&gin102, and2);
    std::cerr << "\rLUT103   ";
    Ciphertext gin103 = 2 * ct_y1 + ct_x10;
    Ciphertext gout103 = ctx.eval_lut(&gin103, and2);
    std::cerr << "\rLUT104   ";
    Ciphertext gin104 = 2 * ct_y8 + ct_x4;
    Ciphertext gout104 = ctx.eval_lut(&gin104, and2);
    std::cerr << "\rLUT105   ";
    Ciphertext gin105 = 2 * (1 - ct_op1) + ct_op0;
    Ciphertext gout105 = ctx.eval_lut(&gin105, and2);
    std::cerr << "\rINV106   ";
    Ciphertext gout106 = 1 - ct_x6;

    std::cerr << "\rLUT107   ";
    Ciphertext gin107 = 2 * ct_y10 + ct_x3;
    Ciphertext gout107 = ctx.eval_lut(&gin107, and2);
    std::cerr << "\rLUT108   ";
    Ciphertext gin108 = 2 * ct_y6 + ct_x2;
    Ciphertext gout108 = ctx.eval_lut(&gin108, and2);
    std::cerr << "\rLUT109   ";
    Ciphertext gin109 = 2 * ct_y7 + ct_x1;
    Ciphertext gout109 = ctx.eval_lut(&gin109, and2);
    std::cerr << "\rLUT110   ";
    Ciphertext gin110 = 2 * ct_y4 + ct_x10;
    Ciphertext gout110 = ctx.eval_lut(&gin110, and2);
    std::cerr << "\rLUT111   ";
    Ciphertext gin111 = 2 * ct_y1 + ct_x14;
    Ciphertext gout111 = ctx.eval_lut(&gin111, and2);
    std::cerr << "\rLUT112   ";
    Ciphertext gin112 = 2 * ct_y6 + ct_x8;
    Ciphertext gout112 = ctx.eval_lut(&gin112, and2);
    std::cerr << "\rLUT113   ";
    Ciphertext gin113 = 2 * ct_y11 + ct_x3;
    Ciphertext gout113 = ctx.eval_lut(&gin113, and2);
    std::cerr << "\rINV114   ";
    Ciphertext gout114 = 1 - ct_y4;

    std::cerr << "\rLUT115   ";
    Ciphertext gin115 = 2 * ct_y5 + ct_x2;
    Ciphertext gout115 = ctx.eval_lut(&gin115, and2);
    std::cerr << "\rLUT116   ";
    Ciphertext gin116 = 2 * ct_y9 + ct_x1;
    Ciphertext gout116 = ctx.eval_lut(&gin116, nand2);
    std::cerr << "\rLUT117   ";
    Ciphertext gin117 = 2 * ct_y4 + ct_x5;
    Ciphertext gout117 = ctx.eval_lut(&gin117, and2);
    std::cerr << "\rINV118   ";
    Ciphertext gout118 = 1 - ct_y3;

    std::cerr << "\rLUT119   ";
    Ciphertext gin119 = 2 * ct_y7 + ct_x2;
    Ciphertext gout119 = ctx.eval_lut(&gin119, and2);
    std::cerr << "\rLUT120   ";
    Ciphertext gin120 = 2 * ct_y4 + ct_x2;
    Ciphertext gout120 = ctx.eval_lut(&gin120, and2);
    std::cerr << "\rLUT121   ";
    Ciphertext gin121 = 2 * ct_y5 + ct_x7;
    Ciphertext gout121 = ctx.eval_lut(&gin121, and2);
    std::cerr << "\rLUT122   ";
    Ciphertext gin122 = 2 * ct_y7 + ct_x7;
    Ciphertext gout122 = ctx.eval_lut(&gin122, nand2);
    std::cerr << "\rINV123   ";
    Ciphertext gout123 = 1 - ct_x11;

    std::cerr << "\rLUT124   ";
    Ciphertext gin124 = 2 * ct_y4 + ct_x3;
    Ciphertext gout124 = ctx.eval_lut(&gin124, and2);
    std::cerr << "\rLUT125   ";
    Ciphertext gin125 = 2 * ct_y12 + ct_x1;
    Ciphertext gout125 = ctx.eval_lut(&gin125, nand2);
    std::cerr << "\rLUT126   ";
    Ciphertext gin126 = 2 * ct_y11 + ct_x4;
    Ciphertext gout126 = ctx.eval_lut(&gin126, and2);
    std::cerr << "\rINV127   ";
    Ciphertext gout127 = 1 - ct_op0;

    std::cerr << "\rLUT128   ";
    Ciphertext gin128 = 2 * ct_y4 + ct_x9;
    Ciphertext gout128 = ctx.eval_lut(&gin128, and2);
    std::cerr << "\rLUT129   ";
    Ciphertext gin129 = 2 * ct_y4 + ct_x8;
    Ciphertext gout129 = ctx.eval_lut(&gin129, and2);
    std::cerr << "\rLUT130   ";
    Ciphertext gin130 = 2 * ct_y0 + ct_x12;
    Ciphertext gout130 = ctx.eval_lut(&gin130, and2);
    std::cerr << "\rLUT131   ";
    Ciphertext gin131 = 2 * ct_y3 + ct_x11;
    Ciphertext gout131 = ctx.eval_lut(&gin131, nand2);
    std::cerr << "\rLUT132   ";
    Ciphertext gin132 = 2 * ct_y2 + ct_x0;
    Ciphertext gout132 = ctx.eval_lut(&gin132, and2);
    std::cerr << "\rLUT133   ";
    Ciphertext gin133 = 2 * ct_y7 + ct_x8;
    Ciphertext gout133 = ctx.eval_lut(&gin133, and2);
    std::cerr << "\rLUT134   ";
    Ciphertext gin134 = 2 * ct_y2 + ct_x2;
    Ciphertext gout134 = ctx.eval_lut(&gin134, and2);
    std::cerr << "\rLUT135   ";
    Ciphertext gin135 = 2 * ct_y3 + ct_x4;
    Ciphertext gout135 = ctx.eval_lut(&gin135, and2);
    std::cerr << "\rLUT136   ";
    Ciphertext gin136 = 2 * ct_y4 + ct_x0;
    Ciphertext gout136 = ctx.eval_lut(&gin136, and2);
    std::cerr << "\rLUT137   ";
    Ciphertext gin137 = 2 * ct_y14 + ct_x0;
    Ciphertext gout137 = ctx.eval_lut(&gin137, and2);
    std::cerr << "\rLUT138   ";
    Ciphertext gin138 = 2 * ct_y11 + ct_x2;
    Ciphertext gout138 = ctx.eval_lut(&gin138, and2);
    std::cerr << "\rLUT139   ";
    Ciphertext gin139 = 2 * ct_y4 + ct_x7;
    Ciphertext gout139 = ctx.eval_lut(&gin139, and2);
    std::cerr << "\rINV140   ";
    Ciphertext gout140 = 1 - ct_x8;

    std::cerr << "\rLUT141   ";
    Ciphertext gin141 = 2 * ct_y2 + ct_x3;
    Ciphertext gout141 = ctx.eval_lut(&gin141, and2);
    std::cerr << "\rLUT142   ";
    Ciphertext gin142 = 2 * ct_y2 + ct_x9;
    Ciphertext gout142 = ctx.eval_lut(&gin142, and2);
    std::cerr << "\rLUT143   ";
    Ciphertext gin143 = 2 * ct_y8 + ct_x5;
    Ciphertext gout143 = ctx.eval_lut(&gin143, and2);
    std::cerr << "\rLUT144   ";
    Ciphertext gin144 = 2 * ct_y8 + ct_x0;
    Ciphertext gout144 = ctx.eval_lut(&gin144, and2);
    std::cerr << "\rLUT145   ";
    Ciphertext gin145 = 2 * ct_y1 + ct_x1;
    Ciphertext gout145 = ctx.eval_lut(&gin145, nand2);
    std::cerr << "\rLUT146   ";
    Ciphertext gin146 = 2 * ct_y1 + ct_x7;
    Ciphertext gout146 = ctx.eval_lut(&gin146, and2);
    std::cerr << "\rLUT147   ";
    Ciphertext gin147 = 2 * ct_y0 + ct_x0;
    Ciphertext gout147 = ctx.eval_lut(&gin147, and2);
    std::cerr << "\rLUT148   ";
    Ciphertext gin148 = 2 * ct_y8 + ct_x6;
    Ciphertext gout148 = ctx.eval_lut(&gin148, and2);
    std::cerr << "\rLUT149   ";
    Ciphertext gin149 = 2 * ct_y3 + ct_x8;
    Ciphertext gout149 = ctx.eval_lut(&gin149, and2);
    std::cerr << "\rLUT150   ";
    Ciphertext gin150 = 2 * ct_y4 + ct_x1;
    Ciphertext gout150 = ctx.eval_lut(&gin150, and2);
    std::cerr << "\rLUT151   ";
    Ciphertext gin151 = 2 * ct_y4 + ct_x11;
    Ciphertext gout151 = ctx.eval_lut(&gin151, and2);
    std::cerr << "\rLUT152   ";
    Ciphertext gin152 = 2 * ct_y1 + ct_x8;
    Ciphertext gout152 = ctx.eval_lut(&gin152, and2);
    std::cerr << "\rLUT153   ";
    Ciphertext gin153 = 2 * ct_y2 + ct_x13;
    Ciphertext gout153 = ctx.eval_lut(&gin153, and2);
    std::cerr << "\rINV154   ";
    Ciphertext gout154 = 1 - ct_x3;

    std::cerr << "\rLUT155   ";
    Ciphertext gin155 = 2 * ct_y3 + ct_x12;
    Ciphertext gout155 = ctx.eval_lut(&gin155, and2);
    std::cerr << "\rLUT156   ";
    Ciphertext gin156 = 2 * ct_y0 + ct_x13;
    Ciphertext gout156 = ctx.eval_lut(&gin156, and2);
    std::cerr << "\rLUT157   ";
    Ciphertext gin157 = 2 * ct_y0 + ct_x3;
    Ciphertext gout157 = ctx.eval_lut(&gin157, and2);
    std::cerr << "\rINV158   ";
    Ciphertext gout158 = 1 - ct_x12;

    std::cerr << "\rINV159   ";
    Ciphertext gout159 = 1 - ct_y15;

    std::cerr << "\rLUT160   ";
    Ciphertext gin160 = 2 * ct_y2 + ct_x5;
    Ciphertext gout160 = ctx.eval_lut(&gin160, and2);
    std::cerr << "\rLUT161   ";
    Ciphertext gin161 = 2 * ct_y13 + ct_x2;
    Ciphertext gout161 = ctx.eval_lut(&gin161, and2);
    std::cerr << "\rLUT162   ";
    Ciphertext gin162 = 2 * ct_y1 + ct_x11;
    Ciphertext gout162 = ctx.eval_lut(&gin162, and2);
    std::cerr << "\rLUT163   ";
    Ciphertext gin163 = 2 * ct_y2 + ct_x12;
    Ciphertext gout163 = ctx.eval_lut(&gin163, and2);
    std::cerr << "\rLUT164   ";
    Ciphertext gin164 = 2 * (1 - ct_x0) + ct_y15;
    Ciphertext gout164 = ctx.eval_lut(&gin164, and2);
    std::cerr << "\rINV165   ";
    Ciphertext gout165 = 1 - ct_x9;

    std::cerr << "\rINV166   ";
    Ciphertext gout166 = 1 - ct_y6;

    std::cerr << "\rINV167   ";
    Ciphertext gout167 = 1 - ct_y5;

    std::cerr << "\rINV168   ";
    Ciphertext gout168 = 1 - ct_y14;

    std::cerr << "\rLUT169   ";
    Ciphertext gin169 = 2 * ct_y10 + ct_x0;
    Ciphertext gout169 = ctx.eval_lut(&gin169, and2);
    std::cerr << "\rLUT170   ";
    Ciphertext gin170 = 2 * ct_y3 + ct_x2;
    Ciphertext gout170 = ctx.eval_lut(&gin170, and2);
    std::cerr << "\rLUT171   ";
    Ciphertext gin171 = 2 * gout1 + gout31;
    Ciphertext gout171 = ctx.eval_lut(&gin171, nand2);
    std::cerr << "\rLUT172   ";
    Ciphertext gin172 = 2 * ct_op3 + gout6;
    Ciphertext gout172 = ctx.eval_lut(&gin172, and2);
    std::cerr << "\rLUT173   ";
    Ciphertext gin173 = 2 * gout41 + gout7;
    Ciphertext gout173 = ctx.eval_lut(&gin173, xor2);
    std::cerr << "\rLUT174   ";
    Ciphertext gin174 = 2 * gout54 + gout16;
    Ciphertext gout174 = ctx.eval_lut(&gin174, and2);
    std::cerr << "\rLUT175   ";
    Ciphertext gin175 = 2 * gout70 + gout22;
    Ciphertext gout175 = ctx.eval_lut(&gin175, xnor2);
    std::cerr << "\rLUT176   ";
    Ciphertext gin176 = 2 * gout64 + gout36;
    Ciphertext gout176 = ctx.eval_lut(&gin176, xnor2);
    std::cerr << "\rLUT177   ";
    Ciphertext gin177 = 2 * gout10 + gout42;
    Ciphertext gout177 = ctx.eval_lut(&gin177, nand2);
    std::cerr << "\rLUT178   ";
    Ciphertext gin178 = 2 * gout71 + gout23;
    Ciphertext gout178 = ctx.eval_lut(&gin178, xor2);
    std::cerr << "\rLUT179   ";
    Ciphertext gin179 = 2 * gout27 + gout49;
    Ciphertext gout179 = ctx.eval_lut(&gin179, xor2);
    std::cerr << "\rLUT180   ";
    Ciphertext gin180 = 2 * gout41 + gout7;
    Ciphertext gout180 = ctx.eval_lut(&gin180, nand2);
    std::cerr << "\rLUT181   ";
    Ciphertext gin181 = 2 * gout27 + gout49;
    Ciphertext gout181 = ctx.eval_lut(&gin181, nand2);
    std::cerr << "\rLUT182   ";
    Ciphertext gin182 = 2 * gout105 + gout72;
    Ciphertext gout182 = ctx.eval_lut(&gin182, and2);
    std::cerr << "\rLUT183   ";
    Ciphertext gin183 = 2 * gout58 + gout82;
    Ciphertext gout183 = ctx.eval_lut(&gin183, xor2);
    std::cerr << "\rLUT184   ";
    Ciphertext gin184 = 2 * gout102 + gout67;
    Ciphertext gout184 = ctx.eval_lut(&gin184, nand2);
    std::cerr << "\rLUT185   ";
    Ciphertext gin185 = 2 * gout68 + gout109;
    Ciphertext gout185 = ctx.eval_lut(&gin185, and2);
    std::cerr << "\rINV186   ";
    Ciphertext gout186 = 1 - gout54;

    std::cerr << "\rLUT187   ";
    Ciphertext gin187 = 2 * gout58 + gout82;
    Ciphertext gout187 = ctx.eval_lut(&gin187, nand2);
    std::cerr << "\rLUT188   ";
    Ciphertext gin188 = 2 * gout66 + gout59;
    Ciphertext gout188 = ctx.eval_lut(&gin188, and2);
    std::cerr << "\rLUT189   ";
    Ciphertext gin189 = 2 * gout9 + gout94;
    Ciphertext gout189 = ctx.eval_lut(&gin189, nand2);
    std::cerr << "\rLUT190   ";
    Ciphertext gin190 = 2 * gout24 + gout5;
    Ciphertext gout190 = ctx.eval_lut(&gin190, xnor2);
    std::cerr << "\rLUT191   ";
    Ciphertext gin191 = 2 * gout3 + gout24;
    Ciphertext gout191 = ctx.eval_lut(&gin191, nand2);
    std::cerr << "\rLUT192   ";
    Ciphertext gin192 = 2 * gout11 + gout53;
    Ciphertext gout192 = ctx.eval_lut(&gin192, xnor2);
    std::cerr << "\rLUT193   ";
    Ciphertext gin193 = 2 * gout122 + gout112;
    Ciphertext gout193 = ctx.eval_lut(&gin193, xnor2);
    std::cerr << "\rLUT194   ";
    Ciphertext gin194 = 2 * gout28 + gout80;
    Ciphertext gout194 = ctx.eval_lut(&gin194, nand2);
    std::cerr << "\rINV195   ";
    Ciphertext gout195 = 1 - gout3;

    std::cerr << "\rLUT196   ";
    Ciphertext gin196 = 2 * gout109 + gout108;
    Ciphertext gout196 = ctx.eval_lut(&gin196, nand2);
    std::cerr << "\rLUT197   ";
    Ciphertext gin197 = 2 * gout1 + gout31;
    Ciphertext gout197 = ctx.eval_lut(&gin197, xor2);
    std::cerr << "\rLUT198   ";
    Ciphertext gin198 = 2 * gout50 + gout35;
    Ciphertext gout198 = ctx.eval_lut(&gin198, nand2);
    std::cerr << "\rLUT199   ";
    Ciphertext gin199 = 2 * gout109 + gout108;
    Ciphertext gout199 = ctx.eval_lut(&gin199, xor2);
    std::cerr << "\rLUT200   ";
    Ciphertext gin200 = 2 * gout37 + gout117;
    Ciphertext gout200 = ctx.eval_lut(&gin200, nand2);
    std::cerr << "\rLUT201   ";
    Ciphertext gin201 = 2 * gout129 + gout130;
    Ciphertext gout201 = ctx.eval_lut(&gin201, nand2);
    std::cerr << "\rLUT202   ";
    Ciphertext gin202 = 2 * gout100 + (1 - gout110);
    Ciphertext gout202 = ctx.eval_lut(&gin202, or2);
    std::cerr << "\rLUT203   ";
    Ciphertext gin203 = 2 * gout16 + gout98;
    Ciphertext gout203 = ctx.eval_lut(&gin203, xnor2);
    std::cerr << "\rLUT204   ";
    Ciphertext gin204 = 2 * gout50 + gout35;
    Ciphertext gout204 = ctx.eval_lut(&gin204, xor2);
    std::cerr << "\rLUT205   ";
    Ciphertext gin205 = 2 * gout126 + gout51;
    Ciphertext gout205 = ctx.eval_lut(&gin205, xnor2);
    std::cerr << "\rLUT206   ";
    Ciphertext gin206 = 2 * gout9 + gout94;
    Ciphertext gout206 = ctx.eval_lut(&gin206, xor2);
    std::cerr << "\rLUT207   ";
    Ciphertext gin207 = 2 * gout71 + gout23;
    Ciphertext gout207 = ctx.eval_lut(&gin207, nand2);
    std::cerr << "\rLUT208   ";
    Ciphertext gin208 = 2 * gout139 + gout63;
    Ciphertext gout208 = ctx.eval_lut(&gin208, xnor2);
    std::cerr << "\rLUT209   ";
    Ciphertext gin209 = 2 * gout90 + gout93;
    Ciphertext gout209 = ctx.eval_lut(&gin209, and2);
    std::cerr << "\rLUT210   ";
    Ciphertext gin210 = 2 * gout52 + gout44;
    Ciphertext gout210 = ctx.eval_lut(&gin210, and2);
    std::cerr << "\rLUT211   ";
    Ciphertext gin211 = 2 * gout2 + gout29;
    Ciphertext gout211 = ctx.eval_lut(&gin211, xnor2);
    std::cerr << "\rLUT212   ";
    Ciphertext gin212 = 2 * gout28 + gout80;
    Ciphertext gout212 = ctx.eval_lut(&gin212, xor2);
    std::cerr << "\rLUT213   ";
    Ciphertext gin213 = 2 * gout60 + gout30;
    Ciphertext gout213 = ctx.eval_lut(&gin213, xnor2);
    std::cerr << "\rLUT214   ";
    Ciphertext gin214 = 2 * gout146 + gout173;
    Ciphertext gout214 = ctx.eval_lut(&gin214, nand2);
    std::cerr << "\rLUT215   ";
    Ciphertext gin215 = 2 * gout117 + gout43;
    Ciphertext gout215 = ctx.eval_lut(&gin215, xnor2);
    std::cerr << "\rLUT216   ";
    Ciphertext gin216 = 2 * gout81 + gout102;
    Ciphertext gout216 = ctx.eval_lut(&gin216, and2);
    std::cerr << "\rLUT217   ";
    Ciphertext gin217 = 2 * gout10 + gout42;
    Ciphertext gout217 = ctx.eval_lut(&gin217, xor2);
    std::cerr << "\rLUT218   ";
    Ciphertext gin218 = 2 * gout147 + (1 - gout145);
    Ciphertext gout218 = ctx.eval_lut(&gin218, and2);
    std::cerr << "\rLUT219   ";
    Ciphertext gin219 = 2 * gout90 + gout37;
    Ciphertext gout219 = ctx.eval_lut(&gin219, xor2);
    std::cerr << "\rLUT220   ";
    Ciphertext gin220 = 2 * gout32 + gout61;
    Ciphertext gout220 = ctx.eval_lut(&gin220, xor2);
    std::cerr << "\rLUT221   ";
    Ciphertext gin221 = 2 * gout128 + gout156;
    Ciphertext gout221 = ctx.eval_lut(&gin221, xor2);
    std::cerr << "\rLUT222   ";
    Ciphertext gin222 = 2 * gout33 + gout124;
    Ciphertext gout222 = ctx.eval_lut(&gin222, xnor2);
    std::cerr << "\rINV223   ";
    Ciphertext gout223 = 1 - gout44;

    std::cerr << "\rLUT224   ";
    Ciphertext gin224 = 2 * gout32 + gout61;
    Ciphertext gout224 = ctx.eval_lut(&gin224, nand2);
    std::cerr << "\rLUT225   ";
    Ciphertext gin225 = 2 * gout110 + gout47;
    Ciphertext gout225 = ctx.eval_lut(&gin225, xor2);
    std::cerr << "\rLUT226   ";
    Ciphertext gin226 = 2 * gout61 + gout133;
    Ciphertext gout226 = ctx.eval_lut(&gin226, nand2);
    std::cerr << "\rLUT227   ";
    Ciphertext gin227 = 2 * gout135 + gout160;
    Ciphertext gout227 = ctx.eval_lut(&gin227, xor2);
    std::cerr << "\rLUT228   ";
    Ciphertext gin228 = 2 * gout125 + (1 - gout161);
    Ciphertext gout228 = ctx.eval_lut(&gin228, or2);
    std::cerr << "\rLUT229   ";
    Ciphertext gin229 = 2 * gout170 + gout141;
    Ciphertext gout229 = ctx.eval_lut(&gin229, xor2);
    std::cerr << "\rLUT230   ";
    Ciphertext gin230 = 2 * gout125 + gout12;
    Ciphertext gout230 = ctx.eval_lut(&gin230, xnor2);
    std::cerr << "\rLUT231   ";
    Ciphertext gin231 = 2 * gout164 + gout87;
    Ciphertext gout231 = ctx.eval_lut(&gin231, xnor2);
    std::cerr << "\rLUT232   ";
    Ciphertext gin232 = 2 * gout107 + gout91;
    Ciphertext gout232 = ctx.eval_lut(&gin232, xor2);
    std::cerr << "\rLUT233   ";
    Ciphertext gin233 = 2 * gout116 + gout169;
    Ciphertext gout233 = ctx.eval_lut(&gin233, xnor2);
    std::cerr << "\rLUT234   ";
    Ciphertext gin234 = 2 * gout149 + gout142;
    Ciphertext gout234 = ctx.eval_lut(&gin234, nand2);
    std::cerr << "\rLUT235   ";
    Ciphertext gin235 = 2 * gout157 + gout139;
    Ciphertext gout235 = ctx.eval_lut(&gin235, nand2);
    std::cerr << "\rLUT236   ";
    Ciphertext gin236 = 2 * gout149 + gout142;
    Ciphertext gout236 = ctx.eval_lut(&gin236, xor2);
    std::cerr << "\rLUT237   ";
    Ciphertext gin237 = 2 * gout4 + (1 - gout128);
    Ciphertext gout237 = ctx.eval_lut(&gin237, or2);
    std::cerr << "\rLUT238   ";
    Ciphertext gin238 = 2 * gout119 + gout45;
    Ciphertext gout238 = ctx.eval_lut(&gin238, xor2);
    std::cerr << "\rLUT239   ";
    Ciphertext gin239 = 2 * gout19 + (1 - gout129);
    Ciphertext gout239 = ctx.eval_lut(&gin239, or2);
    std::cerr << "\rLUT240   ";
    Ciphertext gin240 = 2 * gout0 + gout134;
    Ciphertext gout240 = ctx.eval_lut(&gin240, xnor2);
    std::cerr << "\rLUT241   ";
    Ciphertext gin241 = 2 * gout93 + gout78;
    Ciphertext gout241 = ctx.eval_lut(&gin241, xnor2);
    std::cerr << "\rLUT242   ";
    Ciphertext gin242 = 2 * gout102 + gout67;
    Ciphertext gout242 = ctx.eval_lut(&gin242, xor2);
    std::cerr << "\rLUT243   ";
    Ciphertext gin243 = 2 * gout100 + gout120;
    Ciphertext gout243 = ctx.eval_lut(&gin243, xnor2);
    std::cerr << "\rLUT244   ";
    Ciphertext gin244 = 2 * gout133 + gout176;
    Ciphertext gout244 = ctx.eval_lut(&gin244, xnor2);
    std::cerr << "\rLUT245   ";
    Ciphertext gin245 = 2 * gout96 + gout18;
    Ciphertext gout245 = ctx.eval_lut(&gin245, xor2);
    std::cerr << "\rLUT246   ";
    Ciphertext gin246 = 2 * gout96 + gout18;
    Ciphertext gout246 = ctx.eval_lut(&gin246, nand2);
    std::cerr << "\rLUT247   ";
    Ciphertext gin247 = 2 * gout135 + gout160;
    Ciphertext gout247 = ctx.eval_lut(&gin247, nand2);
    std::cerr << "\rLUT248   ";
    Ciphertext gin248 = 2 * gout128 + gout156;
    Ciphertext gout248 = ctx.eval_lut(&gin248, nand2);
    std::cerr << "\rLUT249   ";
    Ciphertext gin249 = 2 * gout91 + gout46;
    Ciphertext gout249 = ctx.eval_lut(&gin249, nand2);
    std::cerr << "\rLUT250   ";
    Ciphertext gin250 = 2 * gout170 + gout141;
    Ciphertext gout250 = ctx.eval_lut(&gin250, nand2);
    std::cerr << "\rLUT251   ";
    Ciphertext gin251 = 2 * gout110 + gout47;
    Ciphertext gout251 = ctx.eval_lut(&gin251, nand2);
    std::cerr << "\rLUT252   ";
    Ciphertext gin252 = 2 * gout107 + gout91;
    Ciphertext gout252 = ctx.eval_lut(&gin252, nand2);
    std::cerr << "\rLUT253   ";
    Ciphertext gin253 = 2 * gout33 + (1 - gout151);
    Ciphertext gout253 = ctx.eval_lut(&gin253, or2);
    std::cerr << "\rINV254   ";
    Ciphertext gout254 = 1 - gout147;

    std::cerr << "\rLUT255   ";
    Ciphertext gin255 = 2 * gout145 + gout132;
    Ciphertext gout255 = ctx.eval_lut(&gin255, xnor2);
    std::cerr << "\rLUT256   ";
    Ciphertext gin256 = 2 * gout111 + gout15;
    Ciphertext gout256 = ctx.eval_lut(&gin256, xnor2);
    std::cerr << "\rLUT257   ";
    Ciphertext gin257 = 2 * gout159 + gout155;
    Ciphertext gout257 = ctx.eval_lut(&gin257, xnor2);
    std::cerr << "\rLUT258   ";
    Ciphertext gin258 = 2 * gout148 + gout193;
    Ciphertext gout258 = ctx.eval_lut(&gin258, xor2);
    std::cerr << "\rLUT259   ";
    Ciphertext gin259 = 2 * (1 - gout132) + gout0;
    Ciphertext gout259 = ctx.eval_lut(&gin259, or2);
    std::cerr << "\rLUT260   ";
    Ciphertext gin260 = 2 * gout119 + gout45;
    Ciphertext gout260 = ctx.eval_lut(&gin260, nand2);
    std::cerr << "\rLUT261   ";
    Ciphertext gin261 = 2 * gout19 + gout136;
    Ciphertext gout261 = ctx.eval_lut(&gin261, xnor2);
    std::cerr << "\rLUT262   ";
    Ciphertext gin262 = 2 * gout147 + gout60;
    Ciphertext gout262 = ctx.eval_lut(&gin262, and2);
    std::cerr << "\rLUT263   ";
    Ciphertext gin263 = 2 * gout4 + gout150;
    Ciphertext gout263 = ctx.eval_lut(&gin263, xnor2);
    std::cerr << "\rLUT264   ";
    Ciphertext gin264 = 2 * gout129 + gout130;
    Ciphertext gout264 = ctx.eval_lut(&gin264, xor2);
    std::cerr << "\rLUT265   ";
    Ciphertext gin265 = 2 * gout93 + gout170;
    Ciphertext gout265 = ctx.eval_lut(&gin265, nand2);
    std::cerr << "\rLUT266   ";
    Ciphertext gin266 = 2 * gout131 + gout163;
    Ciphertext gout266 = ctx.eval_lut(&gin266, xnor2);
    std::cerr << "\rLUT267   ";
    Ciphertext gin267 = 2 * gout146 + gout173;
    Ciphertext gout267 = ctx.eval_lut(&gin267, xor2);
    std::cerr << "\rLUT268   ";
    Ciphertext gin268 = 2 * gout35 + gout155;
    Ciphertext gout268 = ctx.eval_lut(&gin268, nand2);
    std::cerr << "\rLUT269   ";
    Ciphertext gin269 = 2 * gout148 + gout193;
    Ciphertext gout269 = ctx.eval_lut(&gin269, nand2);
    std::cerr << "\rINV270   ";
    Ciphertext gout270 = 1 - gout157;

    std::cerr << "\rLUT271   ";
    Ciphertext gin271 = 2 * gout48 + gout178;
    Ciphertext gout271 = ctx.eval_lut(&gin271, xor2);
    std::cerr << "\rLUT272   ";
    Ciphertext gin272 = 2 * gout86 + gout183;
    Ciphertext gout272 = ctx.eval_lut(&gin272, xor2);
    std::cerr << "\rLUT273   ";
    Ciphertext gin273 = 2 * gout86 + gout183;
    Ciphertext gout273 = ctx.eval_lut(&gin273, nand2);
    std::cerr << "\rLUT274   ";
    Ciphertext gin274 = 2 * gout56 + gout190;
    Ciphertext gout274 = ctx.eval_lut(&gin274, xor2);
    std::cerr << "\rLUT275   ";
    Ciphertext gin275 = 2 * gout188 + gout172;
    Ciphertext gout275 = ctx.eval_lut(&gin275, and2);
    std::cerr << "\rLUT276   ";
    Ciphertext gin276 = 2 * gout144 + gout199;
    Ciphertext gout276 = ctx.eval_lut(&gin276, nand2);
    std::cerr << "\rLUT277   ";
    Ciphertext gin277 = 2 * gout48 + gout178;
    Ciphertext gout277 = ctx.eval_lut(&gin277, nand2);
    std::cerr << "\rLUT278   ";
    Ciphertext gin278 = 2 * gout144 + gout199;
    Ciphertext gout278 = ctx.eval_lut(&gin278, xor2);
    std::cerr << "\rLUT279   ";
    Ciphertext gin279 = 2 * gout152 + gout197;
    Ciphertext gout279 = ctx.eval_lut(&gin279, xor2);
    std::cerr << "\rLUT280   ";
    Ciphertext gin280 = 2 * gout74 + gout204;
    Ciphertext gout280 = ctx.eval_lut(&gin280, nand2);
    std::cerr << "\rLUT281   ";
    Ciphertext gin281 = 2 * gout175 + gout205;
    Ciphertext gout281 = ctx.eval_lut(&gin281, xnor2);
    std::cerr << "\rLUT282   ";
    Ciphertext gin282 = 2 * gout137 + gout203;
    Ciphertext gout282 = ctx.eval_lut(&gin282, nand2);
    std::cerr << "\rLUT283   ";
    Ciphertext gin283 = 2 * gout56 + gout190;
    Ciphertext gout283 = ctx.eval_lut(&gin283, nand2);
    std::cerr << "\rLUT284   ";
    Ciphertext gin284 = 2 * gout57 + gout208;
    Ciphertext gout284 = ctx.eval_lut(&gin284, nand2);
    std::cerr << "\rLUT285   ";
    Ciphertext gin285 = 2 * gout74 + gout204;
    Ciphertext gout285 = ctx.eval_lut(&gin285, xor2);
    std::cerr << "\rLUT286   ";
    Ciphertext gin286 = 2 * gout118 + gout210;
    Ciphertext gout286 = ctx.eval_lut(&gin286, and2);
    std::cerr << "\rLUT287   ";
    Ciphertext gin287 = 2 * gout25 + gout221;
    Ciphertext gout287 = ctx.eval_lut(&gin287, nand2);
    std::cerr << "\rLUT288   ";
    Ciphertext gin288 = 2 * gout83 + gout213;
    Ciphertext gout288 = ctx.eval_lut(&gin288, xor2);
    std::cerr << "\rLUT289   ";
    Ciphertext gin289 = 2 * gout83 + gout213;
    Ciphertext gout289 = ctx.eval_lut(&gin289, nand2);
    std::cerr << "\rLUT290   ";
    Ciphertext gin290 = 2 * gout25 + gout221;
    Ciphertext gout290 = ctx.eval_lut(&gin290, xor2);
    std::cerr << "\rLUT291   ";
    Ciphertext gin291 = 2 * gout38 + gout229;
    Ciphertext gout291 = ctx.eval_lut(&gin291, xor2);
    std::cerr << "\rLUT292   ";
    Ciphertext gin292 = 2 * gout55 + gout212;
    Ciphertext gout292 = ctx.eval_lut(&gin292, xor2);
    std::cerr << "\rLUT293   ";
    Ciphertext gin293 = 2 * gout188 + gout182;
    Ciphertext gout293 = ctx.eval_lut(&gin293, and2);
    std::cerr << "\rLUT294   ";
    Ciphertext gin294 = 2 * gout40 + gout240;
    Ciphertext gout294 = ctx.eval_lut(&gin294, xor2);
    std::cerr << "\rLUT295   ";
    Ciphertext gin295 = 2 * gout228 + gout282;
    Ciphertext gout295 = ctx.eval_lut(&gin295, nand2);
    std::cerr << "\rLUT296   ";
    Ciphertext gin296 = 2 * gout40 + gout240;
    Ciphertext gout296 = ctx.eval_lut(&gin296, nand2);
    std::cerr << "\rLUT297   ";
    Ciphertext gin297 = 2 * gout207 + gout277;
    Ciphertext gout297 = ctx.eval_lut(&gin297, nand2);
    std::cerr << "\rLUT298   ";
    Ciphertext gin298 = 2 * gout162 + gout217;
    Ciphertext gout298 = ctx.eval_lut(&gin298, xor2);
    std::cerr << "\rLUT299   ";
    Ciphertext gin299 = 2 * gout143 + gout220;
    Ciphertext gout299 = ctx.eval_lut(&gin299, xor2);
    std::cerr << "\rLUT300   ";
    Ciphertext gin300 = 2 * gout137 + gout203;
    Ciphertext gout300 = ctx.eval_lut(&gin300, xor2);
    std::cerr << "\rLUT301   ";
    Ciphertext gin301 = 2 * gout143 + gout220;
    Ciphertext gout301 = ctx.eval_lut(&gin301, nand2);
    std::cerr << "\rLUT302   ";
    Ciphertext gin302 = 2 * gout152 + gout197;
    Ciphertext gout302 = ctx.eval_lut(&gin302, nand2);
    std::cerr << "\rLUT303   ";
    Ciphertext gin303 = 2 * gout77 + gout227;
    Ciphertext gout303 = ctx.eval_lut(&gin303, xor2);
    std::cerr << "\rLUT304   ";
    Ciphertext gin304 = 2 * gout138 + gout232;
    Ciphertext gout304 = ctx.eval_lut(&gin304, nand2);
    std::cerr << "\rINV305   ";
    Ciphertext gout305 = 1 - gout216;

    std::cerr << "\rLUT306   ";
    Ciphertext gin306 = 2 * gout115 + gout222;
    Ciphertext gout306 = ctx.eval_lut(&gin306, nand2);
    std::cerr << "\rLUT307   ";
    Ciphertext gin307 = 2 * gout14 + gout242;
    Ciphertext gout307 = ctx.eval_lut(&gin307, xor2);
    std::cerr << "\rLUT308   ";
    Ciphertext gin308 = 2 * gout138 + gout232;
    Ciphertext gout308 = ctx.eval_lut(&gin308, xor2);
    std::cerr << "\rLUT309   ";
    Ciphertext gin309 = 2 * gout85 + gout179;
    Ciphertext gout309 = ctx.eval_lut(&gin309, nand2);
    std::cerr << "\rLUT310   ";
    Ciphertext gin310 = 2 * gout113 + gout211;
    Ciphertext gout310 = ctx.eval_lut(&gin310, xor2);
    std::cerr << "\rLUT311   ";
    Ciphertext gin311 = 2 * gout103 + gout236;
    Ciphertext gout311 = ctx.eval_lut(&gin311, nand2);
    std::cerr << "\rLUT312   ";
    Ciphertext gin312 = 2 * gout38 + gout229;
    Ciphertext gout312 = ctx.eval_lut(&gin312, nand2);
    std::cerr << "\rLUT313   ";
    Ciphertext gin313 = 2 * gout85 + gout179;
    Ciphertext gout313 = ctx.eval_lut(&gin313, xor2);
    std::cerr << "\rLUT314   ";
    Ciphertext gin314 = 2 * gout26 + gout225;
    Ciphertext gout314 = ctx.eval_lut(&gin314, nand2);
    std::cerr << "\rLUT315   ";
    Ciphertext gin315 = 2 * gout101 + gout238;
    Ciphertext gout315 = ctx.eval_lut(&gin315, xor2);
    std::cerr << "\rLUT316   ";
    Ciphertext gin316 = 2 * gout26 + gout225;
    Ciphertext gout316 = ctx.eval_lut(&gin316, xor2);
    std::cerr << "\rLUT317   ";
    Ciphertext gin317 = 2 * gout34 + gout243;
    Ciphertext gout317 = ctx.eval_lut(&gin317, xor2);
    std::cerr << "\rLUT318   ";
    Ciphertext gin318 = 2 * gout104 + gout245;
    Ciphertext gout318 = ctx.eval_lut(&gin318, xor2);
    std::cerr << "\rLUT319   ";
    Ciphertext gin319 = 2 * gout104 + gout245;
    Ciphertext gout319 = ctx.eval_lut(&gin319, nand2);
    std::cerr << "\rLUT320   ";
    Ciphertext gin320 = 2 * gout162 + gout217;
    Ciphertext gout320 = ctx.eval_lut(&gin320, nand2);
    std::cerr << "\rLUT321   ";
    Ciphertext gin321 = 2 * gout77 + gout227;
    Ciphertext gout321 = ctx.eval_lut(&gin321, nand2);
    std::cerr << "\rLUT322   ";
    Ciphertext gin322 = 2 * gout253 + gout284;
    Ciphertext gout322 = ctx.eval_lut(&gin322, nand2);
    std::cerr << "\rLUT323   ";
    Ciphertext gin323 = 2 * gout115 + gout222;
    Ciphertext gout323 = ctx.eval_lut(&gin323, xor2);
    std::cerr << "\rLUT324   ";
    Ciphertext gin324 = 2 * gout195 + gout255;
    Ciphertext gout324 = ctx.eval_lut(&gin324, xnor2);
    std::cerr << "\rLUT325   ";
    Ciphertext gin325 = 2 * gout113 + gout211;
    Ciphertext gout325 = ctx.eval_lut(&gin325, nand2);
    std::cerr << "\rLUT326   ";
    Ciphertext gin326 = 2 * gout14 + gout242;
    Ciphertext gout326 = ctx.eval_lut(&gin326, nand2);
    std::cerr << "\rLUT327   ";
    Ciphertext gin327 = 2 * gout76 + gout241;
    Ciphertext gout327 = ctx.eval_lut(&gin327, nand2);
    std::cerr << "\rLUT328   ";
    Ciphertext gin328 = 2 * gout265 + gout296;
    Ciphertext gout328 = ctx.eval_lut(&gin328, nand2);
    std::cerr << "\rLUT329   ";
    Ciphertext gin329 = 2 * gout92 + gout263;
    Ciphertext gout329 = ctx.eval_lut(&gin329, nand2);
    std::cerr << "\rLUT330   ";
    Ciphertext gin330 = 2 * gout34 + gout243;
    Ciphertext gout330 = ctx.eval_lut(&gin330, nand2);
    std::cerr << "\rLUT331   ";
    Ciphertext gin331 = 2 * gout101 + gout238;
    Ciphertext gout331 = ctx.eval_lut(&gin331, nand2);
    std::cerr << "\rLUT332   ";
    Ciphertext gin332 = 2 * gout239 + gout289;
    Ciphertext gout332 = ctx.eval_lut(&gin332, nand2);
    std::cerr << "\rLUT333   ";
    Ciphertext gin333 = 2 * gout20 + gout266;
    Ciphertext gout333 = ctx.eval_lut(&gin333, nand2);
    std::cerr << "\rLUT334   ";
    Ciphertext gin334 = 2 * gout226 + gout269;
    Ciphertext gout334 = ctx.eval_lut(&gin334, and2);
    std::cerr << "\rLUT335   ";
    Ciphertext gin335 = 2 * gout39 + gout206;
    Ciphertext gout335 = ctx.eval_lut(&gin335, nand2);
    std::cerr << "\rLUT336   ";
    Ciphertext gin336 = 2 * gout39 + gout206;
    Ciphertext gout336 = ctx.eval_lut(&gin336, xor2);
    std::cerr << "\rLUT337   ";
    Ciphertext gin337 = 2 * gout17 + gout215;
    Ciphertext gout337 = ctx.eval_lut(&gin337, nand2);
    std::cerr << "\rLUT338   ";
    Ciphertext gin338 = 2 * gout180 + gout214;
    Ciphertext gout338 = ctx.eval_lut(&gin338, nand2);
    std::cerr << "\rLUT339   ";
    Ciphertext gin339 = 2 * gout3 + gout255;
    Ciphertext gout339 = ctx.eval_lut(&gin339, and2);
    std::cerr << "\rLUT340   ";
    Ciphertext gin340 = 2 * gout121 + gout264;
    Ciphertext gout340 = ctx.eval_lut(&gin340, xor2);
    std::cerr << "\rLUT341   ";
    Ciphertext gin341 = 2 * gout17 + gout215;
    Ciphertext gout341 = ctx.eval_lut(&gin341, xor2);
    std::cerr << "\rLUT342   ";
    Ciphertext gin342 = 2 * gout55 + gout212;
    Ciphertext gout342 = ctx.eval_lut(&gin342, nand2);
    std::cerr << "\rLUT343   ";
    Ciphertext gin343 = 2 * gout92 + gout263;
    Ciphertext gout343 = ctx.eval_lut(&gin343, xor2);
    std::cerr << "\rLUT344   ";
    Ciphertext gin344 = 2 * gout20 + gout266;
    Ciphertext gout344 = ctx.eval_lut(&gin344, xor2);
    std::cerr << "\rLUT345   ";
    Ciphertext gin345 = 2 * gout248 + gout287;
    Ciphertext gout345 = ctx.eval_lut(&gin345, nand2);
    std::cerr << "\rLUT346   ";
    Ciphertext gin346 = 2 * gout57 + gout208;
    Ciphertext gout346 = ctx.eval_lut(&gin346, xor2);
    std::cerr << "\rLUT347   ";
    Ciphertext gin347 = 2 * gout153 + gout257;
    Ciphertext gout347 = ctx.eval_lut(&gin347, xnor2);
    std::cerr << "\rLUT348   ";
    Ciphertext gin348 = 2 * gout252 + gout304;
    Ciphertext gout348 = ctx.eval_lut(&gin348, nand2);
    std::cerr << "\rLUT349   ";
    Ciphertext gin349 = 2 * gout76 + gout241;
    Ciphertext gout349 = ctx.eval_lut(&gin349, xor2);
    std::cerr << "\rLUT350   ";
    Ciphertext gin350 = 2 * gout103 + gout236;
    Ciphertext gout350 = ctx.eval_lut(&gin350, xor2);
    std::cerr << "\rLUT351   ";
    Ciphertext gin351 = 2 * gout121 + gout264;
    Ciphertext gout351 = ctx.eval_lut(&gin351, nand2);
    std::cerr << "\rINV352   ";
    Ciphertext gout352 = 1 - gout262;

    std::cerr << "\rLUT353   ";
    Ciphertext gin353 = 2 * gout198 + gout280;
    Ciphertext gout353 = ctx.eval_lut(&gin353, nand2);
    std::cerr << "\rLUT354   ";
    Ciphertext gin354 = 2 * gout187 + gout273;
    Ciphertext gout354 = ctx.eval_lut(&gin354, nand2);
    std::cerr << "\rLUT355   ";
    Ciphertext gin355 = 2 * gout196 + gout276;
    Ciphertext gout355 = ctx.eval_lut(&gin355, nand2);
    std::cerr << "\rLUT356   ";
    Ciphertext gin356 = 2 * gout127 + gout275;
    Ciphertext gout356 = ctx.eval_lut(&gin356, and2);
    std::cerr << "\rLUT357   ";
    Ciphertext gin357 = 2 * gout295 + gout231;
    Ciphertext gout357 = ctx.eval_lut(&gin357, xnor2);
    std::cerr << "\rLUT358   ";
    Ciphertext gin358 = 2 * gout114 + gout286;
    Ciphertext gout358 = ctx.eval_lut(&gin358, and2);
    std::cerr << "\rLUT359   ";
    Ciphertext gin359 = 2 * ct_y11 + gout293;
    Ciphertext gout359 = ctx.eval_lut(&gin359, nand2);
    std::cerr << "\rLUT360   ";
    Ciphertext gin360 = 2 * ct_y0 + gout293;
    Ciphertext gout360 = ctx.eval_lut(&gin360, and2);
    std::cerr << "\rLUT361   ";
    Ciphertext gin361 = 2 * gout293 + gout223;
    Ciphertext gout361 = ctx.eval_lut(&gin361, and2);
    std::cerr << "\rLUT362   ";
    Ciphertext gin362 = 2 * gout235 + gout306;
    Ciphertext gout362 = ctx.eval_lut(&gin362, nand2);
    std::cerr << "\rLUT363   ";
    Ciphertext gin363 = 2 * gout216 + gout307;
    Ciphertext gout363 = ctx.eval_lut(&gin363, and2);
    std::cerr << "\rLUT364   ";
    Ciphertext gin364 = 2 * ct_y13 + gout293;
    Ciphertext gout364 = ctx.eval_lut(&gin364, and2);
    std::cerr << "\rLUT365   ";
    Ciphertext gin365 = 2 * gout297 + gout308;
    Ciphertext gout365 = ctx.eval_lut(&gin365, and2);
    std::cerr << "\rLUT366   ";
    Ciphertext gin366 = 2 * gout297 + gout308;
    Ciphertext gout366 = ctx.eval_lut(&gin366, xnor2);
    std::cerr << "\rLUT367   ";
    Ciphertext gin367 = 2 * gout181 + gout309;
    Ciphertext gout367 = ctx.eval_lut(&gin367, nand2);
    std::cerr << "\rLUT368   ";
    Ciphertext gin368 = 2 * gout250 + gout312;
    Ciphertext gout368 = ctx.eval_lut(&gin368, nand2);
    std::cerr << "\rLUT369   ";
    Ciphertext gin369 = 2 * gout275 + gout293;
    Ciphertext gout369 = ctx.eval_lut(&gin369, or2);
    std::cerr << "\rLUT370   ";
    Ciphertext gin370 = 2 * gout202 + gout283;
    Ciphertext gout370 = ctx.eval_lut(&gin370, nand2);
    std::cerr << "\rLUT371   ";
    Ciphertext gin371 = 2 * gout46 + gout281;
    Ciphertext gout371 = ctx.eval_lut(&gin371, xnor2);
    std::cerr << "\rLUT372   ";
    Ciphertext gin372 = 2 * ct_y14 + gout293;
    Ciphertext gout372 = ctx.eval_lut(&gin372, and2);
    std::cerr << "\rLUT373   ";
    Ciphertext gin373 = 2 * gout322 + gout318;
    Ciphertext gout373 = ctx.eval_lut(&gin373, xor2);
    std::cerr << "\rLUT374   ";
    Ciphertext gin374 = 2 * gout191 + gout330;
    Ciphertext gout374 = ctx.eval_lut(&gin374, nand2);
    std::cerr << "\rLUT375   ";
    Ciphertext gin375 = 2 * gout322 + gout318;
    Ciphertext gout375 = ctx.eval_lut(&gin375, nand2);
    std::cerr << "\rLUT376   ";
    Ciphertext gin376 = 2 * gout224 + gout301;
    Ciphertext gout376 = ctx.eval_lut(&gin376, nand2);
    std::cerr << "\rLUT377   ";
    Ciphertext gin377 = 2 * (1 - gout286) + gout293;
    Ciphertext gout377 = ctx.eval_lut(&gin377, and2);
    std::cerr << "\rLUT378   ";
    Ciphertext gin378 = 2 * (1 - gout210) + gout293;
    Ciphertext gout378 = ctx.eval_lut(&gin378, and2);
    std::cerr << "\rLUT379   ";
    Ciphertext gin379 = 2 * ct_y12 + gout293;
    Ciphertext gout379 = ctx.eval_lut(&gin379, nand2);
    std::cerr << "\rLUT380   ";
    Ciphertext gin380 = 2 * gout184 + gout326;
    Ciphertext gout380 = ctx.eval_lut(&gin380, nand2);
    std::cerr << "\rLUT381   ";
    Ciphertext gin381 = 2 * gout200 + gout329;
    Ciphertext gout381 = ctx.eval_lut(&gin381, nand2);
    std::cerr << "\rLUT382   ";
    Ciphertext gin382 = 2 * gout177 + gout320;
    Ciphertext gout382 = ctx.eval_lut(&gin382, nand2);
    std::cerr << "\rLUT383   ";
    Ciphertext gin383 = 2 * gout218 + gout324;
    Ciphertext gout383 = ctx.eval_lut(&gin383, and2);
    std::cerr << "\rLUT384   ";
    Ciphertext gin384 = 2 * gout368 + gout336;
    Ciphertext gout384 = ctx.eval_lut(&gin384, and2);
    std::cerr << "\rLUT385   ";
    Ciphertext gin385 = 2 * gout345 + gout258;
    Ciphertext gout385 = ctx.eval_lut(&gin385, xor2);
    std::cerr << "\rLUT386   ";
    Ciphertext gin386 = 2 * gout218 + gout324;
    Ciphertext gout386 = ctx.eval_lut(&gin386, xnor2);
    std::cerr << "\rLUT387   ";
    Ciphertext gin387 = 2 * gout368 + gout336;
    Ciphertext gout387 = ctx.eval_lut(&gin387, xnor2);
    std::cerr << "\rLUT388   ";
    Ciphertext gin388 = 2 * gout237 + gout337;
    Ciphertext gout388 = ctx.eval_lut(&gin388, nand2);
    std::cerr << "\rINV389   ";
    Ciphertext gout389 = 1 - gout339;

    std::cerr << "\rLUT390   ";
    Ciphertext gin390 = 2 * gout260 + gout331;
    Ciphertext gout390 = ctx.eval_lut(&gin390, nand2);
    std::cerr << "\rLUT391   ";
    Ciphertext gin391 = 2 * gout171 + gout302;
    Ciphertext gout391 = ctx.eval_lut(&gin391, nand2);
    std::cerr << "\rLUT392   ";
    Ciphertext gin392 = 2 * gout249 + gout325;
    Ciphertext gout392 = ctx.eval_lut(&gin392, and2);
    std::cerr << "\rLUT393   ";
    Ciphertext gin393 = 2 * gout338 + gout279;
    Ciphertext gout393 = ctx.eval_lut(&gin393, xnor2);
    std::cerr << "\rLUT394   ";
    Ciphertext gin394 = 2 * gout268 + gout333;
    Ciphertext gout394 = ctx.eval_lut(&gin394, and2);
    std::cerr << "\rLUT395   ";
    Ciphertext gin395 = 2 * gout305 + gout307;
    Ciphertext gout395 = ctx.eval_lut(&gin395, xnor2);
    std::cerr << "\rLUT396   ";
    Ciphertext gin396 = 2 * gout353 + gout344;
    Ciphertext gout396 = ctx.eval_lut(&gin396, xnor2);
    std::cerr << "\rLUT397   ";
    Ciphertext gin397 = 2 * gout251 + gout314;
    Ciphertext gout397 = ctx.eval_lut(&gin397, and2);
    std::cerr << "\rLUT398   ";
    Ciphertext gin398 = 2 * gout328 + gout291;
    Ciphertext gout398 = ctx.eval_lut(&gin398, and2);
    std::cerr << "\rLUT399   ";
    Ciphertext gin399 = 2 * gout345 + gout258;
    Ciphertext gout399 = ctx.eval_lut(&gin399, nand2);
    std::cerr << "\rLUT400   ";
    Ciphertext gin400 = 2 * gout209 + gout349;
    Ciphertext gout400 = ctx.eval_lut(&gin400, xor2);
    std::cerr << "\rLUT401   ";
    Ciphertext gin401 = 2 * gout234 + gout311;
    Ciphertext gout401 = ctx.eval_lut(&gin401, nand2);
    std::cerr << "\rLUT402   ";
    Ciphertext gin402 = 2 * gout189 + gout335;
    Ciphertext gout402 = ctx.eval_lut(&gin402, nand2);
    std::cerr << "\rLUT403   ";
    Ciphertext gin403 = 2 * gout332 + gout315;
    Ciphertext gout403 = ctx.eval_lut(&gin403, nand2);
    std::cerr << "\rLUT404   ";
    Ciphertext gin404 = 2 * gout328 + gout291;
    Ciphertext gout404 = ctx.eval_lut(&gin404, xnor2);
    std::cerr << "\rLUT405   ";
    Ciphertext gin405 = 2 * gout247 + gout321;
    Ciphertext gout405 = ctx.eval_lut(&gin405, nand2);
    std::cerr << "\rLUT406   ";
    Ciphertext gin406 = 2 * gout246 + gout319;
    Ciphertext gout406 = ctx.eval_lut(&gin406, nand2);
    std::cerr << "\rLUT407   ";
    Ciphertext gin407 = 2 * gout194 + gout342;
    Ciphertext gout407 = ctx.eval_lut(&gin407, nand2);
    std::cerr << "\rLUT408   ";
    Ciphertext gin408 = 2 * gout338 + gout279;
    Ciphertext gout408 = ctx.eval_lut(&gin408, and2);
    std::cerr << "\rLUT409   ";
    Ciphertext gin409 = 2 * gout348 + gout310;
    Ciphertext gout409 = ctx.eval_lut(&gin409, xnor2);
    std::cerr << "\rLUT410   ";
    Ciphertext gin410 = 2 * gout259 + gout327;
    Ciphertext gout410 = ctx.eval_lut(&gin410, nand2);
    std::cerr << "\rLUT411   ";
    Ciphertext gin411 = 2 * gout332 + gout315;
    Ciphertext gout411 = ctx.eval_lut(&gin411, xor2);
    std::cerr << "\rLUT412   ";
    Ciphertext gin412 = 2 * gout201 + gout351;
    Ciphertext gout412 = ctx.eval_lut(&gin412, nand2);
    std::cerr << "\rLUT413   ";
    Ciphertext gin413 = 2 * gout256 + gout347;
    Ciphertext gout413 = ctx.eval_lut(&gin413, xnor2);
    std::cerr << "\rLUT414   ";
    Ciphertext gin414 = 2 * gout348 + gout310;
    Ciphertext gout414 = ctx.eval_lut(&gin414, nand2);
    std::cerr << "\rLUT415   ";
    Ciphertext gin415 = 2 * gout209 + gout349;
    Ciphertext gout415 = ctx.eval_lut(&gin415, nand2);
    std::cerr << "\rLUT416   ";
    Ciphertext gin416 = 2 * gout353 + gout344;
    Ciphertext gout416 = ctx.eval_lut(&gin416, nand2);
    std::cerr << "\rLUT417   ";
    Ciphertext gin417 = 2 * (1 - gout358) + gout293;
    Ciphertext gout417 = ctx.eval_lut(&gin417, and2);
    std::cerr << "\rLUT418   ";
    Ciphertext gin418 = 2 * gout362 + gout278;
    Ciphertext gout418 = ctx.eval_lut(&gin418, xor2);
    std::cerr << "\rLUT419   ";
    Ciphertext gin419 = 2 * gout362 + gout278;
    Ciphertext gout419 = ctx.eval_lut(&gin419, nand2);
    std::cerr << "\rLUT420   ";
    Ciphertext gin420 = 2 * gout356 + gout84;
    Ciphertext gout420 = ctx.eval_lut(&gin420, or2);
    std::cerr << "\rLUT421   ";
    Ciphertext gin421 = 2 * gout356 + gout219;
    Ciphertext gout421 = ctx.eval_lut(&gin421, nand2);
    std::cerr << "\rLUT422   ";
    Ciphertext gin422 = 2 * gout62 + gout360;
    Ciphertext gout422 = ctx.eval_lut(&gin422, xnor2);
    std::cerr << "\rLUT423   ";
    Ciphertext gin423 = 2 * gout370 + gout272;
    Ciphertext gout423 = ctx.eval_lut(&gin423, nand2);
    std::cerr << "\rLUT424   ";
    Ciphertext gin424 = 2 * (1 - gout366) + gout230;
    Ciphertext gout424 = ctx.eval_lut(&gin424, and2);
    std::cerr << "\rLUT425   ";
    Ciphertext gin425 = 2 * gout167 + gout358;
    Ciphertext gout425 = ctx.eval_lut(&gin425, and2);
    std::cerr << "\rINV426   ";
    Ciphertext gout426 = 1 - gout356;

    std::cerr << "\rLUT427   ";
    Ciphertext gin427 = 2 * gout52 + gout361;
    Ciphertext gout427 = ctx.eval_lut(&gin427, xnor2);
    std::cerr << "\rLUT428   ";
    Ciphertext gin428 = 2 * gout354 + gout373;
    Ciphertext gout428 = ctx.eval_lut(&gin428, nand2);
    std::cerr << "\rLUT429   ";
    Ciphertext gin429 = 2 * gout118 + gout378;
    Ciphertext gout429 = ctx.eval_lut(&gin429, xnor2);
    std::cerr << "\rLUT430   ";
    Ciphertext gin430 = 2 * gout356 + gout147;
    Ciphertext gout430 = ctx.eval_lut(&gin430, nand2);
    std::cerr << "\rLUT431   ";
    Ciphertext gin431 = 2 * gout387 + gout317;
    Ciphertext gout431 = ctx.eval_lut(&gin431, xnor2);
    std::cerr << "\rLUT432   ";
    Ciphertext gin432 = 2 * gout370 + gout272;
    Ciphertext gout432 = ctx.eval_lut(&gin432, xor2);
    std::cerr << "\rLUT433   ";
    Ciphertext gin433 = 2 * gout374 + gout192;
    Ciphertext gout433 = ctx.eval_lut(&gin433, and2);
    std::cerr << "\rLUT434   ";
    Ciphertext gin434 = 2 * gout369 + gout420;
    Ciphertext gout434 = ctx.eval_lut(&gin434, and2);
    std::cerr << "\rLUT435   ";
    Ciphertext gin435 = 2 * gout381 + gout68;
    Ciphertext gout435 = ctx.eval_lut(&gin435, and2);
    std::cerr << "\rLUT436   ";
    Ciphertext gin436 = 2 * gout374 + gout192;
    Ciphertext gout436 = ctx.eval_lut(&gin436, xor2);
    std::cerr << "\rLUT437   ";
    Ciphertext gin437 = 2 * gout380 + gout271;
    Ciphertext gout437 = ctx.eval_lut(&gin437, nand2);
    std::cerr << "\rLUT438   ";
    Ciphertext gin438 = 2 * gout381 + gout68;
    Ciphertext gout438 = ctx.eval_lut(&gin438, xor2);
    std::cerr << "\rLUT439   ";
    Ciphertext gin439 = 2 * gout388 + gout313;
    Ciphertext gout439 = ctx.eval_lut(&gin439, nand2);
    std::cerr << "\rLUT440   ";
    Ciphertext gin440 = 2 * (1 - gout396) + gout316;
    Ciphertext gout440 = ctx.eval_lut(&gin440, and2);
    std::cerr << "\rLUT441   ";
    Ciphertext gin441 = 2 * (1 - gout387) + gout317;
    Ciphertext gout441 = ctx.eval_lut(&gin441, and2);
    std::cerr << "\rLUT442   ";
    Ciphertext gin442 = 2 * gout376 + gout385;
    Ciphertext gout442 = ctx.eval_lut(&gin442, xor2);
    std::cerr << "\rLUT443   ";
    Ciphertext gin443 = 2 * gout366 + gout230;
    Ciphertext gout443 = ctx.eval_lut(&gin443, xnor2);
    std::cerr << "\rLUT444   ";
    Ciphertext gin444 = 2 * gout401 + gout298;
    Ciphertext gout444 = ctx.eval_lut(&gin444, and2);
    std::cerr << "\rLUT445   ";
    Ciphertext gin445 = 2 * gout382 + gout285;
    Ciphertext gout445 = ctx.eval_lut(&gin445, and2);
    std::cerr << "\rLUT446   ";
    Ciphertext gin446 = 2 * gout380 + gout271;
    Ciphertext gout446 = ctx.eval_lut(&gin446, xor2);
    std::cerr << "\rLUT447   ";
    Ciphertext gin447 = 2 * gout391 + gout292;
    Ciphertext gout447 = ctx.eval_lut(&gin447, xnor2);
    std::cerr << "\rLUT448   ";
    Ciphertext gin448 = 2 * gout376 + gout385;
    Ciphertext gout448 = ctx.eval_lut(&gin448, nand2);
    std::cerr << "\rLUT449   ";
    Ciphertext gin449 = 2 * gout404 + gout343;
    Ciphertext gout449 = ctx.eval_lut(&gin449, xnor2);
    std::cerr << "\rLUT450   ";
    Ciphertext gin450 = 2 * (1 - gout404) + gout343;
    Ciphertext gout450 = ctx.eval_lut(&gin450, and2);
    std::cerr << "\rLUT451   ";
    Ciphertext gin451 = 2 * gout270 + gout400;
    Ciphertext gout451 = ctx.eval_lut(&gin451, xnor2);
    std::cerr << "\rLUT452   ";
    Ciphertext gin452 = 2 * gout369 + gout421;
    Ciphertext gout452 = ctx.eval_lut(&gin452, and2);
    std::cerr << "\rLUT453   ";
    Ciphertext gin453 = 2 * gout354 + gout373;
    Ciphertext gout453 = ctx.eval_lut(&gin453, xor2);
    std::cerr << "\rLUT454   ";
    Ciphertext gin454 = 2 * (1 - gout393) + gout341;
    Ciphertext gout454 = ctx.eval_lut(&gin454, and2);
    std::cerr << "\rLUT455   ";
    Ciphertext gin455 = 2 * gout410 + gout294;
    Ciphertext gout455 = ctx.eval_lut(&gin455, and2);
    std::cerr << "\rLUT456   ";
    Ciphertext gin456 = 2 * gout114 + gout377;
    Ciphertext gout456 = ctx.eval_lut(&gin456, xnor2);
    std::cerr << "\rLUT457   ";
    Ciphertext gin457 = 2 * gout393 + gout341;
    Ciphertext gout457 = ctx.eval_lut(&gin457, xnor2);
    std::cerr << "\rLUT458   ";
    Ciphertext gin458 = 2 * gout157 + gout400;
    Ciphertext gout458 = ctx.eval_lut(&gin458, nand2);
    std::cerr << "\rLUT459   ";
    Ciphertext gin459 = 2 * gout391 + gout292;
    Ciphertext gout459 = ctx.eval_lut(&gin459, and2);
    std::cerr << "\rLUT460   ";
    Ciphertext gin460 = 2 * gout397 + gout244;
    Ciphertext gout460 = ctx.eval_lut(&gin460, xnor2);
    std::cerr << "\rLUT461   ";
    Ciphertext gin461 = 2 * gout355 + gout411;
    Ciphertext gout461 = ctx.eval_lut(&gin461, xor2);
    std::cerr << "\rLUT462   ";
    Ciphertext gin462 = 2 * gout401 + gout298;
    Ciphertext gout462 = ctx.eval_lut(&gin462, xnor2);
    std::cerr << "\rLUT463   ";
    Ciphertext gin463 = 2 * gout409 + gout300;
    Ciphertext gout463 = ctx.eval_lut(&gin463, xnor2);
    std::cerr << "\rLUT464   ";
    Ciphertext gin464 = 2 * gout151 + gout394;
    Ciphertext gout464 = ctx.eval_lut(&gin464, xnor2);
    std::cerr << "\rLUT465   ";
    Ciphertext gin465 = 2 * gout412 + gout299;
    Ciphertext gout465 = ctx.eval_lut(&gin465, nand2);
    std::cerr << "\rLUT466   ";
    Ciphertext gin466 = 2 * (1 - gout409) + gout300;
    Ciphertext gout466 = ctx.eval_lut(&gin466, and2);
    std::cerr << "\rLUT467   ";
    Ciphertext gin467 = 2 * gout161 + gout392;
    Ciphertext gout467 = ctx.eval_lut(&gin467, xnor2);
    std::cerr << "\rLUT468   ";
    Ciphertext gin468 = 2 * gout382 + gout285;
    Ciphertext gout468 = ctx.eval_lut(&gin468, xnor2);
    std::cerr << "\rLUT469   ";
    Ciphertext gin469 = 2 * gout405 + gout267;
    Ciphertext gout469 = ctx.eval_lut(&gin469, xnor2);
    std::cerr << "\rLUT470   ";
    Ciphertext gin470 = 2 * gout388 + gout313;
    Ciphertext gout470 = ctx.eval_lut(&gin470, xor2);
    std::cerr << "\rLUT471   ";
    Ciphertext gin471 = 2 * gout407 + gout350;
    Ciphertext gout471 = ctx.eval_lut(&gin471, xnor2);
    std::cerr << "\rLUT472   ";
    Ciphertext gin472 = 2 * gout396 + gout316;
    Ciphertext gout472 = ctx.eval_lut(&gin472, xnor2);
    std::cerr << "\rLUT473   ";
    Ciphertext gin473 = 2 * gout410 + gout294;
    Ciphertext gout473 = ctx.eval_lut(&gin473, xnor2);
    std::cerr << "\rLUT474   ";
    Ciphertext gin474 = 2 * gout402 + gout303;
    Ciphertext gout474 = ctx.eval_lut(&gin474, and2);
    std::cerr << "\rLUT475   ";
    Ciphertext gin475 = 2 * gout412 + gout299;
    Ciphertext gout475 = ctx.eval_lut(&gin475, xor2);
    std::cerr << "\rLUT476   ";
    Ciphertext gin476 = 2 * gout402 + gout303;
    Ciphertext gout476 = ctx.eval_lut(&gin476, xnor2);
    std::cerr << "\rLUT477   ";
    Ciphertext gin477 = 2 * gout407 + gout350;
    Ciphertext gout477 = ctx.eval_lut(&gin477, and2);
    std::cerr << "\rLUT478   ";
    Ciphertext gin478 = 2 * gout415 + gout458;
    Ciphertext gout478 = ctx.eval_lut(&gin478, nand2);
    std::cerr << "\rLUT479   ";
    Ciphertext gin479 = 2 * gout405 + gout267;
    Ciphertext gout479 = ctx.eval_lut(&gin479, and2);
    std::cerr << "\rLUT480   ";
    Ciphertext gin480 = 2 * gout416 + (1 - gout440);
    Ciphertext gout480 = ctx.eval_lut(&gin480, and2);
    std::cerr << "\rLUT481   ";
    Ciphertext gin481 = 2 * gout355 + gout411;
    Ciphertext gout481 = ctx.eval_lut(&gin481, nand2);
    std::cerr << "\rLUT482   ";
    Ciphertext gin482 = 2 * gout185 + gout418;
    Ciphertext gout482 = ctx.eval_lut(&gin482, xor2);
    std::cerr << "\rLUT483   ";
    Ciphertext gin483 = 2 * gout185 + gout418;
    Ciphertext gout483 = ctx.eval_lut(&gin483, nand2);
    std::cerr << "\rLUT484   ";
    Ciphertext gin484 = 2 * gout79 + gout422;
    Ciphertext gout484 = ctx.eval_lut(&gin484, xnor2);
    std::cerr << "\rLUT485   ";
    Ciphertext gin485 = 2 * gout167 + gout417;
    Ciphertext gout485 = ctx.eval_lut(&gin485, xnor2);
    std::cerr << "\rLUT486   ";
    Ciphertext gin486 = 2 * gout75 + gout427;
    Ciphertext gout486 = ctx.eval_lut(&gin486, xnor2);
    std::cerr << "\rLUT487   ";
    Ciphertext gin487 = 2 * ct_x1 + gout422;
    Ciphertext gout487 = ctx.eval_lut(&gin487, nand2);
    std::cerr << "\rLUT488   ";
    Ciphertext gin488 = 2 * ct_x2 + gout427;
    Ciphertext gout488 = ctx.eval_lut(&gin488, nand2);
    std::cerr << "\rLUT489   ";
    Ciphertext gin489 = 2 * gout154 + gout429;
    Ciphertext gout489 = ctx.eval_lut(&gin489, xnor2);
    std::cerr << "\rLUT490   ";
    Ciphertext gin490 = 2 * gout384 + gout441;
    Ciphertext gout490 = ctx.eval_lut(&gin490, or2);
    std::cerr << "\rLUT491   ";
    Ciphertext gin491 = 2 * (1 - gout425) + gout293;
    Ciphertext gout491 = ctx.eval_lut(&gin491, and2);
    std::cerr << "\rLUT492   ";
    Ciphertext gin492 = 2 * gout166 + gout425;
    Ciphertext gout492 = ctx.eval_lut(&gin492, and2);
    std::cerr << "\rLUT493   ";
    Ciphertext gin493 = 2 * ct_x3 + gout429;
    Ciphertext gout493 = ctx.eval_lut(&gin493, nand2);
    std::cerr << "\rLUT494   ";
    Ciphertext gin494 = 2 * gout367 + gout432;
    Ciphertext gout494 = ctx.eval_lut(&gin494, xor2);
    std::cerr << "\rLUT495   ";
    Ciphertext gin495 = 2 * gout375 + gout428;
    Ciphertext gout495 = ctx.eval_lut(&gin495, nand2);
    std::cerr << "\rLUT496   ";
    Ciphertext gin496 = 2 * gout339 + gout451;
    Ciphertext gout496 = ctx.eval_lut(&gin496, and2);
    std::cerr << "\rLUT497   ";
    Ciphertext gin497 = 2 * gout365 + gout424;
    Ciphertext gout497 = ctx.eval_lut(&gin497, or2);
    std::cerr << "\rLUT498   ";
    Ciphertext gin498 = 2 * gout430 + gout434;
    Ciphertext gout498 = ctx.eval_lut(&gin498, nand2);
    std::cerr << "\rLUT499   ";
    Ciphertext gin499 = 2 * gout398 + gout450;
    Ciphertext gout499 = ctx.eval_lut(&gin499, or2);
    std::cerr << "\rLUT500   ";
    Ciphertext gin500 = 2 * gout367 + gout432;
    Ciphertext gout500 = ctx.eval_lut(&gin500, nand2);
    std::cerr << "\rLUT501   ";
    Ciphertext gin501 = 2 * gout464 + gout460;
    Ciphertext gout501 = ctx.eval_lut(&gin501, xnor2);
    std::cerr << "\rLUT502   ";
    Ciphertext gin502 = 2 * gout462 + gout340;
    Ciphertext gout502 = ctx.eval_lut(&gin502, xnor2);
    std::cerr << "\rLUT503   ";
    Ciphertext gin503 = 2 * gout389 + gout451;
    Ciphertext gout503 = ctx.eval_lut(&gin503, xnor2);
    std::cerr << "\rLUT504   ";
    Ciphertext gin504 = 2 * gout399 + gout448;
    Ciphertext gout504 = ctx.eval_lut(&gin504, and2);
    std::cerr << "\rLUT505   ";
    Ciphertext gin505 = 2 * gout447 + gout274;
    Ciphertext gout505 = ctx.eval_lut(&gin505, xnor2);
    std::cerr << "\rLUT506   ";
    Ciphertext gin506 = 2 * gout390 + gout470;
    Ciphertext gout506 = ctx.eval_lut(&gin506, xor2);
    std::cerr << "\rLUT507   ";
    Ciphertext gin507 = 2 * gout408 + gout454;
    Ciphertext gout507 = ctx.eval_lut(&gin507, or2);
    std::cerr << "\rLUT508   ";
    Ciphertext gin508 = 2 * (1 - gout447) + gout274;
    Ciphertext gout508 = ctx.eval_lut(&gin508, and2);
    std::cerr << "\rLUT509   ";
    Ciphertext gin509 = 2 * (1 - gout471) + gout346;
    Ciphertext gout509 = ctx.eval_lut(&gin509, and2);
    std::cerr << "\rLUT510   ";
    Ciphertext gin510 = 2 * gout471 + gout346;
    Ciphertext gout510 = ctx.eval_lut(&gin510, xnor2);
    std::cerr << "\rLUT511   ";
    Ciphertext gin511 = 2 * gout13 + gout456;
    Ciphertext gout511 = ctx.eval_lut(&gin511, xnor2);
    std::cerr << "\rLUT512   ";
    Ciphertext gin512 = 2 * gout54 + gout446;
    Ciphertext gout512 = ctx.eval_lut(&gin512, nand2);
    std::cerr << "\rLUT513   ";
    Ciphertext gin513 = 2 * (1 - gout476) + gout323;
    Ciphertext gout513 = ctx.eval_lut(&gin513, and2);
    std::cerr << "\rLUT514   ";
    Ciphertext gin514 = 2 * gout186 + gout446;
    Ciphertext gout514 = ctx.eval_lut(&gin514, xnor2);
    std::cerr << "\rLUT515   ";
    Ciphertext gin515 = 2 * gout469 + gout288;
    Ciphertext gout515 = ctx.eval_lut(&gin515, xnor2);
    std::cerr << "\rLUT516   ";
    Ciphertext gin516 = 2 * (1 - gout469) + gout288;
    Ciphertext gout516 = ctx.eval_lut(&gin516, and2);
    std::cerr << "\rLUT517   ";
    Ciphertext gin517 = 2 * gout476 + gout323;
    Ciphertext gout517 = ctx.eval_lut(&gin517, xnor2);
    std::cerr << "\rLUT518   ";
    Ciphertext gin518 = 2 * gout468 + gout290;
    Ciphertext gout518 = ctx.eval_lut(&gin518, xnor2);
    std::cerr << "\rLUT519   ";
    Ciphertext gin519 = 2 * gout390 + gout470;
    Ciphertext gout519 = ctx.eval_lut(&gin519, nand2);
    std::cerr << "\rLUT520   ";
    Ciphertext gin520 = 2 * (1 - gout462) + gout340;
    Ciphertext gout520 = ctx.eval_lut(&gin520, and2);
    std::cerr << "\rLUT521   ";
    Ciphertext gin521 = 2 * gout480 + gout334;
    Ciphertext gout521 = ctx.eval_lut(&gin521, xnor2);
    std::cerr << "\rLUT522   ";
    Ciphertext gin522 = 2 * gout414 + (1 - gout466);
    Ciphertext gout522 = ctx.eval_lut(&gin522, and2);
    std::cerr << "\rLUT523   ";
    Ciphertext gin523 = 2 * ct_x4 + gout456;
    Ciphertext gout523 = ctx.eval_lut(&gin523, nand2);
    std::cerr << "\rLUT524   ";
    Ciphertext gin524 = 2 * gout473 + gout261;
    Ciphertext gout524 = ctx.eval_lut(&gin524, xnor2);
    std::cerr << "\rLUT525   ";
    Ciphertext gin525 = 2 * (1 - gout468) + gout290;
    Ciphertext gout525 = ctx.eval_lut(&gin525, and2);
    std::cerr << "\rLUT526   ";
    Ciphertext gin526 = 2 * gout371 + gout467;
    Ciphertext gout526 = ctx.eval_lut(&gin526, xnor2);
    std::cerr << "\rLUT527   ";
    Ciphertext gin527 = 2 * (1 - gout473) + gout261;
    Ciphertext gout527 = ctx.eval_lut(&gin527, and2);
    std::cerr << "\rLUT528   ";
    Ciphertext gin528 = 2 * gout406 + gout475;
    Ciphertext gout528 = ctx.eval_lut(&gin528, xor2);
    std::cerr << "\rLUT529   ";
    Ciphertext gin529 = 2 * gout403 + gout481;
    Ciphertext gout529 = ctx.eval_lut(&gin529, nand2);
    std::cerr << "\rLUT530   ";
    Ciphertext gin530 = 2 * gout406 + gout475;
    Ciphertext gout530 = ctx.eval_lut(&gin530, nand2);
    std::cerr << "\rLUT531   ";
    Ciphertext gin531 = 2 * gout419 + gout483;
    Ciphertext gout531 = ctx.eval_lut(&gin531, nand2);
    std::cerr << "\rLUT532   ";
    Ciphertext gin532 = 2 * gout69 + gout485;
    Ciphertext gout532 = ctx.eval_lut(&gin532, xnor2);
    std::cerr << "\rLUT533   ";
    Ciphertext gin533 = 2 * gout147 + gout484;
    Ciphertext gout533 = ctx.eval_lut(&gin533, nand2);
    std::cerr << "\rLUT534   ";
    Ciphertext gin534 = 2 * gout254 + gout484;
    Ciphertext gout534 = ctx.eval_lut(&gin534, xnor2);
    std::cerr << "\rLUT535   ";
    Ciphertext gin535 = 2 * ct_x5 + gout485;
    Ciphertext gout535 = ctx.eval_lut(&gin535, nand2);
    std::cerr << "\rLUT536   ";
    Ciphertext gin536 = 2 * gout166 + gout491;
    Ciphertext gout536 = ctx.eval_lut(&gin536, xnor2);
    std::cerr << "\rLUT537   ";
    Ciphertext gin537 = 2 * gout499 + gout431;
    Ciphertext gout537 = ctx.eval_lut(&gin537, and2);
    std::cerr << "\rLUT538   ";
    Ciphertext gin538 = 2 * gout499 + gout431;
    Ciphertext gout538 = ctx.eval_lut(&gin538, xnor2);
    std::cerr << "\rLUT539   ";
    Ciphertext gin539 = 2 * gout383 + gout503;
    Ciphertext gout539 = ctx.eval_lut(&gin539, xnor2);
    std::cerr << "\rLUT540   ";
    Ciphertext gin540 = 2 * gout495 + gout443;
    Ciphertext gout540 = ctx.eval_lut(&gin540, nand2);
    std::cerr << "\rINV541   ";
    Ciphertext gout541 = 1 - gout496;

    std::cerr << "\rLUT542   ";
    Ciphertext gin542 = 2 * gout495 + gout443;
    Ciphertext gout542 = ctx.eval_lut(&gin542, xor2);
    std::cerr << "\rLUT543   ";
    Ciphertext gin543 = 2 * gout507 + gout505;
    Ciphertext gout543 = ctx.eval_lut(&gin543, xnor2);
    std::cerr << "\rLUT544   ";
    Ciphertext gin544 = 2 * gout459 + gout508;
    Ciphertext gout544 = ctx.eval_lut(&gin544, or2);
    std::cerr << "\rLUT545   ";
    Ciphertext gin545 = 2 * (1 - gout492) + gout293;
    Ciphertext gout545 = ctx.eval_lut(&gin545, and2);
    std::cerr << "\rLUT546   ";
    Ciphertext gin546 = 2 * gout477 + gout509;
    Ciphertext gout546 = ctx.eval_lut(&gin546, or2);
    std::cerr << "\rLUT547   ";
    Ciphertext gin547 = 2 * gout89 + gout492;
    Ciphertext gout547 = ctx.eval_lut(&gin547, and2);
    std::cerr << "\rLUT548   ";
    Ciphertext gin548 = 2 * gout474 + gout513;
    Ciphertext gout548 = ctx.eval_lut(&gin548, or2);
    std::cerr << "\rLUT549   ";
    Ciphertext gin549 = 2 * gout383 + gout503;
    Ciphertext gout549 = ctx.eval_lut(&gin549, nand2);
    std::cerr << "\rLUT550   ";
    Ciphertext gin550 = 2 * gout490 + gout517;
    Ciphertext gout550 = ctx.eval_lut(&gin550, xnor2);
    std::cerr << "\rLUT551   ";
    Ciphertext gin551 = 2 * gout490 + gout517;
    Ciphertext gout551 = ctx.eval_lut(&gin551, and2);
    std::cerr << "\rLUT552   ";
    Ciphertext gin552 = 2 * gout507 + gout505;
    Ciphertext gout552 = ctx.eval_lut(&gin552, and2);
    std::cerr << "\rLUT553   ";
    Ciphertext gin553 = 2 * gout544 + gout510;
    Ciphertext gout553 = ctx.eval_lut(&gin553, and2);
    std::cerr << "\rLUT554   ";
    Ciphertext gin554 = 2 * gout479 + gout516;
    Ciphertext gout554 = ctx.eval_lut(&gin554, or2);
    std::cerr << "\rLUT555   ";
    Ciphertext gin555 = 2 * gout544 + gout510;
    Ciphertext gout555 = ctx.eval_lut(&gin555, xnor2);
    std::cerr << "\rLUT556   ";
    Ciphertext gin556 = 2 * gout413 + gout501;
    Ciphertext gout556 = ctx.eval_lut(&gin556, xnor2);
    std::cerr << "\rLUT557   ";
    Ciphertext gin557 = 2 * gout423 + gout500;
    Ciphertext gout557 = ctx.eval_lut(&gin557, nand2);
    std::cerr << "\rLUT558   ";
    Ciphertext gin558 = 2 * gout444 + gout520;
    Ciphertext gout558 = ctx.eval_lut(&gin558, or2);
    std::cerr << "\rLUT559   ";
    Ciphertext gin559 = 2 * gout478 + gout524;
    Ciphertext gout559 = ctx.eval_lut(&gin559, and2);
    std::cerr << "\rLUT560   ";
    Ciphertext gin560 = 2 * gout439 + gout519;
    Ciphertext gout560 = ctx.eval_lut(&gin560, nand2);
    std::cerr << "\rLUT561   ";
    Ciphertext gin561 = 2 * gout465 + gout530;
    Ciphertext gout561 = ctx.eval_lut(&gin561, nand2);
    std::cerr << "\rLUT562   ";
    Ciphertext gin562 = 2 * gout437 + gout512;
    Ciphertext gout562 = ctx.eval_lut(&gin562, nand2);
    std::cerr << "\rLUT563   ";
    Ciphertext gin563 = 2 * gout529 + gout233;
    Ciphertext gout563 = ctx.eval_lut(&gin563, and2);
    std::cerr << "\rLUT564   ";
    Ciphertext gin564 = 2 * gout504 + gout526;
    Ciphertext gout564 = ctx.eval_lut(&gin564, xnor2);
    std::cerr << "\rLUT565   ";
    Ciphertext gin565 = 2 * gout445 + gout525;
    Ciphertext gout565 = ctx.eval_lut(&gin565, or2);
    std::cerr << "\rLUT566   ";
    Ciphertext gin566 = 2 * gout478 + gout524;
    Ciphertext gout566 = ctx.eval_lut(&gin566, xor2);
    std::cerr << "\rLUT567   ";
    Ciphertext gin567 = 2 * gout529 + gout233;
    Ciphertext gout567 = ctx.eval_lut(&gin567, xor2);
    std::cerr << "\rLUT568   ";
    Ciphertext gin568 = 2 * gout455 + gout527;
    Ciphertext gout568 = ctx.eval_lut(&gin568, or2);
    std::cerr << "\rLUT569   ";
    Ciphertext gin569 = 2 * gout531 + gout81;
    Ciphertext gout569 = ctx.eval_lut(&gin569, and2);
    std::cerr << "\rLUT570   ";
    Ciphertext gin570 = 2 * gout426 + gout534;
    Ciphertext gout570 = ctx.eval_lut(&gin570, nand2);
    std::cerr << "\rLUT571   ";
    Ciphertext gin571 = 2 * gout487 + gout533;
    Ciphertext gout571 = ctx.eval_lut(&gin571, nand2);
    std::cerr << "\rLUT572   ";
    Ciphertext gin572 = 2 * gout531 + gout81;
    Ciphertext gout572 = ctx.eval_lut(&gin572, xor2);
    std::cerr << "\rLUT573   ";
    Ciphertext gin573 = 2 * gout106 + gout536;
    Ciphertext gout573 = ctx.eval_lut(&gin573, xnor2);
    std::cerr << "\rLUT574   ";
    Ciphertext gin574 = 2 * gout570 + gout452;
    Ciphertext gout574 = ctx.eval_lut(&gin574, nand2);
    std::cerr << "\rLUT575   ";
    Ciphertext gin575 = 2 * ct_x6 + gout536;
    Ciphertext gout575 = ctx.eval_lut(&gin575, nand2);
    std::cerr << "\rLUT576   ";
    Ciphertext gin576 = 2 * (1 - gout538) + gout438;
    Ciphertext gout576 = ctx.eval_lut(&gin576, and2);
    std::cerr << "\rLUT577   ";
    Ciphertext gin577 = 2 * gout538 + gout438;
    Ciphertext gout577 = ctx.eval_lut(&gin577, xnor2);
    std::cerr << "\rLUT578   ";
    Ciphertext gin578 = 2 * gout89 + gout545;
    Ciphertext gout578 = ctx.eval_lut(&gin578, xnor2);
    std::cerr << "\rLUT579   ";
    Ciphertext gin579 = 2 * gout555 + gout494;
    Ciphertext gout579 = ctx.eval_lut(&gin579, xnor2);
    std::cerr << "\rLUT580   ";
    Ciphertext gin580 = 2 * gout521 + gout556;
    Ciphertext gout580 = ctx.eval_lut(&gin580, xnor2);
    std::cerr << "\rLUT581   ";
    Ciphertext gin581 = 2 * gout546 + gout502;
    Ciphertext gout581 = ctx.eval_lut(&gin581, and2);
    std::cerr << "\rLUT582   ";
    Ciphertext gin582 = 2 * gout546 + gout502;
    Ciphertext gout582 = ctx.eval_lut(&gin582, xnor2);
    std::cerr << "\rLUT583   ";
    Ciphertext gin583 = 2 * (1 - gout547) + gout293;
    Ciphertext gout583 = ctx.eval_lut(&gin583, and2);
    std::cerr << "\rLUT584   ";
    Ciphertext gin584 = 2 * gout73 + gout547;
    Ciphertext gout584 = ctx.eval_lut(&gin584, and2);
    std::cerr << "\rLUT585   ";
    Ciphertext gin585 = 2 * gout554 + gout457;
    Ciphertext gout585 = ctx.eval_lut(&gin585, and2);
    std::cerr << "\rLUT586   ";
    Ciphertext gin586 = 2 * gout548 + gout515;
    Ciphertext gout586 = ctx.eval_lut(&gin586, and2);
    std::cerr << "\rLUT587   ";
    Ciphertext gin587 = 2 * (1 - gout543) + gout506;
    Ciphertext gout587 = ctx.eval_lut(&gin587, and2);
    std::cerr << "\rLUT588   ";
    Ciphertext gin588 = 2 * gout554 + gout457;
    Ciphertext gout588 = ctx.eval_lut(&gin588, xnor2);
    std::cerr << "\rLUT589   ";
    Ciphertext gin589 = 2 * gout548 + gout515;
    Ciphertext gout589 = ctx.eval_lut(&gin589, xnor2);
    std::cerr << "\rLUT590   ";
    Ciphertext gin590 = 2 * gout543 + gout506;
    Ciphertext gout590 = ctx.eval_lut(&gin590, xnor2);
    std::cerr << "\rLUT591   ";
    Ciphertext gin591 = 2 * gout541 + gout549;
    Ciphertext gout591 = ctx.eval_lut(&gin591, nand2);
    std::cerr << "\rLUT592   ";
    Ciphertext gin592 = 2 * (1 - gout550) + gout436;
    Ciphertext gout592 = ctx.eval_lut(&gin592, and2);
    std::cerr << "\rLUT593   ";
    Ciphertext gin593 = 2 * gout557 + gout514;
    Ciphertext gout593 = ctx.eval_lut(&gin593, xor2);
    std::cerr << "\rLUT594   ";
    Ciphertext gin594 = 2 * gout557 + gout514;
    Ciphertext gout594 = ctx.eval_lut(&gin594, nand2);
    std::cerr << "\rLUT595   ";
    Ciphertext gin595 = 2 * gout558 + gout518;
    Ciphertext gout595 = ctx.eval_lut(&gin595, and2);
    std::cerr << "\rLUT596   ";
    Ciphertext gin596 = 2 * gout558 + gout518;
    Ciphertext gout596 = ctx.eval_lut(&gin596, xnor2);
    std::cerr << "\rLUT597   ";
    Ciphertext gin597 = 2 * gout562 + gout542;
    Ciphertext gout597 = ctx.eval_lut(&gin597, xor2);
    std::cerr << "\rLUT598   ";
    Ciphertext gin598 = 2 * gout550 + gout436;
    Ciphertext gout598 = ctx.eval_lut(&gin598, xnor2);
    std::cerr << "\rLUT599   ";
    Ciphertext gin599 = 2 * (1 - gout555) + gout494;
    Ciphertext gout599 = ctx.eval_lut(&gin599, and2);
    std::cerr << "\rLUT600   ";
    Ciphertext gin600 = 2 * gout496 + gout566;
    Ciphertext gout600 = ctx.eval_lut(&gin600, and2);
    std::cerr << "\rLUT601   ";
    Ciphertext gin601 = 2 * gout564 + gout522;
    Ciphertext gout601 = ctx.eval_lut(&gin601, xnor2);
    std::cerr << "\rLUT602   ";
    Ciphertext gin602 = 2 * (1 - gout549) + gout566;
    Ciphertext gout602 = ctx.eval_lut(&gin602, and2);
    std::cerr << "\rLUT603   ";
    Ciphertext gin603 = 2 * gout568 + gout449;
    Ciphertext gout603 = ctx.eval_lut(&gin603, nand2);
    std::cerr << "\rLUT604   ";
    Ciphertext gin604 = 2 * gout560 + gout395;
    Ciphertext gout604 = ctx.eval_lut(&gin604, xor2);
    std::cerr << "\rLUT605   ";
    Ciphertext gin605 = 2 * gout568 + gout449;
    Ciphertext gout605 = ctx.eval_lut(&gin605, xor2);
    std::cerr << "\rLUT606   ";
    Ciphertext gin606 = 2 * gout565 + gout472;
    Ciphertext gout606 = ctx.eval_lut(&gin606, xnor2);
    std::cerr << "\rLUT607   ";
    Ciphertext gin607 = 2 * gout560 + gout395;
    Ciphertext gout607 = ctx.eval_lut(&gin607, and2);
    std::cerr << "\rLUT608   ";
    Ciphertext gin608 = 2 * gout562 + gout542;
    Ciphertext gout608 = ctx.eval_lut(&gin608, nand2);
    std::cerr << "\rLUT609   ";
    Ciphertext gin609 = 2 * gout561 + gout463;
    Ciphertext gout609 = ctx.eval_lut(&gin609, nand2);
    std::cerr << "\rLUT610   ";
    Ciphertext gin610 = 2 * gout566 + gout591;
    Ciphertext gout610 = ctx.eval_lut(&gin610, xnor2);
    std::cerr << "\rLUT611   ";
    Ciphertext gin611 = 2 * gout561 + gout463;
    Ciphertext gout611 = ctx.eval_lut(&gin611, xor2);
    std::cerr << "\rLUT612   ";
    Ciphertext gin612 = 2 * gout565 + gout472;
    Ciphertext gout612 = ctx.eval_lut(&gin612, and2);
    std::cerr << "\rLUT613   ";
    Ciphertext gin613 = 2 * gout537 + gout576;
    Ciphertext gout613 = ctx.eval_lut(&gin613, or2);
    std::cerr << "\rLUT614   ";
    Ciphertext gin614 = 2 * gout571 + gout486;
    Ciphertext gout614 = ctx.eval_lut(&gin614, nand2);
    std::cerr << "\rLUT615   ";
    Ciphertext gin615 = 2 * gout571 + gout486;
    Ciphertext gout615 = ctx.eval_lut(&gin615, xnor2);
    std::cerr << "\rLUT616   ";
    Ciphertext gin616 = 2 * gout95 + gout578;
    Ciphertext gout616 = ctx.eval_lut(&gin616, xnor2);
    std::cerr << "\rLUT617   ";
    Ciphertext gin617 = 2 * ct_x7 + gout578;
    Ciphertext gout617 = ctx.eval_lut(&gin617, nand2);
    std::cerr << "\rLUT618   ";
    Ciphertext gin618 = 2 * (1 - gout584) + gout293;
    Ciphertext gout618 = ctx.eval_lut(&gin618, and2);
    std::cerr << "\rLUT619   ";
    Ciphertext gin619 = 2 * gout589 + gout482;
    Ciphertext gout619 = ctx.eval_lut(&gin619, xnor2);
    std::cerr << "\rLUT620   ";
    Ciphertext gin620 = 2 * gout99 + gout584;
    Ciphertext gout620 = ctx.eval_lut(&gin620, and2);
    std::cerr << "\rLUT621   ";
    Ciphertext gin621 = 2 * (1 - gout596) + gout528;
    Ciphertext gout621 = ctx.eval_lut(&gin621, and2);
    std::cerr << "\rINV622   ";
    Ciphertext gout622 = 1 - gout577;

    std::cerr << "\rLUT623   ";
    Ciphertext gin623 = 2 * gout363 + gout593;
    Ciphertext gout623 = ctx.eval_lut(&gin623, nand2);
    std::cerr << "\rLUT624   ";
    Ciphertext gin624 = 2 * gout551 + gout592;
    Ciphertext gout624 = ctx.eval_lut(&gin624, or2);
    std::cerr << "\rLUT625   ";
    Ciphertext gin625 = 2 * gout588 + gout461;
    Ciphertext gout625 = ctx.eval_lut(&gin625, xnor2);
    std::cerr << "\rLUT626   ";
    Ciphertext gin626 = 2 * (1 - gout588) + gout461;
    Ciphertext gout626 = ctx.eval_lut(&gin626, and2);
    std::cerr << "\rLUT627   ";
    Ciphertext gin627 = 2 * gout73 + gout583;
    Ciphertext gout627 = ctx.eval_lut(&gin627, xnor2);
    std::cerr << "\rLUT628   ";
    Ciphertext gin628 = 2 * gout559 + gout600;
    Ciphertext gout628 = ctx.eval_lut(&gin628, or2);
    std::cerr << "\rLUT629   ";
    Ciphertext gin629 = 2 * (1 - gout582) + gout453;
    Ciphertext gout629 = ctx.eval_lut(&gin629, and2);
    std::cerr << "\rLUT630   ";
    Ciphertext gin630 = 2 * gout582 + gout453;
    Ciphertext gout630 = ctx.eval_lut(&gin630, xnor2);
    std::cerr << "\rLUT631   ";
    Ciphertext gin631 = 2 * gout553 + gout599;
    Ciphertext gout631 = ctx.eval_lut(&gin631, or2);
    std::cerr << "\rLUT632   ";
    Ciphertext gin632 = 2 * gout613 + gout598;
    Ciphertext gout632 = ctx.eval_lut(&gin632, xor2);
    std::cerr << "\rLUT633   ";
    Ciphertext gin633 = 2 * gout552 + gout587;
    Ciphertext gout633 = ctx.eval_lut(&gin633, or2);
    std::cerr << "\rLUT634   ";
    Ciphertext gin634 = 2 * (1 - gout589) + gout482;
    Ciphertext gout634 = ctx.eval_lut(&gin634, and2);
    std::cerr << "\rLUT635   ";
    Ciphertext gin635 = 2 * gout262 + gout605;
    Ciphertext gout635 = ctx.eval_lut(&gin635, nand2);
    std::cerr << "\rLUT636   ";
    Ciphertext gin636 = 2 * gout596 + gout528;
    Ciphertext gout636 = ctx.eval_lut(&gin636, xnor2);
    std::cerr << "\rLUT637   ";
    Ciphertext gin637 = 2 * gout613 + gout598;
    Ciphertext gout637 = ctx.eval_lut(&gin637, nand2);
    std::cerr << "\rLUT638   ";
    Ciphertext gin638 = 2 * (1 - gout606) + gout442;
    Ciphertext gout638 = ctx.eval_lut(&gin638, and2);
    std::cerr << "\rLUT639   ";
    Ciphertext gin639 = 2 * gout601 + gout580;
    Ciphertext gout639 = ctx.eval_lut(&gin639, xnor2);
    std::cerr << "\rLUT640   ";
    Ciphertext gin640 = 2 * gout606 + gout442;
    Ciphertext gout640 = ctx.eval_lut(&gin640, xnor2);
    std::cerr << "\rLUT641   ";
    Ciphertext gin641 = 2 * gout363 + gout593;
    Ciphertext gout641 = ctx.eval_lut(&gin641, xor2);
    std::cerr << "\rLUT642   ";
    Ciphertext gin642 = 2 * gout540 + gout608;
    Ciphertext gout642 = ctx.eval_lut(&gin642, nand2);
    std::cerr << "\rLUT643   ";
    Ciphertext gin643 = 2 * gout352 + gout605;
    Ciphertext gout643 = ctx.eval_lut(&gin643, xnor2);
    std::cerr << "\rLUT644   ";
    Ciphertext gin644 = 2 * gout497 + gout611;
    Ciphertext gout644 = ctx.eval_lut(&gin644, nand2);
    std::cerr << "\rLUT645   ";
    Ciphertext gin645 = 2 * gout497 + gout611;
    Ciphertext gout645 = ctx.eval_lut(&gin645, xor2);
    std::cerr << "\rLUT646   ";
    Ciphertext gin646 = 2 * gout612 + gout638;
    Ciphertext gout646 = ctx.eval_lut(&gin646, or2);
    std::cerr << "\rIMUX647  ";
    Ciphertext gin647A = 2 * gout386 + gout356;
    Ciphertext gout647A = ctx.eval_lut(&gin647A, and2);
    Ciphertext gin647B = 2 * gout615 + (1 - gout356);
    Ciphertext gout647B = ctx.eval_lut(&gin647B, and2);
    Ciphertext gout647 = gout647A + gout647B;
    std::cerr << "\rLUT648   ";
    Ciphertext gin648 = 2 * gout488 + gout614;
    Ciphertext gout648 = ctx.eval_lut(&gin648, nand2);
    std::cerr << "\rLUT649   ";
    Ciphertext gin649 = 2 * gout585 + gout626;
    Ciphertext gout649 = ctx.eval_lut(&gin649, or2);
    std::cerr << "\rLUT650   ";
    Ciphertext gin650 = 2 * gout99 + gout618;
    Ciphertext gout650 = ctx.eval_lut(&gin650, xnor2);
    std::cerr << "\rLUT651   ";
    Ciphertext gin651 = 2 * gout624 + gout619;
    Ciphertext gout651 = ctx.eval_lut(&gin651, xor2);
    std::cerr << "\rLUT652   ";
    Ciphertext gin652 = 2 * gout140 + gout627;
    Ciphertext gout652 = ctx.eval_lut(&gin652, xnor2);
    std::cerr << "\rLUT653   ";
    Ciphertext gin653 = 2 * gout581 + gout629;
    Ciphertext gout653 = ctx.eval_lut(&gin653, or2);
    std::cerr << "\rLUT654   ";
    Ciphertext gin654 = 2 * gout595 + gout621;
    Ciphertext gout654 = ctx.eval_lut(&gin654, or2);
    std::cerr << "\rLUT655   ";
    Ciphertext gin655 = 2 * gout97 + gout620;
    Ciphertext gout655 = ctx.eval_lut(&gin655, nand2);
    std::cerr << "\rLUT656   ";
    Ciphertext gin656 = 2 * gout631 + gout630;
    Ciphertext gout656 = ctx.eval_lut(&gin656, and2);
    std::cerr << "\rLUT657   ";
    Ciphertext gin657 = 2 * gout631 + gout630;
    Ciphertext gout657 = ctx.eval_lut(&gin657, xnor2);
    std::cerr << "\rLUT658   ";
    Ciphertext gin658 = 2 * gout435 + gout632;
    Ciphertext gout658 = ctx.eval_lut(&gin658, xor2);
    std::cerr << "\rLUT659   ";
    Ciphertext gin659 = 2 * ct_x8 + gout627;
    Ciphertext gout659 = ctx.eval_lut(&gin659, nand2);
    std::cerr << "\rLUT660   ";
    Ciphertext gin660 = 2 * gout586 + gout634;
    Ciphertext gout660 = ctx.eval_lut(&gin660, or2);
    std::cerr << "\rLUT661   ";
    Ciphertext gin661 = 2 * gout594 + gout623;
    Ciphertext gout661 = ctx.eval_lut(&gin661, nand2);
    std::cerr << "\rLUT662   ";
    Ciphertext gin662 = 2 * gout633 + gout579;
    Ciphertext gout662 = ctx.eval_lut(&gin662, and2);
    std::cerr << "\rLUT663   ";
    Ciphertext gin663 = 2 * gout633 + gout579;
    Ciphertext gout663 = ctx.eval_lut(&gin663, xnor2);
    std::cerr << "\rLUT664   ";
    Ciphertext gin664 = 2 * gout624 + gout619;
    Ciphertext gout664 = ctx.eval_lut(&gin664, nand2);
    std::cerr << "\rLUT665   ";
    Ciphertext gin665 = 2 * gout603 + gout635;
    Ciphertext gout665 = ctx.eval_lut(&gin665, nand2);
    std::cerr << "\rLUT666   ";
    Ciphertext gin666 = 2 * gout653 + gout636;
    Ciphertext gout666 = ctx.eval_lut(&gin666, and2);
    std::cerr << "\rLUT667   ";
    Ciphertext gin667 = 2 * gout653 + gout636;
    Ciphertext gout667 = ctx.eval_lut(&gin667, xnor2);
    std::cerr << "\rLUT668   ";
    Ciphertext gin668 = 2 * (1 - gout620) + gout293;
    Ciphertext gout668 = ctx.eval_lut(&gin668, and2);
    std::cerr << "\rLUT669   ";
    Ciphertext gin669 = 2 * gout435 + gout632;
    Ciphertext gout669 = ctx.eval_lut(&gin669, nand2);
    std::cerr << "\rLUT670   ";
    Ciphertext gin670 = 2 * gout654 + gout640;
    Ciphertext gout670 = ctx.eval_lut(&gin670, and2);
    std::cerr << "\rLUT671   ";
    Ciphertext gin671 = 2 * gout174 + gout642;
    Ciphertext gout671 = ctx.eval_lut(&gin671, and2);
    std::cerr << "\rLUT672   ";
    Ciphertext gin672 = 2 * (1 - gout657) + gout641;
    Ciphertext gout672 = ctx.eval_lut(&gin672, and2);
    std::cerr << "\rLUT673   ";
    Ciphertext gin673 = 2 * gout654 + gout640;
    Ciphertext gout673 = ctx.eval_lut(&gin673, xnor2);
    std::cerr << "\rLUT674   ";
    Ciphertext gin674 = 2 * gout657 + gout641;
    Ciphertext gout674 = ctx.eval_lut(&gin674, xnor2);
    std::cerr << "\rLUT675   ";
    Ciphertext gin675 = 2 * gout174 + gout642;
    Ciphertext gout675 = ctx.eval_lut(&gin675, xor2);
    std::cerr << "\rLUT676   ";
    Ciphertext gin676 = 2 * gout559 + gout643;
    Ciphertext gout676 = ctx.eval_lut(&gin676, and2);
    std::cerr << "\rLUT677   ";
    Ciphertext gin677 = 2 * gout600 + gout643;
    Ciphertext gout677 = ctx.eval_lut(&gin677, and2);
    std::cerr << "\rLUT678   ";
    Ciphertext gin678 = 2 * gout643 + gout628;
    Ciphertext gout678 = ctx.eval_lut(&gin678, xor2);
    std::cerr << "\rLUT679   ";
    Ciphertext gin679 = 2 * gout609 + gout644;
    Ciphertext gout679 = ctx.eval_lut(&gin679, nand2);
    std::cerr << "\rLUT680   ";
    Ciphertext gin680 = 2 * gout646 + gout639;
    Ciphertext gout680 = ctx.eval_lut(&gin680, xnor2);
    std::cerr << "\rLUT681   ";
    Ciphertext gin681 = 2 * gout648 + gout489;
    Ciphertext gout681 = ctx.eval_lut(&gin681, nand2);
    std::cerr << "\rLUT682   ";
    Ciphertext gin682 = 2 * gout648 + gout489;
    Ciphertext gout682 = ctx.eval_lut(&gin682, xnor2);
    std::cerr << "\rLUT683   ";
    Ciphertext gin683 = 2 * gout369 + gout647;
    Ciphertext gout683 = ctx.eval_lut(&gin683, nand2);
    std::cerr << "\rLUT684   ";
    Ciphertext gin684 = 2 * gout433 + gout651;
    Ciphertext gout684 = ctx.eval_lut(&gin684, xor2);
    std::cerr << "\rLUT685   ";
    Ciphertext gin685 = 2 * gout293 + gout655;
    Ciphertext gout685 = ctx.eval_lut(&gin685, and2);
    std::cerr << "\rLUT686   ";
    Ciphertext gin686 = 2 * ct_x9 + gout650;
    Ciphertext gout686 = ctx.eval_lut(&gin686, nand2);
    std::cerr << "\rLUT687   ";
    Ciphertext gin687 = 2 * ct_x9 + gout650;
    Ciphertext gout687 = ctx.eval_lut(&gin687, or2);
    std::cerr << "\rLUT688   ";
    Ciphertext gin688 = 2 * gout660 + gout625;
    Ciphertext gout688 = ctx.eval_lut(&gin688, and2);
    std::cerr << "\rLUT689   ";
    Ciphertext gin689 = 2 * gout433 + gout651;
    Ciphertext gout689 = ctx.eval_lut(&gin689, nand2);
    std::cerr << "\rLUT690   ";
    Ciphertext gin690 = 2 * gout660 + gout625;
    Ciphertext gout690 = ctx.eval_lut(&gin690, xnor2);
    std::cerr << "\rLUT691   ";
    Ciphertext gin691 = 2 * (1 - gout663) + gout604;
    Ciphertext gout691 = ctx.eval_lut(&gin691, and2);
    std::cerr << "\rLUT692   ";
    Ciphertext gin692 = 2 * gout165 + gout650;
    Ciphertext gout692 = ctx.eval_lut(&gin692, xnor2);
    std::cerr << "\rLUT693   ";
    Ciphertext gin693 = 2 * gout664 + gout689;
    Ciphertext gout693 = ctx.eval_lut(&gin693, nand2);
    std::cerr << "\rLUT694   ";
    Ciphertext gin694 = 2 * gout649 + gout590;
    Ciphertext gout694 = ctx.eval_lut(&gin694, and2);
    std::cerr << "\rLUT695   ";
    Ciphertext gin695 = 2 * gout649 + gout590;
    Ciphertext gout695 = ctx.eval_lut(&gin695, xnor2);
    std::cerr << "\rLUT696   ";
    Ciphertext gin696 = 2 * gout663 + gout604;
    Ciphertext gout696 = ctx.eval_lut(&gin696, xnor2);
    std::cerr << "\rLUT697   ";
    Ciphertext gin697 = 2 * gout667 + gout597;
    Ciphertext gout697 = ctx.eval_lut(&gin697, xnor2);
    std::cerr << "\rLUT698   ";
    Ciphertext gin698 = 2 * gout665 + gout577;
    Ciphertext gout698 = ctx.eval_lut(&gin698, and2);
    std::cerr << "\rLUT699   ";
    Ciphertext gin699 = 2 * (1 - gout667) + gout597;
    Ciphertext gout699 = ctx.eval_lut(&gin699, and2);
    std::cerr << "\rLUT700   ";
    Ciphertext gin700 = 2 * gout665 + gout622;
    Ciphertext gout700 = ctx.eval_lut(&gin700, xnor2);
    std::cerr << "\rLUT701   ";
    Ciphertext gin701 = 2 * (1 - gout673) + gout645;
    Ciphertext gout701 = ctx.eval_lut(&gin701, and2);
    std::cerr << "\rLUT702   ";
    Ciphertext gin702 = 2 * gout97 + gout668;
    Ciphertext gout702 = ctx.eval_lut(&gin702, xnor2);
    std::cerr << "\rLUT703   ";
    Ciphertext gin703 = 2 * gout673 + gout645;
    Ciphertext gout703 = ctx.eval_lut(&gin703, xnor2);
    std::cerr << "\rLUT704   ";
    Ciphertext gin704 = 2 * gout637 + gout669;
    Ciphertext gout704 = ctx.eval_lut(&gin704, nand2);
    std::cerr << "\rLUT705   ";
    Ciphertext gin705 = 2 * gout602 + gout678;
    Ciphertext gout705 = ctx.eval_lut(&gin705, xnor2);
    std::cerr << "\rLUT706   ";
    Ciphertext gin706 = 2 * gout602 + gout678;
    Ciphertext gout706 = ctx.eval_lut(&gin706, nand2);
    std::cerr << "\rLUT707   ";
    Ciphertext gin707 = 2 * gout679 + gout357;
    Ciphertext gout707 = ctx.eval_lut(&gin707, xnor2);
    std::cerr << "\rLUT708   ";
    Ciphertext gin708 = 2 * gout656 + gout672;
    Ciphertext gout708 = ctx.eval_lut(&gin708, or2);
    std::cerr << "\rINV709   ";
    Ciphertext gout709 = 1 - gout676;

    std::cerr << "\rINV710   ";
    Ciphertext gout710 = 1 - gout677;

    std::cerr << "\rLUT711   ";
    Ciphertext gin711 = 2 * gout676 + gout700;
    Ciphertext gout711 = ctx.eval_lut(&gin711, and2);
    std::cerr << "\rIMUX712  ";
    Ciphertext gin712A = 2 * gout539 + gout356;
    Ciphertext gout712A = ctx.eval_lut(&gin712A, and2);
    Ciphertext gin712B = 2 * gout682 + (1 - gout356);
    Ciphertext gout712B = ctx.eval_lut(&gin712B, and2);
    Ciphertext gout712 = gout712A + gout712B;
    std::cerr << "\rLUT713   ";
    Ciphertext gin713 = 2 * gout493 + gout681;
    Ciphertext gout713 = ctx.eval_lut(&gin713, nand2);
    std::cerr << "\rLUT714   ";
    Ciphertext gin714 = 2 * (1 - gout685) + gout359;
    Ciphertext gout714 = ctx.eval_lut(&gin714, and2);
    std::cerr << "\rLUT715   ";
    Ciphertext gin715 = 2 * (1 - gout690) + gout572;
    Ciphertext gout715 = ctx.eval_lut(&gin715, and2);
    std::cerr << "\rLUT716   ";
    Ciphertext gin716 = 2 * gout690 + gout572;
    Ciphertext gout716 = ctx.eval_lut(&gin716, xnor2);
    std::cerr << "\rLUT717   ";
    Ciphertext gin717 = 2 * ct_y11 + gout685;
    Ciphertext gout717 = ctx.eval_lut(&gin717, xnor2);
    std::cerr << "\rLUT718   ";
    Ciphertext gin718 = 2 * gout659 + gout686;
    Ciphertext gout718 = ctx.eval_lut(&gin718, nand2);
    std::cerr << "\rINV719   ";
    Ciphertext gout719 = 1 - gout692;

    std::cerr << "\rLUT720   ";
    Ciphertext gin720 = 2 * gout662 + gout691;
    Ciphertext gout720 = ctx.eval_lut(&gin720, or2);
    std::cerr << "\rLUT721   ";
    Ciphertext gin721 = 2 * gout693 + gout716;
    Ciphertext gout721 = ctx.eval_lut(&gin721, xor2);
    std::cerr << "\rLUT722   ";
    Ciphertext gin722 = 2 * gout698 + gout658;
    Ciphertext gout722 = ctx.eval_lut(&gin722, and2);
    std::cerr << "\rLUT723   ";
    Ciphertext gin723 = 2 * gout693 + gout716;
    Ciphertext gout723 = ctx.eval_lut(&gin723, and2);
    std::cerr << "\rLUT724   ";
    Ciphertext gin724 = 2 * gout720 + gout674;
    Ciphertext gout724 = ctx.eval_lut(&gin724, nand2);
    std::cerr << "\rLUT725   ";
    Ciphertext gin725 = 2 * gout695 + gout567;
    Ciphertext gout725 = ctx.eval_lut(&gin725, xnor2);
    std::cerr << "\rLUT726   ";
    Ciphertext gin726 = 2 * (1 - gout695) + gout567;
    Ciphertext gout726 = ctx.eval_lut(&gin726, and2);
    std::cerr << "\rLUT727   ";
    Ciphertext gin727 = 2 * gout720 + gout674;
    Ciphertext gout727 = ctx.eval_lut(&gin727, xor2);
    std::cerr << "\rLUT728   ";
    Ciphertext gin728 = 2 * ct_x10 + gout702;
    Ciphertext gout728 = ctx.eval_lut(&gin728, nand2);
    std::cerr << "\rLUT729   ";
    Ciphertext gin729 = 2 * gout666 + gout699;
    Ciphertext gout729 = ctx.eval_lut(&gin729, or2);
    std::cerr << "\rLUT730   ";
    Ciphertext gin730 = 2 * gout704 + gout684;
    Ciphertext gout730 = ctx.eval_lut(&gin730, xor2);
    std::cerr << "\rLUT731   ";
    Ciphertext gin731 = 2 * gout704 + gout684;
    Ciphertext gout731 = ctx.eval_lut(&gin731, and2);
    std::cerr << "\rLUT732   ";
    Ciphertext gin732 = 2 * gout88 + gout702;
    Ciphertext gout732 = ctx.eval_lut(&gin732, xnor2);
    std::cerr << "\rINV733   ";
    Ciphertext gout733 = 1 - gout698;

    std::cerr << "\rLUT734   ";
    Ciphertext gin734 = 2 * gout708 + gout697;
    Ciphertext gout734 = ctx.eval_lut(&gin734, xor2);
    std::cerr << "\rLUT735   ";
    Ciphertext gin735 = 2 * gout708 + gout697;
    Ciphertext gout735 = ctx.eval_lut(&gin735, nand2);
    std::cerr << "\rLUT736   ";
    Ciphertext gin736 = 2 * gout670 + gout701;
    Ciphertext gout736 = ctx.eval_lut(&gin736, or2);
    std::cerr << "\rLUT737   ";
    Ciphertext gin737 = 2 * gout707 + gout680;
    Ciphertext gout737 = ctx.eval_lut(&gin737, xnor2);
    std::cerr << "\rINV738   ";
    Ciphertext gout738 = 1 - gout706;

    std::cerr << "\rLUT739   ";
    Ciphertext gin739 = 2 * gout709 + gout700;
    Ciphertext gout739 = ctx.eval_lut(&gin739, xnor2);
    std::cerr << "\rINV740   ";
    Ciphertext gout740 = 1 - gout711;

    std::cerr << "\rLUT741   ";
    Ciphertext gin741 = 2 * gout369 + gout712;
    Ciphertext gout741 = ctx.eval_lut(&gin741, nand2);
    std::cerr << "\rLUT742   ";
    Ciphertext gin742 = 2 * gout713 + gout511;
    Ciphertext gout742 = ctx.eval_lut(&gin742, nand2);
    std::cerr << "\rLUT743   ";
    Ciphertext gin743 = 2 * gout713 + gout511;
    Ciphertext gout743 = ctx.eval_lut(&gin743, xnor2);
    std::cerr << "\rLUT744   ";
    Ciphertext gin744 = 2 * ct_y12 + gout714;
    Ciphertext gout744 = ctx.eval_lut(&gin744, xnor2);
    std::cerr << "\rLUT745   ";
    Ciphertext gin745 = 2 * gout123 + gout717;
    Ciphertext gout745 = ctx.eval_lut(&gin745, or2);
    std::cerr << "\rLUT746   ";
    Ciphertext gin746 = 2 * gout688 + gout715;
    Ciphertext gout746 = ctx.eval_lut(&gin746, or2);
    std::cerr << "\rLUT747   ";
    Ciphertext gin747 = 2 * gout123 + gout717;
    Ciphertext gout747 = ctx.eval_lut(&gin747, nand2);
    std::cerr << "\rLUT748   ";
    Ciphertext gin748 = 2 * gout714 + gout379;
    Ciphertext gout748 = ctx.eval_lut(&gin748, nand2);
    std::cerr << "\rLUT749   ";
    Ciphertext gin749 = 2 * ct_x11 + gout717;
    Ciphertext gout749 = ctx.eval_lut(&gin749, xnor2);
    std::cerr << "\rLUT750   ";
    Ciphertext gin750 = 2 * gout687 + gout718;
    Ciphertext gout750 = ctx.eval_lut(&gin750, nand2);
    std::cerr << "\rLUT751   ";
    Ciphertext gin751 = 2 * gout694 + gout726;
    Ciphertext gout751 = ctx.eval_lut(&gin751, or2);
    std::cerr << "\rLUT752   ";
    Ciphertext gin752 = 2 * gout729 + gout703;
    Ciphertext gout752 = ctx.eval_lut(&gin752, nand2);
    std::cerr << "\rLUT753   ";
    Ciphertext gin753 = 2 * gout729 + gout703;
    Ciphertext gout753 = ctx.eval_lut(&gin753, xnor2);
    std::cerr << "\rINV754   ";
    Ciphertext gout754 = 1 - gout723;

    std::cerr << "\rLUT755   ";
    Ciphertext gin755 = 2 * gout728 + gout745;
    Ciphertext gout755 = ctx.eval_lut(&gin755, nand2);
    std::cerr << "\rLUT756   ";
    Ciphertext gin756 = 2 * gout731 + gout721;
    Ciphertext gout756 = ctx.eval_lut(&gin756, and2);
    std::cerr << "\rINV757   ";
    Ciphertext gout757 = 1 - gout722;

    std::cerr << "\rLUT758   ";
    Ciphertext gin758 = 2 * gout731 + gout721;
    Ciphertext gout758 = ctx.eval_lut(&gin758, xor2);
    std::cerr << "\rLUT759   ";
    Ciphertext gin759 = 2 * gout607 + gout727;
    Ciphertext gout759 = ctx.eval_lut(&gin759, nand2);
    std::cerr << "\rLUT760   ";
    Ciphertext gin760 = 2 * gout607 + gout727;
    Ciphertext gout760 = ctx.eval_lut(&gin760, xor2);
    std::cerr << "\rLUT761   ";
    Ciphertext gin761 = 2 * gout746 + gout725;
    Ciphertext gout761 = ctx.eval_lut(&gin761, nand2);
    std::cerr << "\rLUT762   ";
    Ciphertext gin762 = 2 * gout722 + gout730;
    Ciphertext gout762 = ctx.eval_lut(&gin762, and2);
    std::cerr << "\rLUT763   ";
    Ciphertext gin763 = 2 * gout746 + gout725;
    Ciphertext gout763 = ctx.eval_lut(&gin763, xor2);
    std::cerr << "\rLUT764   ";
    Ciphertext gin764 = 2 * gout736 + gout737;
    Ciphertext gout764 = ctx.eval_lut(&gin764, xnor2);
    std::cerr << "\rLUT765   ";
    Ciphertext gin765 = 2 * gout661 + gout734;
    Ciphertext gout765 = ctx.eval_lut(&gin765, nand2);
    std::cerr << "\rLUT766   ";
    Ciphertext gin766 = 2 * gout661 + gout734;
    Ciphertext gout766 = ctx.eval_lut(&gin766, xor2);
    std::cerr << "\rLUT767   ";
    Ciphertext gin767 = 2 * gout733 + gout658;
    Ciphertext gout767 = ctx.eval_lut(&gin767, xnor2);
    std::cerr << "\rLUT768   ";
    Ciphertext gin768 = 2 * gout710 + gout739;
    Ciphertext gout768 = ctx.eval_lut(&gin768, xnor2);
    std::cerr << "\rLUT769   ";
    Ciphertext gin769 = 2 * gout677 + gout739;
    Ciphertext gout769 = ctx.eval_lut(&gin769, nand2);
    std::cerr << "\rLUT770   ";
    Ciphertext gin770 = 2 * gout740 + gout767;
    Ciphertext gout770 = ctx.eval_lut(&gin770, xnor2);
    std::cerr << "\rIMUX771  ";
    Ciphertext gin771A = 2 * gout743 + gout426;
    Ciphertext gout771A = ctx.eval_lut(&gin771A, and2);
    Ciphertext gin771B = 2 * gout610 + (1 - gout426);
    Ciphertext gout771B = ctx.eval_lut(&gin771B, and2);
    Ciphertext gout771 = gout771A + gout771B;
    std::cerr << "\rLUT772   ";
    Ciphertext gin772 = 2 * gout523 + gout742;
    Ciphertext gout772 = ctx.eval_lut(&gin772, nand2);
    std::cerr << "\rLUT773   ";
    Ciphertext gin773 = 2 * gout158 + gout744;
    Ciphertext gout773 = ctx.eval_lut(&gin773, xnor2);
    std::cerr << "\rINV774   ";
    Ciphertext gout774 = 1 - gout749;

    std::cerr << "\rLUT775   ";
    Ciphertext gin775 = 2 * ct_x12 + gout744;
    Ciphertext gout775 = ctx.eval_lut(&gin775, nand2);
    std::cerr << "\rLUT776   ";
    Ciphertext gin776 = 2 * ct_y13 + gout748;
    Ciphertext gout776 = ctx.eval_lut(&gin776, xnor2);
    std::cerr << "\rLUT777   ";
    Ciphertext gin777 = 2 * gout753 + gout675;
    Ciphertext gout777 = ctx.eval_lut(&gin777, xnor2);
    std::cerr << "\rLUT778   ";
    Ciphertext gin778 = 2 * gout751 + gout696;
    Ciphertext gout778 = ctx.eval_lut(&gin778, nand2);
    std::cerr << "\rLUT779   ";
    Ciphertext gin779 = 2 * gout751 + gout696;
    Ciphertext gout779 = ctx.eval_lut(&gin779, xor2);
    std::cerr << "\rLUT780   ";
    Ciphertext gin780 = 2 * gout748 + gout364;
    Ciphertext gout780 = ctx.eval_lut(&gin780, or2);
    std::cerr << "\rLUT781   ";
    Ciphertext gin781 = 2 * gout762 + gout758;
    Ciphertext gout781 = ctx.eval_lut(&gin781, nand2);
    std::cerr << "\rLUT782   ";
    Ciphertext gin782 = 2 * (1 - gout753) + gout675;
    Ciphertext gout782 = ctx.eval_lut(&gin782, and2);
    std::cerr << "\rLUT783   ";
    Ciphertext gin783 = 2 * gout735 + gout765;
    Ciphertext gout783 = ctx.eval_lut(&gin783, nand2);
    std::cerr << "\rLUT784   ";
    Ciphertext gin784 = 2 * gout724 + gout759;
    Ciphertext gout784 = ctx.eval_lut(&gin784, nand2);
    std::cerr << "\rLUT785   ";
    Ciphertext gin785 = 2 * gout747 + gout755;
    Ciphertext gout785 = ctx.eval_lut(&gin785, nand2);
    std::cerr << "\rLUT786   ";
    Ciphertext gin786 = 2 * gout762 + gout758;
    Ciphertext gout786 = ctx.eval_lut(&gin786, xnor2);
    std::cerr << "\rLUT787   ";
    Ciphertext gin787 = 2 * gout569 + gout763;
    Ciphertext gout787 = ctx.eval_lut(&gin787, nand2);
    std::cerr << "\rLUT788   ";
    Ciphertext gin788 = 2 * gout569 + gout763;
    Ciphertext gout788 = ctx.eval_lut(&gin788, xor2);
    std::cerr << "\rLUT789   ";
    Ciphertext gin789 = 2 * gout711 + gout767;
    Ciphertext gout789 = ctx.eval_lut(&gin789, nand2);
    std::cerr << "\rLUT790   ";
    Ciphertext gin790 = 2 * gout738 + gout768;
    Ciphertext gout790 = ctx.eval_lut(&gin790, nand2);
    std::cerr << "\rLUT791   ";
    Ciphertext gin791 = 2 * gout738 + gout768;
    Ciphertext gout791 = ctx.eval_lut(&gin791, xnor2);
    std::cerr << "\rLUT792   ";
    Ciphertext gin792 = 2 * gout369 + gout771;
    Ciphertext gout792 = ctx.eval_lut(&gin792, nand2);
    std::cerr << "\rLUT793   ";
    Ciphertext gin793 = 2 * gout772 + gout532;
    Ciphertext gout793 = ctx.eval_lut(&gin793, xnor2);
    std::cerr << "\rLUT794   ";
    Ciphertext gin794 = 2 * gout772 + gout532;
    Ciphertext gout794 = ctx.eval_lut(&gin794, nand2);
    std::cerr << "\rLUT795   ";
    Ciphertext gin795 = 2 * gout21 + gout776;
    Ciphertext gout795 = ctx.eval_lut(&gin795, nand2);
    std::cerr << "\rLUT796   ";
    Ciphertext gin796 = 2 * ct_x13 + gout776;
    Ciphertext gout796 = ctx.eval_lut(&gin796, xnor2);
    std::cerr << "\rIMUX797  ";
    Ciphertext gin797A = 2 * gout705 + gout356;
    Ciphertext gout797A = ctx.eval_lut(&gin797A, and2);
    Ciphertext gin797B = 2 * gout793 + (1 - gout356);
    Ciphertext gout797B = ctx.eval_lut(&gin797B, and2);
    Ciphertext gout797 = gout797A + gout797B;
    std::cerr << "\rLUT798   ";
    Ciphertext gin798 = 2 * gout21 + gout776;
    Ciphertext gout798 = ctx.eval_lut(&gin798, or2);
    std::cerr << "\rLUT799   ";
    Ciphertext gin799 = 2 * gout563 + gout779;
    Ciphertext gout799 = ctx.eval_lut(&gin799, nand2);
    std::cerr << "\rLUT800   ";
    Ciphertext gin800 = 2 * gout752 + (1 - gout782);
    Ciphertext gout800 = ctx.eval_lut(&gin800, and2);
    std::cerr << "\rLUT801   ";
    Ciphertext gin801 = 2 * gout563 + gout779;
    Ciphertext gout801 = ctx.eval_lut(&gin801, xor2);
    std::cerr << "\rLUT802   ";
    Ciphertext gin802 = 2 * gout784 + gout766;
    Ciphertext gout802 = ctx.eval_lut(&gin802, and2);
    std::cerr << "\rLUT803   ";
    Ciphertext gin803 = 2 * gout168 + gout780;
    Ciphertext gout803 = ctx.eval_lut(&gin803, xnor2);
    std::cerr << "\rLUT804   ";
    Ciphertext gin804 = 2 * gout780 + gout372;
    Ciphertext gout804 = ctx.eval_lut(&gin804, or2);
    std::cerr << "\rLUT805   ";
    Ciphertext gin805 = 2 * gout784 + gout766;
    Ciphertext gout805 = ctx.eval_lut(&gin805, xor2);
    std::cerr << "\rLUT806   ";
    Ciphertext gin806 = 2 * gout789 + (1 - gout730);
    Ciphertext gout806 = ctx.eval_lut(&gin806, or2);
    std::cerr << "\rLUT807   ";
    Ciphertext gin807 = 2 * gout783 + gout777;
    Ciphertext gout807 = ctx.eval_lut(&gin807, and2);
    std::cerr << "\rLUT808   ";
    Ciphertext gin808 = 2 * gout757 + gout789;
    Ciphertext gout808 = ctx.eval_lut(&gin808, and2);
    std::cerr << "\rLUT809   ";
    Ciphertext gin809 = 2 * gout783 + gout777;
    Ciphertext gout809 = ctx.eval_lut(&gin809, xor2);
    std::cerr << "\rLUT810   ";
    Ciphertext gin810 = 2 * gout761 + gout787;
    Ciphertext gout810 = ctx.eval_lut(&gin810, nand2);
    std::cerr << "\rLUT811   ";
    Ciphertext gin811 = 2 * gout754 + gout788;
    Ciphertext gout811 = ctx.eval_lut(&gin811, xnor2);
    std::cerr << "\rLUT812   ";
    Ciphertext gin812 = 2 * gout723 + gout788;
    Ciphertext gout812 = ctx.eval_lut(&gin812, and2);
    std::cerr << "\rLUT813   ";
    Ciphertext gin813 = 2 * gout769 + gout790;
    Ciphertext gout813 = ctx.eval_lut(&gin813, nand2);
    std::cerr << "\rLUT814   ";
    Ciphertext gin814 = 2 * gout535 + gout794;
    Ciphertext gout814 = ctx.eval_lut(&gin814, nand2);
    std::cerr << "\rLUT815   ";
    Ciphertext gin815 = 2 * gout369 + gout797;
    Ciphertext gout815 = ctx.eval_lut(&gin815, nand2);
    std::cerr << "\rINV816   ";
    Ciphertext gout816 = 1 - gout796;

    std::cerr << "\rLUT817   ";
    Ciphertext gin817 = 2 * gout775 + gout798;
    Ciphertext gout817 = ctx.eval_lut(&gin817, nand2);
    std::cerr << "\rLUT818   ";
    Ciphertext gin818 = 2 * gout778 + gout799;
    Ciphertext gout818 = ctx.eval_lut(&gin818, nand2);
    std::cerr << "\rLUT819   ";
    Ciphertext gin819 = 2 * gout8 + gout803;
    Ciphertext gout819 = ctx.eval_lut(&gin819, xnor2);
    std::cerr << "\rLUT820   ";
    Ciphertext gin820 = 2 * gout800 + gout764;
    Ciphertext gout820 = ctx.eval_lut(&gin820, xnor2);
    std::cerr << "\rLUT821   ";
    Ciphertext gin821 = 2 * gout804 + gout65;
    Ciphertext gout821 = ctx.eval_lut(&gin821, xnor2);
    std::cerr << "\rLUT822   ";
    Ciphertext gin822 = 2 * gout810 + gout801;
    Ciphertext gout822 = ctx.eval_lut(&gin822, and2);
    std::cerr << "\rLUT823   ";
    Ciphertext gin823 = 2 * ct_x14 + gout803;
    Ciphertext gout823 = ctx.eval_lut(&gin823, nand2);
    std::cerr << "\rLUT824   ";
    Ciphertext gin824 = 2 * gout802 + gout809;
    Ciphertext gout824 = ctx.eval_lut(&gin824, xor2);
    std::cerr << "\rLUT825   ";
    Ciphertext gin825 = 2 * gout671 + gout807;
    Ciphertext gout825 = ctx.eval_lut(&gin825, xnor2);
    std::cerr << "\rLUT826   ";
    Ciphertext gin826 = 2 * gout810 + gout801;
    Ciphertext gout826 = ctx.eval_lut(&gin826, xor2);
    std::cerr << "\rLUT827   ";
    Ciphertext gin827 = 2 * gout756 + gout811;
    Ciphertext gout827 = ctx.eval_lut(&gin827, nand2);
    std::cerr << "\rLUT828   ";
    Ciphertext gin828 = 2 * gout756 + gout811;
    Ciphertext gout828 = ctx.eval_lut(&gin828, xor2);
    std::cerr << "\rINV829   ";
    Ciphertext gout829 = 1 - gout812;

    std::cerr << "\rLUT830   ";
    Ciphertext gin830 = 2 * gout802 + gout809;
    Ciphertext gout830 = ctx.eval_lut(&gin830, nand2);
    std::cerr << "\rLUT831   ";
    Ciphertext gin831 = 2 * gout730 + gout808;
    Ciphertext gout831 = ctx.eval_lut(&gin831, xnor2);
    std::cerr << "\rLUT832   ";
    Ciphertext gin832 = 2 * gout770 + gout813;
    Ciphertext gout832 = ctx.eval_lut(&gin832, and2);
    std::cerr << "\rLUT833   ";
    Ciphertext gin833 = 2 * gout770 + gout813;
    Ciphertext gout833 = ctx.eval_lut(&gin833, xnor2);
    std::cerr << "\rLUT834   ";
    Ciphertext gin834 = 2 * gout814 + gout573;
    Ciphertext gout834 = ctx.eval_lut(&gin834, nand2);
    std::cerr << "\rLUT835   ";
    Ciphertext gin835 = 2 * gout814 + gout573;
    Ciphertext gout835 = ctx.eval_lut(&gin835, xnor2);
    std::cerr << "\rLUT836   ";
    Ciphertext gin836 = 2 * gout795 + gout817;
    Ciphertext gout836 = ctx.eval_lut(&gin836, nand2);
    std::cerr << "\rLUT837   ";
    Ciphertext gin837 = 2 * gout818 + gout760;
    Ciphertext gout837 = ctx.eval_lut(&gin837, xor2);
    std::cerr << "\rLUT838   ";
    Ciphertext gin838 = 2 * gout818 + gout760;
    Ciphertext gout838 = ctx.eval_lut(&gin838, and2);
    std::cerr << "\rLUT839   ";
    Ciphertext gin839 = 2 * gout820 + gout825;
    Ciphertext gout839 = ctx.eval_lut(&gin839, xnor2);
    std::cerr << "\rIMUX840  ";
    Ciphertext gin840A = 2 * gout791 + gout356;
    Ciphertext gout840A = ctx.eval_lut(&gin840A, and2);
    Ciphertext gin840B = 2 * gout835 + (1 - gout356);
    Ciphertext gout840B = ctx.eval_lut(&gin840B, and2);
    Ciphertext gout840 = gout840A + gout840B;
    std::cerr << "\rLUT841   ";
    Ciphertext gin841 = 2 * gout812 + gout826;
    Ciphertext gout841 = ctx.eval_lut(&gin841, nand2);
    std::cerr << "\rLUT842   ";
    Ciphertext gin842 = 2 * gout832 + gout831;
    Ciphertext gout842 = ctx.eval_lut(&gin842, xnor2);
    std::cerr << "\rLUT843   ";
    Ciphertext gin843 = 2 * gout829 + gout826;
    Ciphertext gout843 = ctx.eval_lut(&gin843, xnor2);
    std::cerr << "\rLUT844   ";
    Ciphertext gin844 = 2 * gout832 + gout831;
    Ciphertext gout844 = ctx.eval_lut(&gin844, nand2);
    std::cerr << "\rLUT845   ";
    Ciphertext gin845 = 2 * gout575 + gout834;
    Ciphertext gout845 = ctx.eval_lut(&gin845, nand2);
    std::cerr << "\rLUT846   ";
    Ciphertext gin846 = 2 * gout822 + gout837;
    Ciphertext gout846 = ctx.eval_lut(&gin846, nand2);
    std::cerr << "\rLUT847   ";
    Ciphertext gin847 = 2 * gout822 + gout837;
    Ciphertext gout847 = ctx.eval_lut(&gin847, xor2);
    std::cerr << "\rLUT848   ";
    Ciphertext gin848 = 2 * gout838 + gout805;
    Ciphertext gout848 = ctx.eval_lut(&gin848, nand2);
    std::cerr << "\rLUT849   ";
    Ciphertext gin849 = 2 * gout838 + gout805;
    Ciphertext gout849 = ctx.eval_lut(&gin849, xor2);
    std::cerr << "\rLUT850   ";
    Ciphertext gin850 = 2 * gout369 + gout840;
    Ciphertext gout850 = ctx.eval_lut(&gin850, nand2);
    std::cerr << "\rLUT851   ";
    Ciphertext gin851 = 2 * gout844 + gout806;
    Ciphertext gout851 = ctx.eval_lut(&gin851, and2);
    std::cerr << "\rLUT852   ";
    Ciphertext gin852 = 2 * gout845 + gout616;
    Ciphertext gout852 = ctx.eval_lut(&gin852, nand2);
    std::cerr << "\rLUT853   ";
    Ciphertext gin853 = 2 * gout845 + gout616;
    Ciphertext gout853 = ctx.eval_lut(&gin853, xnor2);
    std::cerr << "\rIMUX854  ";
    Ciphertext gin854A = 2 * gout833 + gout356;
    Ciphertext gout854A = ctx.eval_lut(&gin854A, and2);
    Ciphertext gin854B = 2 * gout853 + (1 - gout356);
    Ciphertext gout854B = ctx.eval_lut(&gin854B, and2);
    Ciphertext gout854 = gout854A + gout854B;
    std::cerr << "\rLUT855   ";
    Ciphertext gin855 = 2 * gout851 + gout786;
    Ciphertext gout855 = ctx.eval_lut(&gin855, or2);
    std::cerr << "\rLUT856   ";
    Ciphertext gin856 = 2 * gout851 + gout786;
    Ciphertext gout856 = ctx.eval_lut(&gin856, nand2);
    std::cerr << "\rLUT857   ";
    Ciphertext gin857 = 2 * gout617 + gout852;
    Ciphertext gout857 = ctx.eval_lut(&gin857, nand2);
    std::cerr << "\rLUT858   ";
    Ciphertext gin858 = 2 * gout369 + gout854;
    Ciphertext gout858 = ctx.eval_lut(&gin858, nand2);
    std::cerr << "\rLUT859   ";
    Ciphertext gin859 = 2 * gout781 + gout855;
    Ciphertext gout859 = ctx.eval_lut(&gin859, nand2);
    std::cerr << "\rLUT860   ";
    Ciphertext gin860 = 2 * gout356 + gout855;
    Ciphertext gout860 = ctx.eval_lut(&gin860, and2);
    std::cerr << "\rLUT861   ";
    Ciphertext gin861 = 2 * gout857 + gout652;
    Ciphertext gout861 = ctx.eval_lut(&gin861, xnor2);
    std::cerr << "\rLUT862   ";
    Ciphertext gin862 = 2 * gout857 + gout652;
    Ciphertext gout862 = ctx.eval_lut(&gin862, nand2);
    std::cerr << "\rIMUX863  ";
    Ciphertext gin863A = 2 * gout842 + gout356;
    Ciphertext gout863A = ctx.eval_lut(&gin863A, and2);
    Ciphertext gin863B = 2 * gout861 + (1 - gout356);
    Ciphertext gout863B = ctx.eval_lut(&gin863B, and2);
    Ciphertext gout863 = gout863A + gout863B;
    std::cerr << "\rLUT864   ";
    Ciphertext gin864 = 2 * gout859 + gout828;
    Ciphertext gout864 = ctx.eval_lut(&gin864, xnor2);
    std::cerr << "\rLUT865   ";
    Ciphertext gin865 = 2 * gout859 + gout828;
    Ciphertext gout865 = ctx.eval_lut(&gin865, nand2);
    std::cerr << "\rLUT866   ";
    Ciphertext gin866 = 2 * gout856 + gout860;
    Ciphertext gout866 = ctx.eval_lut(&gin866, nand2);
    std::cerr << "\rLUT867   ";
    Ciphertext gin867 = 2 * gout862 + gout719;
    Ciphertext gout867 = ctx.eval_lut(&gin867, or2);
    std::cerr << "\rLUT868   ";
    Ciphertext gin868 = 2 * gout659 + gout862;
    Ciphertext gout868 = ctx.eval_lut(&gin868, nand2);
    std::cerr << "\rLUT869   ";
    Ciphertext gin869 = 2 * gout827 + gout865;
    Ciphertext gout869 = ctx.eval_lut(&gin869, nand2);
    std::cerr << "\rLUT870   ";
    Ciphertext gin870 = 2 * gout369 + gout863;
    Ciphertext gout870 = ctx.eval_lut(&gin870, nand2);
    std::cerr << "\rLUT871   ";
    Ciphertext gin871 = 2 * gout369 + gout866;
    Ciphertext gout871 = ctx.eval_lut(&gin871, and2);
    std::cerr << "\rLUT872   ";
    Ciphertext gin872 = 2 * gout868 + gout692;
    Ciphertext gout872 = ctx.eval_lut(&gin872, or2);
    std::cerr << "\rLUT873   ";
    Ciphertext gin873 = 2 * gout868 + gout692;
    Ciphertext gout873 = ctx.eval_lut(&gin873, nand2);
    std::cerr << "\rLUT874   ";
    Ciphertext gin874 = 2 * gout867 + gout750;
    Ciphertext gout874 = ctx.eval_lut(&gin874, nand2);
    std::cerr << "\rLUT875   ";
    Ciphertext gin875 = 2 * gout869 + gout843;
    Ciphertext gout875 = ctx.eval_lut(&gin875, nand2);
    std::cerr << "\rLUT876   ";
    Ciphertext gin876 = 2 * gout869 + gout843;
    Ciphertext gout876 = ctx.eval_lut(&gin876, or2);
    std::cerr << "\rLUT877   ";
    Ciphertext gin877 = 2 * gout426 + gout872;
    Ciphertext gout877 = ctx.eval_lut(&gin877, and2);
    std::cerr << "\rLUT878   ";
    Ciphertext gin878 = 2 * gout874 + gout732;
    Ciphertext gout878 = ctx.eval_lut(&gin878, nand2);
    std::cerr << "\rLUT879   ";
    Ciphertext gin879 = 2 * gout874 + gout732;
    Ciphertext gout879 = ctx.eval_lut(&gin879, xnor2);
    std::cerr << "\rIMUX880  ";
    Ciphertext gin880A = 2 * gout864 + gout356;
    Ciphertext gout880A = ctx.eval_lut(&gin880A, and2);
    Ciphertext gin880B = 2 * gout879 + (1 - gout356);
    Ciphertext gout880B = ctx.eval_lut(&gin880B, and2);
    Ciphertext gout880 = gout880A + gout880B;
    std::cerr << "\rLUT881   ";
    Ciphertext gin881 = 2 * gout356 + gout876;
    Ciphertext gout881 = ctx.eval_lut(&gin881, and2);
    std::cerr << "\rLUT882   ";
    Ciphertext gin882 = 2 * gout841 + gout875;
    Ciphertext gout882 = ctx.eval_lut(&gin882, nand2);
    std::cerr << "\rLUT883   ";
    Ciphertext gin883 = 2 * gout728 + gout878;
    Ciphertext gout883 = ctx.eval_lut(&gin883, nand2);
    std::cerr << "\rLUT884   ";
    Ciphertext gin884 = 2 * gout873 + gout877;
    Ciphertext gout884 = ctx.eval_lut(&gin884, nand2);
    std::cerr << "\rLUT885   ";
    Ciphertext gin885 = 2 * gout878 + gout774;
    Ciphertext gout885 = ctx.eval_lut(&gin885, or2);
    std::cerr << "\rLUT886   ";
    Ciphertext gin886 = 2 * gout369 + gout880;
    Ciphertext gout886 = ctx.eval_lut(&gin886, nand2);
    std::cerr << "\rLUT887   ";
    Ciphertext gin887 = 2 * gout882 + gout847;
    Ciphertext gout887 = ctx.eval_lut(&gin887, xnor2);
    std::cerr << "\rLUT888   ";
    Ciphertext gin888 = 2 * gout875 + gout881;
    Ciphertext gout888 = ctx.eval_lut(&gin888, nand2);
    std::cerr << "\rLUT889   ";
    Ciphertext gin889 = 2 * gout882 + gout847;
    Ciphertext gout889 = ctx.eval_lut(&gin889, nand2);
    std::cerr << "\rLUT890   ";
    Ciphertext gin890 = 2 * gout884 + gout871;
    Ciphertext gout890 = ctx.eval_lut(&gin890, nand2);
    std::cerr << "\rLUT891   ";
    Ciphertext gin891 = 2 * gout883 + gout749;
    Ciphertext gout891 = ctx.eval_lut(&gin891, nand2);
    std::cerr << "\rLUT892   ";
    Ciphertext gin892 = 2 * gout883 + gout749;
    Ciphertext gout892 = ctx.eval_lut(&gin892, or2);
    std::cerr << "\rLUT893   ";
    Ciphertext gin893 = 2 * gout885 + gout785;
    Ciphertext gout893 = ctx.eval_lut(&gin893, nand2);
    std::cerr << "\rLUT894   ";
    Ciphertext gin894 = 2 * gout369 + gout888;
    Ciphertext gout894 = ctx.eval_lut(&gin894, and2);
    std::cerr << "\rLUT895   ";
    Ciphertext gin895 = 2 * gout846 + gout889;
    Ciphertext gout895 = ctx.eval_lut(&gin895, nand2);
    std::cerr << "\rLUT896   ";
    Ciphertext gin896 = 2 * gout893 + gout773;
    Ciphertext gout896 = ctx.eval_lut(&gin896, nand2);
    std::cerr << "\rLUT897   ";
    Ciphertext gin897 = 2 * gout893 + gout773;
    Ciphertext gout897 = ctx.eval_lut(&gin897, xnor2);
    std::cerr << "\rLUT898   ";
    Ciphertext gin898 = 2 * gout426 + gout892;
    Ciphertext gout898 = ctx.eval_lut(&gin898, and2);
    std::cerr << "\rIMUX899  ";
    Ciphertext gin899A = 2 * gout887 + gout356;
    Ciphertext gout899A = ctx.eval_lut(&gin899A, and2);
    Ciphertext gin899B = 2 * gout897 + (1 - gout356);
    Ciphertext gout899B = ctx.eval_lut(&gin899B, and2);
    Ciphertext gout899 = gout899A + gout899B;
    std::cerr << "\rLUT900   ";
    Ciphertext gin900 = 2 * gout895 + gout849;
    Ciphertext gout900 = ctx.eval_lut(&gin900, or2);
    std::cerr << "\rLUT901   ";
    Ciphertext gin901 = 2 * gout895 + gout849;
    Ciphertext gout901 = ctx.eval_lut(&gin901, nand2);
    std::cerr << "\rLUT902   ";
    Ciphertext gin902 = 2 * gout896 + gout816;
    Ciphertext gout902 = ctx.eval_lut(&gin902, or2);
    std::cerr << "\rLUT903   ";
    Ciphertext gin903 = 2 * gout775 + gout896;
    Ciphertext gout903 = ctx.eval_lut(&gin903, nand2);
    std::cerr << "\rLUT904   ";
    Ciphertext gin904 = 2 * gout891 + gout898;
    Ciphertext gout904 = ctx.eval_lut(&gin904, nand2);
    std::cerr << "\rLUT905   ";
    Ciphertext gin905 = 2 * gout369 + gout899;
    Ciphertext gout905 = ctx.eval_lut(&gin905, nand2);
    std::cerr << "\rLUT906   ";
    Ciphertext gin906 = 2 * gout904 + gout894;
    Ciphertext gout906 = ctx.eval_lut(&gin906, nand2);
    std::cerr << "\rLUT907   ";
    Ciphertext gin907 = 2 * gout356 + gout900;
    Ciphertext gout907 = ctx.eval_lut(&gin907, and2);
    std::cerr << "\rLUT908   ";
    Ciphertext gin908 = 2 * gout848 + gout901;
    Ciphertext gout908 = ctx.eval_lut(&gin908, nand2);
    std::cerr << "\rLUT909   ";
    Ciphertext gin909 = 2 * gout903 + gout796;
    Ciphertext gout909 = ctx.eval_lut(&gin909, nand2);
    std::cerr << "\rLUT910   ";
    Ciphertext gin910 = 2 * gout903 + gout796;
    Ciphertext gout910 = ctx.eval_lut(&gin910, or2);
    std::cerr << "\rLUT911   ";
    Ciphertext gin911 = 2 * gout902 + gout836;
    Ciphertext gout911 = ctx.eval_lut(&gin911, nand2);
    std::cerr << "\rLUT912   ";
    Ciphertext gin912 = 2 * gout901 + gout907;
    Ciphertext gout912 = ctx.eval_lut(&gin912, nand2);
    std::cerr << "\rLUT913   ";
    Ciphertext gin913 = 2 * gout908 + gout824;
    Ciphertext gout913 = ctx.eval_lut(&gin913, xnor2);
    std::cerr << "\rLUT914   ";
    Ciphertext gin914 = 2 * gout908 + gout824;
    Ciphertext gout914 = ctx.eval_lut(&gin914, nand2);
    std::cerr << "\rLUT915   ";
    Ciphertext gin915 = 2 * gout426 + gout910;
    Ciphertext gout915 = ctx.eval_lut(&gin915, and2);
    std::cerr << "\rLUT916   ";
    Ciphertext gin916 = 2 * gout911 + gout819;
    Ciphertext gout916 = ctx.eval_lut(&gin916, xnor2);
    std::cerr << "\rLUT917   ";
    Ciphertext gin917 = 2 * gout911 + gout819;
    Ciphertext gout917 = ctx.eval_lut(&gin917, nand2);
    std::cerr << "\rIMUX918  ";
    Ciphertext gin918A = 2 * gout913 + gout356;
    Ciphertext gout918A = ctx.eval_lut(&gin918A, and2);
    Ciphertext gin918B = 2 * gout916 + (1 - gout356);
    Ciphertext gout918B = ctx.eval_lut(&gin918B, and2);
    Ciphertext gout918 = gout918A + gout918B;
    std::cerr << "\rLUT919   ";
    Ciphertext gin919 = 2 * gout369 + gout912;
    Ciphertext gout919 = ctx.eval_lut(&gin919, and2);
    std::cerr << "\rLUT920   ";
    Ciphertext gin920 = 2 * gout830 + gout914;
    Ciphertext gout920 = ctx.eval_lut(&gin920, and2);
    std::cerr << "\rLUT921   ";
    Ciphertext gin921 = 2 * gout909 + gout915;
    Ciphertext gout921 = ctx.eval_lut(&gin921, nand2);
    std::cerr << "\rLUT922   ";
    Ciphertext gin922 = 2 * gout823 + gout917;
    Ciphertext gout922 = ctx.eval_lut(&gin922, and2);
    std::cerr << "\rLUT923   ";
    Ciphertext gin923 = 2 * gout369 + gout918;
    Ciphertext gout923 = ctx.eval_lut(&gin923, nand2);
    std::cerr << "\rLUT924   ";
    Ciphertext gin924 = 2 * gout921 + gout919;
    Ciphertext gout924 = ctx.eval_lut(&gin924, nand2);
    std::cerr << "\rLUT925   ";
    Ciphertext gin925 = 2 * gout920 + gout839;
    Ciphertext gout925 = ctx.eval_lut(&gin925, nand2);
    std::cerr << "\rLUT926   ";
    Ciphertext gin926 = 2 * gout920 + gout839;
    Ciphertext gout926 = ctx.eval_lut(&gin926, or2);
    std::cerr << "\rLUT927   ";
    Ciphertext gin927 = 2 * gout922 + gout821;
    Ciphertext gout927 = ctx.eval_lut(&gin927, or2);
    std::cerr << "\rLUT928   ";
    Ciphertext gin928 = 2 * gout922 + gout821;
    Ciphertext gout928 = ctx.eval_lut(&gin928, nand2);
    std::cerr << "\rLUT929   ";
    Ciphertext gin929 = 2 * gout356 + gout926;
    Ciphertext gout929 = ctx.eval_lut(&gin929, and2);
    std::cerr << "\rLUT930   ";
    Ciphertext gin930 = 2 * gout426 + gout927;
    Ciphertext gout930 = ctx.eval_lut(&gin930, and2);
    std::cerr << "\rLUT931   ";
    Ciphertext gin931 = 2 * gout925 + gout929;
    Ciphertext gout931 = ctx.eval_lut(&gin931, nand2);
    std::cerr << "\rLUT932   ";
    Ciphertext gin932 = 2 * gout928 + gout930;
    Ciphertext gout932 = ctx.eval_lut(&gin932, nand2);
    std::cerr << "\rLUT933   ";
    Ciphertext gin933 = 2 * gout369 + gout932;
    Ciphertext gout933 = ctx.eval_lut(&gin933, and2);
    std::cerr << "\rLUT934   ";
    Ciphertext gin934 = 2 * gout931 + gout933;
    Ciphertext gout934 = ctx.eval_lut(&gin934, nand2);

    std::cerr << "\r          \r";
    std::vector<long> test_out;
    test_out.push_back(ctx.decrypt(&gout498)); /* out0 */
    test_out.push_back(ctx.decrypt(&gout574)); /* out1 */
    test_out.push_back(ctx.decrypt(&gout683)); /* out2 */
    test_out.push_back(ctx.decrypt(&gout741)); /* out3 */
    test_out.push_back(ctx.decrypt(&gout792)); /* out4 */
    test_out.push_back(ctx.decrypt(&gout815)); /* out5 */
    test_out.push_back(ctx.decrypt(&gout850)); /* out6 */
    test_out.push_back(ctx.decrypt(&gout858)); /* out7 */
    test_out.push_back(ctx.decrypt(&gout870)); /* out8 */
    test_out.push_back(ctx.decrypt(&gout890)); /* out9 */
    test_out.push_back(ctx.decrypt(&gout886)); /* out10 */
    test_out.push_back(ctx.decrypt(&gout906)); /* out11 */
    test_out.push_back(ctx.decrypt(&gout905)); /* out12 */
    test_out.push_back(ctx.decrypt(&gout924)); /* out13 */
    test_out.push_back(ctx.decrypt(&gout923)); /* out14 */
    test_out.push_back(ctx.decrypt(&gout934)); /* out15 */
    return test_out;
}

static void
BM_calculator_boolean(benchmark::State& state)
{
    FHEContext ctx;
    ctx.generate_context(tfhe_11_NTT);
    ctx.set_default_message_encoding_type(partial_domain);
    ctx.set_default_plaintext_space(4);

    for (auto _ : state) {
        test_calculator_boolean(ctx);
    }
}

BENCHMARK(BM_calculator_boolean)->Unit(benchmark::kSecond);
BENCHMARK_MAIN();
