#include <benchmark/benchmark.h>
#include "fhe_context.h"
using namespace fhe_deck;


std::vector<long>
test_image_sharpen_boolean(FHEContext& ctx, uint64_t window = 0)
{
    Ciphertext ct_window8 = ctx.encrypt_public((window >> 0) & 1);
    Ciphertext ct_window9 = ctx.encrypt_public((window >> 1) & 1);
    Ciphertext ct_window10 = ctx.encrypt_public((window >> 2) & 1);
    Ciphertext ct_window11 = ctx.encrypt_public((window >> 3) & 1);
    Ciphertext ct_window12 = ctx.encrypt_public((window >> 4) & 1);
    Ciphertext ct_window13 = ctx.encrypt_public((window >> 5) & 1);
    Ciphertext ct_window14 = ctx.encrypt_public((window >> 6) & 1);
    Ciphertext ct_window15 = ctx.encrypt_public((window >> 7) & 1);
    Ciphertext ct_window24 = ctx.encrypt_public((window >> 8) & 1);
    Ciphertext ct_window25 = ctx.encrypt_public((window >> 9) & 1);
    Ciphertext ct_window26 = ctx.encrypt_public((window >> 10) & 1);
    Ciphertext ct_window27 = ctx.encrypt_public((window >> 11) & 1);
    Ciphertext ct_window28 = ctx.encrypt_public((window >> 12) & 1);
    Ciphertext ct_window29 = ctx.encrypt_public((window >> 13) & 1);
    Ciphertext ct_window30 = ctx.encrypt_public((window >> 14) & 1);
    Ciphertext ct_window31 = ctx.encrypt_public((window >> 15) & 1);
    Ciphertext ct_window32 = ctx.encrypt_public((window >> 16) & 1);
    Ciphertext ct_window33 = ctx.encrypt_public((window >> 17) & 1);
    Ciphertext ct_window34 = ctx.encrypt_public((window >> 18) & 1);
    Ciphertext ct_window35 = ctx.encrypt_public((window >> 19) & 1);
    Ciphertext ct_window36 = ctx.encrypt_public((window >> 20) & 1);
    Ciphertext ct_window37 = ctx.encrypt_public((window >> 21) & 1);
    Ciphertext ct_window38 = ctx.encrypt_public((window >> 22) & 1);
    Ciphertext ct_window39 = ctx.encrypt_public((window >> 23) & 1);
    Ciphertext ct_window40 = ctx.encrypt_public((window >> 24) & 1);
    Ciphertext ct_window41 = ctx.encrypt_public((window >> 25) & 1);
    Ciphertext ct_window42 = ctx.encrypt_public((window >> 26) & 1);
    Ciphertext ct_window43 = ctx.encrypt_public((window >> 27) & 1);
    Ciphertext ct_window44 = ctx.encrypt_public((window >> 28) & 1);
    Ciphertext ct_window45 = ctx.encrypt_public((window >> 29) & 1);
    Ciphertext ct_window46 = ctx.encrypt_public((window >> 30) & 1);
    Ciphertext ct_window47 = ctx.encrypt_public((window >> 31) & 1);
    Ciphertext ct_window56 = ctx.encrypt_public((window >> 32) & 1);
    Ciphertext ct_window57 = ctx.encrypt_public((window >> 33) & 1);
    Ciphertext ct_window58 = ctx.encrypt_public((window >> 34) & 1);
    Ciphertext ct_window59 = ctx.encrypt_public((window >> 35) & 1);
    Ciphertext ct_window60 = ctx.encrypt_public((window >> 36) & 1);
    Ciphertext ct_window61 = ctx.encrypt_public((window >> 37) & 1);
    Ciphertext ct_window62 = ctx.encrypt_public((window >> 38) & 1);
    Ciphertext ct_window63 = ctx.encrypt_public((window >> 39) & 1);

    auto fand2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 0;
            case 1:  return 0;
            case 2:  return 0;
            case 3:  return 1;
            default: assert(0);
        }
    };
    RotationPoly and2 = ctx.genrate_lut(fand2);

    auto fnand2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 1;
            case 1:  return 1;
            case 2:  return 1;
            case 3:  return 0;
            default: assert(0);
        }
    };
    RotationPoly nand2 = ctx.genrate_lut(fnand2);

    auto for2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 0;
            case 1:  return 1;
            case 2:  return 1;
            case 3:  return 1;
            default: assert(0);
        }
    };
    RotationPoly or2 = ctx.genrate_lut(for2);

    auto fnor2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 1;
            case 1:  return 0;
            case 2:  return 0;
            case 3:  return 0;
            default: assert(0);
        }
    };
    RotationPoly nor2 = ctx.genrate_lut(fnor2);

    auto fxor2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 0;
            case 1:  return 1;
            case 2:  return 1;
            case 3:  return 0;
            default: assert(0);
        }
    };
    RotationPoly xor2 = ctx.genrate_lut(fxor2);

    auto fxnor2 = [](long i, long t) -> long {
        switch (i) {
            case 0:  return 1;
            case 1:  return 0;
            case 2:  return 0;
            case 3:  return 1;
            default: assert(0);
        }
    };
    RotationPoly xnor2 = ctx.genrate_lut(fxnor2);

    std::cerr << "\rLUT0   ";
    Ciphertext gin0 = 2 * ct_window33 + ct_window35;
    Ciphertext gout0 = ctx.eval_lut(&gin0, nand2);
    std::cerr << "\rLUT1   ";
    Ciphertext gin1 = 2 * ct_window13 + ct_window29;
    Ciphertext gout1 = ctx.eval_lut(&gin1, xor2);
    std::cerr << "\rLUT2   ";
    Ciphertext gin2 = 2 * ct_window14 + ct_window30;
    Ciphertext gout2 = ctx.eval_lut(&gin2, nand2);
    std::cerr << "\rLUT3   ";
    Ciphertext gin3 = 2 * ct_window12 + ct_window28;
    Ciphertext gout3 = ctx.eval_lut(&gin3, nand2);
    std::cerr << "\rLUT4   ";
    Ciphertext gin4 = 2 * ct_window14 + ct_window30;
    Ciphertext gout4 = ctx.eval_lut(&gin4, xor2);
    std::cerr << "\rLUT5   ";
    Ciphertext gin5 = 2 * ct_window9 + ct_window25;
    Ciphertext gout5 = ctx.eval_lut(&gin5, xor2);
    std::cerr << "\rLUT6   ";
    Ciphertext gin6 = 2 * ct_window32 + ct_window34;
    Ciphertext gout6 = ctx.eval_lut(&gin6, and2);
    std::cerr << "\rLUT7   ";
    Ciphertext gin7 = 2 * ct_window9 + ct_window25;
    Ciphertext gout7 = ctx.eval_lut(&gin7, nand2);
    std::cerr << "\rLUT8   ";
    Ciphertext gin8 = 2 * ct_window10 + ct_window26;
    Ciphertext gout8 = ctx.eval_lut(&gin8, nand2);
    std::cerr << "\rLUT9   ";
    Ciphertext gin9 = 2 * ct_window11 + ct_window27;
    Ciphertext gout9 = ctx.eval_lut(&gin9, nand2);
    std::cerr << "\rLUT10   ";
    Ciphertext gin10 = 2 * ct_window36 + ct_window38;
    Ciphertext gout10 = ctx.eval_lut(&gin10, xor2);
    std::cerr << "\rLUT11   ";
    Ciphertext gin11 = 2 * ct_window8 + ct_window24;
    Ciphertext gout11 = ctx.eval_lut(&gin11, and2);
    std::cerr << "\rLUT12   ";
    Ciphertext gin12 = 2 * ct_window40 + ct_window56;
    Ciphertext gout12 = ctx.eval_lut(&gin12, xor2);
    std::cerr << "\rLUT13   ";
    Ciphertext gin13 = 2 * ct_window8 + ct_window24;
    Ciphertext gout13 = ctx.eval_lut(&gin13, xor2);
    std::cerr << "\rLUT14   ";
    Ciphertext gin14 = 2 * ct_window43 + ct_window59;
    Ciphertext gout14 = ctx.eval_lut(&gin14, xor2);
    std::cerr << "\rLUT15   ";
    Ciphertext gin15 = 2 * ct_window10 + ct_window26;
    Ciphertext gout15 = ctx.eval_lut(&gin15, xor2);
    std::cerr << "\rLUT16   ";
    Ciphertext gin16 = 2 * ct_window34 + ct_window36;
    Ciphertext gout16 = ctx.eval_lut(&gin16, xor2);
    std::cerr << "\rLUT17   ";
    Ciphertext gin17 = 2 * ct_window44 + ct_window60;
    Ciphertext gout17 = ctx.eval_lut(&gin17, xor2);
    std::cerr << "\rLUT18   ";
    Ciphertext gin18 = 2 * ct_window36 + ct_window38;
    Ciphertext gout18 = ctx.eval_lut(&gin18, nand2);
    std::cerr << "\rLUT19   ";
    Ciphertext gin19 = 2 * ct_window11 + ct_window27;
    Ciphertext gout19 = ctx.eval_lut(&gin19, xor2);
    std::cerr << "\rLUT20   ";
    Ciphertext gin20 = 2 * ct_window34 + ct_window36;
    Ciphertext gout20 = ctx.eval_lut(&gin20, and2);
    std::cerr << "\rLUT21   ";
    Ciphertext gin21 = 2 * ct_window47 + ct_window63;
    Ciphertext gout21 = ctx.eval_lut(&gin21, xnor2);
    std::cerr << "\rLUT22   ";
    Ciphertext gin22 = 2 * ct_window43 + ct_window59;
    Ciphertext gout22 = ctx.eval_lut(&gin22, nand2);
    std::cerr << "\rLUT23   ";
    Ciphertext gin23 = 2 * ct_window35 + ct_window37;
    Ciphertext gout23 = ctx.eval_lut(&gin23, and2);
    std::cerr << "\rINV24   ";
    Ciphertext gout24 = 1 - ct_window33;

    std::cerr << "\rINV25   ";
    Ciphertext gout25 = 1 - ct_window32;

    std::cerr << "\rLUT26   ";
    Ciphertext gin26 = 2 * ct_window46 + ct_window62;
    Ciphertext gout26 = ctx.eval_lut(&gin26, xor2);
    std::cerr << "\rLUT27   ";
    Ciphertext gin27 = 2 * ct_window15 + ct_window31;
    Ciphertext gout27 = ctx.eval_lut(&gin27, xor2);
    std::cerr << "\rLUT28   ";
    Ciphertext gin28 = 2 * ct_window45 + ct_window61;
    Ciphertext gout28 = ctx.eval_lut(&gin28, nand2);
    std::cerr << "\rLUT29   ";
    Ciphertext gin29 = 2 * ct_window12 + ct_window28;
    Ciphertext gout29 = ctx.eval_lut(&gin29, xor2);
    std::cerr << "\rLUT30   ";
    Ciphertext gin30 = 2 * ct_window41 + ct_window57;
    Ciphertext gout30 = ctx.eval_lut(&gin30, nand2);
    std::cerr << "\rLUT31   ";
    Ciphertext gin31 = 2 * ct_window46 + ct_window62;
    Ciphertext gout31 = ctx.eval_lut(&gin31, nand2);
    std::cerr << "\rLUT32   ";
    Ciphertext gin32 = 2 * ct_window37 + ct_window39;
    Ciphertext gout32 = ctx.eval_lut(&gin32, xnor2);
    std::cerr << "\rLUT33   ";
    Ciphertext gin33 = 2 * ct_window35 + ct_window37;
    Ciphertext gout33 = ctx.eval_lut(&gin33, xor2);
    std::cerr << "\rLUT34   ";
    Ciphertext gin34 = 2 * ct_window40 + ct_window56;
    Ciphertext gout34 = ctx.eval_lut(&gin34, and2);
    std::cerr << "\rLUT35   ";
    Ciphertext gin35 = 2 * ct_window42 + ct_window58;
    Ciphertext gout35 = ctx.eval_lut(&gin35, nand2);
    std::cerr << "\rLUT36   ";
    Ciphertext gin36 = 2 * ct_window42 + ct_window58;
    Ciphertext gout36 = ctx.eval_lut(&gin36, xor2);
    std::cerr << "\rLUT37   ";
    Ciphertext gin37 = 2 * ct_window44 + ct_window60;
    Ciphertext gout37 = ctx.eval_lut(&gin37, nand2);
    std::cerr << "\rLUT38   ";
    Ciphertext gin38 = 2 * ct_window33 + ct_window35;
    Ciphertext gout38 = ctx.eval_lut(&gin38, xor2);
    std::cerr << "\rLUT39   ";
    Ciphertext gin39 = 2 * ct_window41 + ct_window57;
    Ciphertext gout39 = ctx.eval_lut(&gin39, xor2);
    std::cerr << "\rLUT40   ";
    Ciphertext gin40 = 2 * ct_window13 + ct_window29;
    Ciphertext gout40 = ctx.eval_lut(&gin40, nand2);
    std::cerr << "\rLUT41   ";
    Ciphertext gin41 = 2 * ct_window45 + ct_window61;
    Ciphertext gout41 = ctx.eval_lut(&gin41, xor2);
    std::cerr << "\rLUT42   ";
    Ciphertext gin42 = 2 * ct_window32 + ct_window34;
    Ciphertext gout42 = ctx.eval_lut(&gin42, xor2);
    std::cerr << "\rLUT43   ";
    Ciphertext gin43 = 2 * gout12 + gout13;
    Ciphertext gout43 = ctx.eval_lut(&gin43, xor2);
    std::cerr << "\rLUT44   ";
    Ciphertext gin44 = 2 * gout11 + gout5;
    Ciphertext gout44 = ctx.eval_lut(&gin44, xor2);
    std::cerr << "\rLUT45   ";
    Ciphertext gin45 = 2 * gout20 + gout33;
    Ciphertext gout45 = ctx.eval_lut(&gin45, xor2);
    std::cerr << "\rLUT46   ";
    Ciphertext gin46 = 2 * gout34 + gout39;
    Ciphertext gout46 = ctx.eval_lut(&gin46, nand2);
    std::cerr << "\rLUT47   ";
    Ciphertext gin47 = 2 * gout11 + gout5;
    Ciphertext gout47 = ctx.eval_lut(&gin47, nand2);
    std::cerr << "\rLUT48   ";
    Ciphertext gin48 = 2 * gout23 + gout10;
    Ciphertext gout48 = ctx.eval_lut(&gin48, nand2);
    std::cerr << "\rLUT49   ";
    Ciphertext gin49 = 2 * gout23 + gout10;
    Ciphertext gout49 = ctx.eval_lut(&gin49, xor2);
    std::cerr << "\rLUT50   ";
    Ciphertext gin50 = 2 * gout20 + gout33;
    Ciphertext gout50 = ctx.eval_lut(&gin50, nand2);
    std::cerr << "\rLUT51   ";
    Ciphertext gin51 = 2 * gout12 + gout13;
    Ciphertext gout51 = ctx.eval_lut(&gin51, and2);
    std::cerr << "\rINV52   ";
    Ciphertext gout52 = 1 - gout19;

    std::cerr << "\rLUT53   ";
    Ciphertext gin53 = 2 * gout6 + gout38;
    Ciphertext gout53 = ctx.eval_lut(&gin53, xor2);
    std::cerr << "\rLUT54   ";
    Ciphertext gin54 = 2 * gout18 + gout32;
    Ciphertext gout54 = ctx.eval_lut(&gin54, xnor2);
    std::cerr << "\rINV55   ";
    Ciphertext gout55 = 1 - gout17;

    std::cerr << "\rLUT56   ";
    Ciphertext gin56 = 2 * gout34 + gout39;
    Ciphertext gout56 = ctx.eval_lut(&gin56, xnor2);
    std::cerr << "\rLUT57   ";
    Ciphertext gin57 = 2 * gout6 + gout38;
    Ciphertext gout57 = ctx.eval_lut(&gin57, nand2);
    std::cerr << "\rLUT58   ";
    Ciphertext gin58 = 2 * gout25 + gout43;
    Ciphertext gout58 = ctx.eval_lut(&gin58, nand2);
    std::cerr << "\rLUT59   ";
    Ciphertext gin59 = 2 * gout25 + gout43;
    Ciphertext gout59 = ctx.eval_lut(&gin59, xnor2);
    std::cerr << "\rLUT60   ";
    Ciphertext gin60 = 2 * (1 - gout56) + gout44;
    Ciphertext gout60 = ctx.eval_lut(&gin60, and2);
    std::cerr << "\rLUT61   ";
    Ciphertext gin61 = 2 * gout30 + gout46;
    Ciphertext gout61 = ctx.eval_lut(&gin61, nand2);
    std::cerr << "\rLUT62   ";
    Ciphertext gin62 = 2 * gout7 + gout47;
    Ciphertext gout62 = ctx.eval_lut(&gin62, nand2);
    std::cerr << "\rLUT63   ";
    Ciphertext gin63 = 2 * gout27 + gout54;
    Ciphertext gout63 = ctx.eval_lut(&gin63, xnor2);
    std::cerr << "\rLUT64   ";
    Ciphertext gin64 = 2 * gout56 + gout44;
    Ciphertext gout64 = ctx.eval_lut(&gin64, xnor2);
    std::cerr << "\rLUT65   ";
    Ciphertext gin65 = 2 * gout0 + gout57;
    Ciphertext gout65 = ctx.eval_lut(&gin65, nand2);
    std::cerr << "\rLUT66   ";
    Ciphertext gin66 = 2 * gout51 + gout64;
    Ciphertext gout66 = ctx.eval_lut(&gin66, xnor2);
    std::cerr << "\rLUT67   ";
    Ciphertext gin67 = 2 * gout61 + gout36;
    Ciphertext gout67 = ctx.eval_lut(&gin67, nand2);
    std::cerr << "\rLUT68   ";
    Ciphertext gin68 = 2 * gout61 + gout36;
    Ciphertext gout68 = ctx.eval_lut(&gin68, xnor2);
    std::cerr << "\rLUT69   ";
    Ciphertext gin69 = 2 * gout62 + gout15;
    Ciphertext gout69 = ctx.eval_lut(&gin69, xor2);
    std::cerr << "\rLUT70   ";
    Ciphertext gin70 = 2 * gout62 + gout15;
    Ciphertext gout70 = ctx.eval_lut(&gin70, nand2);
    std::cerr << "\rLUT71   ";
    Ciphertext gin71 = 2 * gout16 + gout65;
    Ciphertext gout71 = ctx.eval_lut(&gin71, xor2);
    std::cerr << "\rLUT72   ";
    Ciphertext gin72 = 2 * gout51 + gout64;
    Ciphertext gout72 = ctx.eval_lut(&gin72, and2);
    std::cerr << "\rLUT73   ";
    Ciphertext gin73 = 2 * gout16 + gout65;
    Ciphertext gout73 = ctx.eval_lut(&gin73, and2);
    std::cerr << "\rLUT74   ";
    Ciphertext gin74 = 2 * ct_window33 + gout66;
    Ciphertext gout74 = ctx.eval_lut(&gin74, nand2);
    std::cerr << "\rLUT75   ";
    Ciphertext gin75 = 2 * gout24 + gout66;
    Ciphertext gout75 = ctx.eval_lut(&gin75, xnor2);
    std::cerr << "\rLUT76   ";
    Ciphertext gin76 = 2 * gout35 + gout67;
    Ciphertext gout76 = ctx.eval_lut(&gin76, nand2);
    std::cerr << "\rLUT77   ";
    Ciphertext gin77 = 2 * gout8 + gout70;
    Ciphertext gout77 = ctx.eval_lut(&gin77, nand2);
    std::cerr << "\rLUT78   ";
    Ciphertext gin78 = 2 * (1 - gout68) + gout69;
    Ciphertext gout78 = ctx.eval_lut(&gin78, and2);
    std::cerr << "\rLUT79   ";
    Ciphertext gin79 = 2 * gout60 + gout72;
    Ciphertext gout79 = ctx.eval_lut(&gin79, or2);
    std::cerr << "\rLUT80   ";
    Ciphertext gin80 = 2 * gout68 + gout69;
    Ciphertext gout80 = ctx.eval_lut(&gin80, xnor2);
    std::cerr << "\rLUT81   ";
    Ciphertext gin81 = 2 * gout73 + gout45;
    Ciphertext gout81 = ctx.eval_lut(&gin81, xor2);
    std::cerr << "\rLUT82   ";
    Ciphertext gin82 = 2 * gout73 + gout45;
    Ciphertext gout82 = ctx.eval_lut(&gin82, nand2);
    std::cerr << "\rLUT83   ";
    Ciphertext gin83 = 2 * gout58 + gout75;
    Ciphertext gout83 = ctx.eval_lut(&gin83, xor2);
    std::cerr << "\rLUT84   ";
    Ciphertext gin84 = 2 * gout77 + gout52;
    Ciphertext gout84 = ctx.eval_lut(&gin84, xnor2);
    std::cerr << "\rLUT85   ";
    Ciphertext gin85 = 2 * gout58 + gout75;
    Ciphertext gout85 = ctx.eval_lut(&gin85, nand2);
    std::cerr << "\rLUT86   ";
    Ciphertext gin86 = 2 * gout79 + gout80;
    Ciphertext gout86 = ctx.eval_lut(&gin86, and2);
    std::cerr << "\rLUT87   ";
    Ciphertext gin87 = 2 * gout76 + gout14;
    Ciphertext gout87 = ctx.eval_lut(&gin87, nand2);
    std::cerr << "\rLUT88   ";
    Ciphertext gin88 = 2 * gout79 + gout80;
    Ciphertext gout88 = ctx.eval_lut(&gin88, xnor2);
    std::cerr << "\rLUT89   ";
    Ciphertext gin89 = 2 * gout77 + gout19;
    Ciphertext gout89 = ctx.eval_lut(&gin89, nand2);
    std::cerr << "\rLUT90   ";
    Ciphertext gin90 = 2 * gout76 + gout14;
    Ciphertext gout90 = ctx.eval_lut(&gin90, xnor2);
    std::cerr << "\rLUT91   ";
    Ciphertext gin91 = 2 * gout50 + gout82;
    Ciphertext gout91 = ctx.eval_lut(&gin91, nand2);
    std::cerr << "\rLUT92   ";
    Ciphertext gin92 = 2 * gout74 + gout85;
    Ciphertext gout92 = ctx.eval_lut(&gin92, nand2);
    std::cerr << "\rLUT93   ";
    Ciphertext gin93 = 2 * gout88 + gout42;
    Ciphertext gout93 = ctx.eval_lut(&gin93, xor2);
    std::cerr << "\rLUT94   ";
    Ciphertext gin94 = 2 * gout90 + (1 - gout84);
    Ciphertext gout94 = ctx.eval_lut(&gin94, or2);
    std::cerr << "\rLUT95   ";
    Ciphertext gin95 = 2 * gout9 + gout89;
    Ciphertext gout95 = ctx.eval_lut(&gin95, nand2);
    std::cerr << "\rLUT96   ";
    Ciphertext gin96 = 2 * gout88 + gout42;
    Ciphertext gout96 = ctx.eval_lut(&gin96, nand2);
    std::cerr << "\rLUT97   ";
    Ciphertext gin97 = 2 * (1 - gout90) + gout84;
    Ciphertext gout97 = ctx.eval_lut(&gin97, or2);
    std::cerr << "\rLUT98   ";
    Ciphertext gin98 = 2 * gout78 + gout86;
    Ciphertext gout98 = ctx.eval_lut(&gin98, or2);
    std::cerr << "\rLUT99   ";
    Ciphertext gin99 = 2 * gout90 + gout84;
    Ciphertext gout99 = ctx.eval_lut(&gin99, xnor2);
    std::cerr << "\rLUT100   ";
    Ciphertext gin100 = 2 * gout22 + gout87;
    Ciphertext gout100 = ctx.eval_lut(&gin100, nand2);
    std::cerr << "\rLUT101   ";
    Ciphertext gin101 = 2 * gout91 + gout49;
    Ciphertext gout101 = ctx.eval_lut(&gin101, nand2);
    std::cerr << "\rLUT102   ";
    Ciphertext gin102 = 2 * gout91 + gout49;
    Ciphertext gout102 = ctx.eval_lut(&gin102, xor2);
    std::cerr << "\rLUT103   ";
    Ciphertext gin103 = 2 * gout92 + gout93;
    Ciphertext gout103 = ctx.eval_lut(&gin103, xor2);
    std::cerr << "\rLUT104   ";
    Ciphertext gin104 = 2 * gout92 + gout93;
    Ciphertext gout104 = ctx.eval_lut(&gin104, nand2);
    std::cerr << "\rLUT105   ";
    Ciphertext gin105 = 2 * gout95 + gout29;
    Ciphertext gout105 = ctx.eval_lut(&gin105, nand2);
    std::cerr << "\rLUT106   ";
    Ciphertext gin106 = 2 * gout98 + gout99;
    Ciphertext gout106 = ctx.eval_lut(&gin106, xnor2);
    std::cerr << "\rLUT107   ";
    Ciphertext gin107 = 2 * gout95 + gout29;
    Ciphertext gout107 = ctx.eval_lut(&gin107, xor2);
    std::cerr << "\rLUT108   ";
    Ciphertext gin108 = 2 * gout48 + gout101;
    Ciphertext gout108 = ctx.eval_lut(&gin108, and2);
    std::cerr << "\rLUT109   ";
    Ciphertext gin109 = 2 * gout97 + gout98;
    Ciphertext gout109 = ctx.eval_lut(&gin109, nand2);
    std::cerr << "\rLUT110   ";
    Ciphertext gin110 = 2 * gout100 + gout17;
    Ciphertext gout110 = ctx.eval_lut(&gin110, nand2);
    std::cerr << "\rLUT111   ";
    Ciphertext gin111 = 2 * gout100 + gout55;
    Ciphertext gout111 = ctx.eval_lut(&gin111, xnor2);
    std::cerr << "\rLUT112   ";
    Ciphertext gin112 = 2 * gout96 + gout104;
    Ciphertext gout112 = ctx.eval_lut(&gin112, nand2);
    std::cerr << "\rLUT113   ";
    Ciphertext gin113 = 2 * gout3 + gout105;
    Ciphertext gout113 = ctx.eval_lut(&gin113, nand2);
    std::cerr << "\rLUT114   ";
    Ciphertext gin114 = 2 * gout53 + gout106;
    Ciphertext gout114 = ctx.eval_lut(&gin114, nand2);
    std::cerr << "\rLUT115   ";
    Ciphertext gin115 = 2 * gout111 + gout107;
    Ciphertext gout115 = ctx.eval_lut(&gin115, xor2);
    std::cerr << "\rLUT116   ";
    Ciphertext gin116 = 2 * gout53 + gout106;
    Ciphertext gout116 = ctx.eval_lut(&gin116, xor2);
    std::cerr << "\rLUT117   ";
    Ciphertext gin117 = 2 * gout94 + gout109;
    Ciphertext gout117 = ctx.eval_lut(&gin117, and2);
    std::cerr << "\rLUT118   ";
    Ciphertext gin118 = 2 * gout37 + gout110;
    Ciphertext gout118 = ctx.eval_lut(&gin118, nand2);
    std::cerr << "\rLUT119   ";
    Ciphertext gin119 = 2 * gout111 + gout107;
    Ciphertext gout119 = ctx.eval_lut(&gin119, nand2);
    std::cerr << "\rLUT120   ";
    Ciphertext gin120 = 2 * gout113 + gout1;
    Ciphertext gout120 = ctx.eval_lut(&gin120, nand2);
    std::cerr << "\rLUT121   ";
    Ciphertext gin121 = 2 * gout113 + gout1;
    Ciphertext gout121 = ctx.eval_lut(&gin121, xor2);
    std::cerr << "\rLUT122   ";
    Ciphertext gin122 = 2 * gout112 + gout116;
    Ciphertext gout122 = ctx.eval_lut(&gin122, xor2);
    std::cerr << "\rLUT123   ";
    Ciphertext gin123 = 2 * gout115 + gout117;
    Ciphertext gout123 = ctx.eval_lut(&gin123, xnor2);
    std::cerr << "\rLUT124   ";
    Ciphertext gin124 = 2 * gout118 + gout41;
    Ciphertext gout124 = ctx.eval_lut(&gin124, nand2);
    std::cerr << "\rLUT125   ";
    Ciphertext gin125 = 2 * gout112 + gout116;
    Ciphertext gout125 = ctx.eval_lut(&gin125, nand2);
    std::cerr << "\rLUT126   ";
    Ciphertext gin126 = 2 * gout118 + gout41;
    Ciphertext gout126 = ctx.eval_lut(&gin126, xnor2);
    std::cerr << "\rLUT127   ";
    Ciphertext gin127 = 2 * (1 - gout115) + gout117;
    Ciphertext gout127 = ctx.eval_lut(&gin127, or2);
    std::cerr << "\rLUT128   ";
    Ciphertext gin128 = 2 * gout40 + gout120;
    Ciphertext gout128 = ctx.eval_lut(&gin128, nand2);
    std::cerr << "\rLUT129   ";
    Ciphertext gin129 = 2 * gout122 + gout103;
    Ciphertext gout129 = ctx.eval_lut(&gin129, nand2);
    std::cerr << "\rLUT130   ";
    Ciphertext gin130 = 2 * gout71 + gout123;
    Ciphertext gout130 = ctx.eval_lut(&gin130, xnor2);
    std::cerr << "\rLUT131   ";
    Ciphertext gin131 = 2 * gout126 + (1 - gout121);
    Ciphertext gout131 = ctx.eval_lut(&gin131, or2);
    std::cerr << "\rLUT132   ";
    Ciphertext gin132 = 2 * (1 - gout123) + gout71;
    Ciphertext gout132 = ctx.eval_lut(&gin132, and2);
    std::cerr << "\rLUT133   ";
    Ciphertext gin133 = 2 * gout126 + gout121;
    Ciphertext gout133 = ctx.eval_lut(&gin133, xnor2);
    std::cerr << "\rLUT134   ";
    Ciphertext gin134 = 2 * gout114 + gout125;
    Ciphertext gout134 = ctx.eval_lut(&gin134, nand2);
    std::cerr << "\rLUT135   ";
    Ciphertext gin135 = 2 * gout28 + gout124;
    Ciphertext gout135 = ctx.eval_lut(&gin135, nand2);
    std::cerr << "\rLUT136   ";
    Ciphertext gin136 = 2 * gout119 + gout127;
    Ciphertext gout136 = ctx.eval_lut(&gin136, nand2);
    std::cerr << "\rLUT137   ";
    Ciphertext gin137 = 2 * gout128 + gout4;
    Ciphertext gout137 = ctx.eval_lut(&gin137, xor2);
    std::cerr << "\rLUT138   ";
    Ciphertext gin138 = 2 * gout128 + gout4;
    Ciphertext gout138 = ctx.eval_lut(&gin138, nand2);
    std::cerr << "\rLUT139   ";
    Ciphertext gin139 = 2 * gout130 + gout134;
    Ciphertext gout139 = ctx.eval_lut(&gin139, and2);
    std::cerr << "\rLUT140   ";
    Ciphertext gin140 = 2 * gout136 + gout133;
    Ciphertext gout140 = ctx.eval_lut(&gin140, nand2);
    std::cerr << "\rLUT141   ";
    Ciphertext gin141 = 2 * gout135 + gout26;
    Ciphertext gout141 = ctx.eval_lut(&gin141, xnor2);
    std::cerr << "\rLUT142   ";
    Ciphertext gin142 = 2 * gout136 + gout133;
    Ciphertext gout142 = ctx.eval_lut(&gin142, xnor2);
    std::cerr << "\rLUT143   ";
    Ciphertext gin143 = 2 * gout135 + gout26;
    Ciphertext gout143 = ctx.eval_lut(&gin143, nand2);
    std::cerr << "\rLUT144   ";
    Ciphertext gin144 = 2 * gout2 + gout138;
    Ciphertext gout144 = ctx.eval_lut(&gin144, nand2);
    std::cerr << "\rLUT145   ";
    Ciphertext gin145 = 2 * gout131 + gout140;
    Ciphertext gout145 = ctx.eval_lut(&gin145, nand2);
    std::cerr << "\rLUT146   ";
    Ciphertext gin146 = 2 * gout141 + gout137;
    Ciphertext gout146 = ctx.eval_lut(&gin146, xnor2);
    std::cerr << "\rLUT147   ";
    Ciphertext gin147 = 2 * gout141 + (1 - gout137);
    Ciphertext gout147 = ctx.eval_lut(&gin147, or2);
    std::cerr << "\rLUT148   ";
    Ciphertext gin148 = 2 * gout31 + gout143;
    Ciphertext gout148 = ctx.eval_lut(&gin148, nand2);
    std::cerr << "\rLUT149   ";
    Ciphertext gin149 = 2 * gout142 + gout81;
    Ciphertext gout149 = ctx.eval_lut(&gin149, xor2);
    std::cerr << "\rLUT150   ";
    Ciphertext gin150 = 2 * gout142 + gout81;
    Ciphertext gout150 = ctx.eval_lut(&gin150, nand2);
    std::cerr << "\rLUT151   ";
    Ciphertext gin151 = 2 * gout144 + gout63;
    Ciphertext gout151 = ctx.eval_lut(&gin151, xnor2);
    std::cerr << "\rLUT152   ";
    Ciphertext gin152 = 2 * gout145 + gout146;
    Ciphertext gout152 = ctx.eval_lut(&gin152, xnor2);
    std::cerr << "\rLUT153   ";
    Ciphertext gin153 = 2 * gout145 + gout146;
    Ciphertext gout153 = ctx.eval_lut(&gin153, nand2);
    std::cerr << "\rLUT154   ";
    Ciphertext gin154 = 2 * gout132 + gout149;
    Ciphertext gout154 = ctx.eval_lut(&gin154, nand2);
    std::cerr << "\rLUT155   ";
    Ciphertext gin155 = 2 * gout132 + gout149;
    Ciphertext gout155 = ctx.eval_lut(&gin155, xnor2);
    std::cerr << "\rLUT156   ";
    Ciphertext gin156 = 2 * gout148 + gout21;
    Ciphertext gout156 = ctx.eval_lut(&gin156, xnor2);
    std::cerr << "\rLUT157   ";
    Ciphertext gin157 = 2 * gout149 + gout139;
    Ciphertext gout157 = ctx.eval_lut(&gin157, nand2);
    std::cerr << "\rLUT158   ";
    Ciphertext gin158 = 2 * gout102 + gout152;
    Ciphertext gout158 = ctx.eval_lut(&gin158, xor2);
    std::cerr << "\rLUT159   ";
    Ciphertext gin159 = 2 * gout102 + gout152;
    Ciphertext gout159 = ctx.eval_lut(&gin159, nand2);
    std::cerr << "\rLUT160   ";
    Ciphertext gin160 = 2 * gout147 + gout153;
    Ciphertext gout160 = ctx.eval_lut(&gin160, and2);
    std::cerr << "\rLUT161   ";
    Ciphertext gin161 = 2 * (1 - gout130) + gout155;
    Ciphertext gout161 = ctx.eval_lut(&gin161, and2);
    std::cerr << "\rLUT162   ";
    Ciphertext gin162 = 2 * gout156 + gout151;
    Ciphertext gout162 = ctx.eval_lut(&gin162, xnor2);
    std::cerr << "\rLUT163   ";
    Ciphertext gin163 = 2 * gout150 + gout157;
    Ciphertext gout163 = ctx.eval_lut(&gin163, and2);
    std::cerr << "\rLUT164   ";
    Ciphertext gin164 = 2 * gout108 + gout160;
    Ciphertext gout164 = ctx.eval_lut(&gin164, xnor2);
    std::cerr << "\rLUT165   ";
    Ciphertext gin165 = 2 * gout164 + gout162;
    Ciphertext gout165 = ctx.eval_lut(&gin165, xnor2);
    std::cerr << "\rLUT166   ";
    Ciphertext gin166 = 2 * (1 - gout134) + gout161;
    Ciphertext gout166 = ctx.eval_lut(&gin166, and2);
    std::cerr << "\rLUT167   ";
    Ciphertext gin167 = 2 * gout154 + gout163;
    Ciphertext gout167 = ctx.eval_lut(&gin167, nand2);
    std::cerr << "\rLUT168   ";
    Ciphertext gin168 = 2 * (1 - gout157) + gout166;
    Ciphertext gout168 = ctx.eval_lut(&gin168, or2);
    std::cerr << "\rLUT169   ";
    Ciphertext gin169 = 2 * gout167 + gout158;
    Ciphertext gout169 = ctx.eval_lut(&gin169, nand2);
    std::cerr << "\rLUT170   ";
    Ciphertext gin170 = 2 * gout167 + gout158;
    Ciphertext gout170 = ctx.eval_lut(&gin170, xnor2);
    std::cerr << "\rLUT171   ";
    Ciphertext gin171 = 2 * gout170 + gout168;
    Ciphertext gout171 = ctx.eval_lut(&gin171, and2);
    std::cerr << "\rLUT172   ";
    Ciphertext gin172 = 2 * gout168 + gout129;
    Ciphertext gout172 = ctx.eval_lut(&gin172, and2);
    std::cerr << "\rLUT173   ";
    Ciphertext gin173 = 2 * gout159 + gout169;
    Ciphertext gout173 = ctx.eval_lut(&gin173, and2);
    std::cerr << "\rLUT174   ";
    Ciphertext gin174 = 2 * gout173 + gout165;
    Ciphertext gout174 = ctx.eval_lut(&gin174, xnor2);
    std::cerr << "\rLUT175   ";
    Ciphertext gin175 = 2 * gout170 + gout172;
    Ciphertext gout175 = ctx.eval_lut(&gin175, or2);
    std::cerr << "\rLUT176   ";
    Ciphertext gin176 = 2 * gout174 + gout171;
    Ciphertext gout176 = ctx.eval_lut(&gin176, nand2);
    std::cerr << "\rLUT177   ";
    Ciphertext gin177 = 2 * gout174 + gout171;
    Ciphertext gout177 = ctx.eval_lut(&gin177, and2);
    std::cerr << "\rLUT178   ";
    Ciphertext gin178 = 2 * gout174 + gout175;
    Ciphertext gout178 = ctx.eval_lut(&gin178, and2);
    std::cerr << "\rIMUX179  ";
    Ciphertext gin179A = 2 * gout178 + gout176;
    Ciphertext gout179A = ctx.eval_lut(&gin179A, and2);
    Ciphertext gin179B = 2 * gout83 + (1 - gout176);
    Ciphertext gout179B = ctx.eval_lut(&gin179B, and2);
    Ciphertext gout179 = gout179A + gout179B;
    std::cerr << "\rIMUX180  ";
    Ciphertext gin180A = 2 * gout178 + gout176;
    Ciphertext gout180A = ctx.eval_lut(&gin180A, and2);
    Ciphertext gin180B = 2 * gout59 + (1 - gout176);
    Ciphertext gout180B = ctx.eval_lut(&gin180B, and2);
    Ciphertext gout180 = gout180A + gout180B;
    std::cerr << "\rIMUX181  ";
    Ciphertext gin181A = 2 * gout122 + gout177;
    Ciphertext gout181A = ctx.eval_lut(&gin181A, and2);
    Ciphertext gin181B = 2 * gout178 + (1 - gout177);
    Ciphertext gout181B = ctx.eval_lut(&gin181B, and2);
    Ciphertext gout181 = gout181A + gout181B;
    std::cerr << "\rIMUX182  ";
    Ciphertext gin182A = 2 * gout103 + gout177;
    Ciphertext gout182A = ctx.eval_lut(&gin182A, and2);
    Ciphertext gin182B = 2 * gout178 + (1 - gout177);
    Ciphertext gout182B = ctx.eval_lut(&gin182B, and2);
    Ciphertext gout182 = gout182A + gout182B;

    std::cerr << "\r          \r";
    std::vector<long> test_out;
    test_out.push_back(ctx.decrypt(&gout180)); /* out0 */
    test_out.push_back(ctx.decrypt(&gout179)); /* out1 */
    test_out.push_back(ctx.decrypt(&gout182)); /* out2 */
    test_out.push_back(ctx.decrypt(&gout181)); /* out3 */
    return test_out;
}

static void
BM_image_sharpen_boolean(benchmark::State& state)
{
    FHEContext ctx;
    ctx.generate_context(tfhe_11_NTT);
    ctx.set_default_message_encoding_type(partial_domain);
    ctx.set_default_plaintext_space(4);

    for (auto _ : state) {
        test_image_sharpen_boolean(ctx);
    }
}

BENCHMARK(BM_image_sharpen_boolean)->Unit(benchmark::kSecond);
BENCHMARK_MAIN();
